package com.connor.renben.process.plm.util;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.EventObject;

import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.EventListenerList;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellEditor;

public class CheckBoxCellEditor extends JCheckBox implements TableCellEditor {

	protected EventListenerList listenerList = new EventListenerList();
	protected ChangeEvent changeEvent = new ChangeEvent(this);
	private JTableHeader tableHeader;
	private DefaultTableModel tableModel;

	public CheckBoxCellEditor(final CTable table) {
		super();
		this.tableModel = (DefaultTableModel) table.getModel();
		this.tableHeader = table.getTableHeader();
		this.setName("4");
		// selectBox = new JCheckBox(tableModel.getColumnName(1));
		this.setSelected(false);
		tableHeader.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() > 0) {
					// ѡ
					int selectColumn = tableHeader.columnAtPoint(e.getPoint());
					if (table.getColumnName(selectColumn).equals("4")) {
						boolean value = !CheckBoxCellEditor.this.isSelected();
						CheckBoxCellEditor.this.setSelected(value);
						table.selectAllOrNull(value ? "1" : "0");
						tableHeader.repaint();
					}
				}
			}
		});
		addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				fireEditingStopped();
			}
		});
	}

	public void addCellEditorListener(CellEditorListener listener) {
		listenerList.add(CellEditorListener.class, listener);
	}

	public void removeCellEditorListener(CellEditorListener listener) {
		listenerList.remove(CellEditorListener.class, listener);
	}

	protected void fireEditingStopped() {
		System.out.println(this.isSelected() ? "1" : "0");
		CellEditorListener listener;
		Object[] listeners = listenerList.getListenerList();
		for (int i = 0; i < listeners.length; i++) {
			if (listeners[i] == CellEditorListener.class) {
				listener = (CellEditorListener) listeners[i + 1];
				listener.editingStopped(changeEvent);
			}
		}
	}

	protected void fireEditingCanceled() {
		CellEditorListener listener;
		Object[] listeners = listenerList.getListenerList();
		for (int i = 0; i < listeners.length; i++) {
			if (listeners[i] == CellEditorListener.class) {
				listener = (CellEditorListener) listeners[i + 1];
				listener.editingCanceled(changeEvent);
			}
		}
	}

	public void cancelCellEditing() {
		fireEditingCanceled();
	}

	public boolean stopCellEditing() {
		// this.addItem(this.getSelectedItem());
		fireEditingStopped();
		return true;
	}

	public boolean isCellEditable(EventObject event) {
		return true;
	}

	public boolean shouldSelectCell(EventObject event) {
		return true;
	}

	public Object getCellEditorValue() {
		return this.isSelected() ? "1" : "0";
	}

	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {

//		String valueStr = (String) value;
//        JLabel label = new JLabel(valueStr);
//        label.setHorizontalAlignment(SwingConstants.CENTER); // ͷǩ
		this.setHorizontalAlignment(SwingConstants.CENTER);// ͷǩ
		this.setBorderPainted(true);
		this.setSelected(value.toString().equals("1"));
		return this;
	}
}