package com.connor.zf.controlplan;

import java.awt.Dimension;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.event.TableModelEvent;
import javax.swing.table.DefaultTableModel;

public class CTMap extends DefaultTableModel implements CellSpan {
	protected int rowSize;
	protected int columnSize;
	protected int[][][] span; // CellSpan
	protected boolean isEditable = true;
	private List<Integer> processRowList;
	private Map<Integer,List<String>> labelRows;//ע
	private int row = -1;
	private int column = -1;

	public int getRow() {
		return row;
	}

	public void setRow(int row) {
		this.row = row;
	}

	public int getColumn() {
		return column;
	}

	public void setColumn(int column) {
		this.column = column;
	}

	public void setEditable(boolean isEditable) {
		this.isEditable = isEditable;
	}

	public List<Integer> getProcessRowList() {
		return processRowList;
	}

	public void setProcessRowList(List<Integer> processRowList) {
		this.processRowList = processRowList;
	}
	
	public Map<Integer,List<String>> getLabelRows() {
		return labelRows;
	}

	public void setLabelRows(Map<Integer,List<String>> labelRows) {
		this.labelRows = labelRows;
	}

	@Override
	//õԪ񲻿ɱ༭
	public boolean isCellEditable(int arg0, int arg1) {
		// TODO Auto-generated method stub
		if (processRowList != null && processRowList.size() > 0) {
			//вܱ༭
			if (!processRowList.contains(arg0) ) {//|| arg1 == 1 || arg1 == 2
				return false;
			} else {
				if (arg0 == row && arg1 == column) {
					return this.isEditable;
				} else {
					return false;
				}
			}
		} else {
			return false;
		}
	}

	@Override
	public void removeRow(int row) {
		// ޸ĵ-1
		if (processRowList != null && processRowList.size() > 0) {
			for (int i = processRowList.size() - 1; i >= 0; i--) {
				if (processRowList.get(i) != null
						&& processRowList.get(i) == row) {
					processRowList.remove(i);
				} else if (processRowList.get(i) != null
						&& processRowList.get(i) > row) {
					processRowList.set(i, processRowList.get(i) - 1);
				}
			}
		}
		//עм1
		if (labelRows != null && labelRows.size() > 0 && labelRows.keySet().contains(row)) {
			List<String> labelRowList = labelRows.get(row);
			for (int i = labelRowList.size() - 1; i >= 0; i--) {
				Integer listRow = (Integer.parseInt(labelRowList.get(i)));
				if (labelRowList.get(i) != null
						&& listRow == row) {
					labelRowList.remove(i);
				} else if (labelRowList.get(i) != null
						&& listRow > row) {
					labelRowList.set(i, ((Integer)(listRow-1)).toString());
				}
			}
		}
		super.removeRow(row);
	}

	@Override
	public int[] getSpan(int row, int column) {
		// TODO Auto-generated method stub
		if (isOutOfBounds(row, column)) {
			int[] ret_code = { 1, 1 };
			return ret_code;
		}
		return span[row][column];
	}

	@Override
	public void setSpan(int[] span, int row, int column) {
		// TODO Auto-generated method stub
		if (isOutOfBounds(row, column))
			return;
		this.span[row][column] = span;
	}

	@Override
	public boolean isVisible(int row, int column) {
		// TODO Auto-generated method stub
		if (isOutOfBounds(row, column))
			return false;
		if ((span[row][column][CellSpan.COLUMN] < 1)
				|| (span[row][column][CellSpan.ROW] < 1))
			return false;
		return true;
	}

	@Override
	public void combine(int[] rows, int[] columns) {
		// TODO Auto-generated method stub

		int rowSpan = rows.length;
		int columnSpan = columns.length;
		int startRow = rows[0];
		int startColumn = columns[0];
		for (int i = 0; i < rowSpan; i++) {
			for (int j = 0; j < columnSpan; j++) {
				if ((span[startRow + i][startColumn + j][CellSpan.COLUMN] != 1)
						|| (span[startRow + i][startColumn + j][CellSpan.ROW] != 1)) {
					// System.out.println("can't combine");
					return;
				}
			}
		}
		for (int i = 0, ii = 0; i < rowSpan; i++, ii--) {
			for (int j = 0, jj = 0; j < columnSpan; j++, jj--) {
				span[startRow + i][startColumn + j][CellSpan.COLUMN] = jj;
				span[startRow + i][startColumn + j][CellSpan.ROW] = ii;
				// System.out.println("r " +ii +" c " +jj);
			}
		}
		span[startRow][startColumn][CellSpan.COLUMN] = columnSpan;
		span[startRow][startColumn][CellSpan.ROW] = rowSpan;
	}

	// @Override
	// public boolean isCellEditable(int arg0, int arg1) {
	// if(arg1 == 1 )
	// {
	// return false;
	// }
	// return super.isCellEditable(arg0, arg1);
	// }
	//
	public void setSize(Dimension size) {
		columnSize = size.width;
		rowSize = size.height;
		span = new int[rowSize][columnSize][2]; // 2: COLUMN,ROW
		initValue();
	}

	protected boolean isOutOfBounds(int row, int column) {
		if ((row < 0) || (rowSize <= row) || (column < 0)
				|| (columnSize <= column)) {
			return true;
		}
		return false;
	}

	public void addRow() {

		Vector newData = new Vector(getColumnCount());
		dataVector.add(newData);

		//
		newRowsAdded(new TableModelEvent(this, getRowCount() - 1,
				getRowCount() - 1, TableModelEvent.ALL_COLUMNS,
				TableModelEvent.INSERT));
		int[][][] oldSpan = span;
		int numRows = oldSpan.length;
		int numColumns = oldSpan[0].length;
		span = new int[numRows + 1][numColumns][2];
		System.arraycopy(oldSpan, 0, span, 0, numRows);
		for (int i = 0; i < numColumns; i++) {
			span[numRows][i][CellSpan.COLUMN] = 1;
			span[numRows][i][CellSpan.ROW] = 1;
		}
		rowSize = span.length;
	}

	public void addColumn(Object columnName) {

		int[][][] oldSpan = span;
		int numRows = oldSpan.length;
		int numColumns = oldSpan[0].length;
		span = new int[numRows][numColumns + 1][2];
		for (int i = 0; i < span.length; i++) {
			for (int j = 0; j < span[0].length; j++) {
				span[i][j][CellSpan.COLUMN] = 1;
				span[i][j][CellSpan.ROW] = 1;
			}
		}

		columnSize = span[0].length;
		addColumn(columnName, (Vector) null);
	}

	public void insertRow(int row) {
		Vector rowData = new Vector(getColumnCount());
		int index = 0;

		dataVector.insertElementAt(rowData, row);
		System.out.println("size:" + dataVector.size());

		//
		newRowsAdded(new TableModelEvent(this, row, row,
				TableModelEvent.ALL_COLUMNS, TableModelEvent.INSERT));
		int[][][] newSpan = new int[span.length + 1][span[0].length][2];

		int numRows = span.length;
		int numColumns = span[0].length;
		for (int i = 0; i < newSpan.length; i++) {
			if (i < row) {
				for (int j = 0; j < numColumns; j++) {
					newSpan[i][j][0] = span[i][j][0];
					newSpan[i][j][1] = span[i][j][1];
					// newSpan[i][j][0] = 1;
					// newSpan[i][j][1] = 1;
				}
			} else if (i == row) {
				for (int j = 0; j < numColumns; j++) {
					newSpan[i][j][0] = 1;
					newSpan[i][j][1] = 1;
				}
			} else {
				for (int j = 0; j < numColumns; j++) {
					newSpan[i][j][0] = span[i - 1][j][0];
					newSpan[i][j][1] = span[i - 1][j][1];
					// newSpan[i][j][0] = 1;
					// newSpan[i][j][1] = 1;
				}
			}
		}
		span = newSpan;
		rowSize = span.length;// ޸ĵ+1
		if (processRowList != null && processRowList.size() > 0) {

			for (int i = processRowList.size() - 1; i >= 0; i--) {
				if (!processRowList.contains(row)
						&& processRowList.get(i) != null
						&& processRowList.get(i) == row - 1) {
					index = i + 1;
					processRowList.add(i + 1, row);
				} else if (processRowList.get(i) != null
						&& processRowList.get(i) == row) {
					index = i + 1;
					processRowList.add(i + 1, row + 1);
				} else if (processRowList.get(i) != null && i > index
						&& processRowList.get(i) >= row) {
					processRowList.set(i, processRowList.get(i) + 1);
				}
			}
		}
		//ע+1
		if (labelRows != null && labelRows.size() > 0 && labelRows.keySet().contains(row)) {
			List<String> labelRowList = labelRows.get(row);
			for (int i = labelRowList.size() - 1; i >= 0; i--) {
				Integer listRow = (Integer.parseInt(labelRowList.get(i)));
				if (labelRowList.get(i) != null && i > index
						&& listRow >= row) {
					labelRowList.set(i, ((Integer)(listRow + 1)).toString());
				}
			}
		}

	}

	public CTMap(int numRows, int numColumns) {
		Vector names = new Vector(numColumns);
		names.setSize(numColumns);
		setColumnIdentifiers(names);
		dataVector = new Vector();
		setNumRows(numRows);
		setSize(new Dimension(numColumns, numRows));
	}

	protected void initValue() {
		System.out.println(span.length);
		for (int i = 0; i < span.length; i++) {
			for (int j = 0; j < span[i].length; j++) {
				span[i][j][CellSpan.COLUMN] = 1;
				span[i][j][CellSpan.ROW] = 1;
			}
		}
	}

	public void split(int row, int column) {
		if (isOutOfBounds(row, column))
			return;
		int columnSpan = span[row][column][CellSpan.COLUMN];
		int rowSpan = span[row][column][CellSpan.ROW];
		for (int i = 0; i < rowSpan; i++) {
			for (int j = 0; j < columnSpan; j++) {
				span[row + i][column + j][CellSpan.COLUMN] = 1;
				span[row + i][column + j][CellSpan.ROW] = 1;
			}
		}
	}

	public void removeCol() {

		columnIdentifiers.removeElementAt(columnIdentifiers.size() - 1);
		dataVector.setSize(getRowCount());

		for (int i = 0; i < getRowCount() - 1; i++) {

			((Vector) dataVector.elementAt(i)).setSize(getColumnCount());
		}
		fireTableStructureChanged();
	}
}
