package com.connor.zf.controlplan;

import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentGroup;
import com.teamcenter.rac.kernel.TCComponentGroupType;
import com.teamcenter.rac.kernel.TCComponentRole;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class TMom004LibraryTree {
	public void getLibrary(DefaultMutableTreeNode node, TCComponent comp,
			TCComponent parent) {
		try {
			if (comp instanceof TCComponentGroup) {
				TCComponent[] comps = ((TCComponentGroup) comp)
						.getRolesAndGroups();
				for (int i = 0; i < comps.length; i++) {
					TMomUserBean bean = new TMomUserBean(comps[i], comp);
					DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(
							bean);
					node.add(node1);
					getLibrary(node1, comps[i], comp);
				}
			} else if (comp instanceof TCComponentRole) {
				TCComponent[] comps = ((TCComponentRole) comp)
						.getUsers((TCComponentGroup) parent);
				for (int i = 0; i < comps.length; i++) {
					TMomUserBean bean = new TMomUserBean(comps[i], comp);
					DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(
							bean);
					node.add(node1);
				}
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}
	}

	public JTree getTcOrgTree(TCSession session, String goupFullName) {
		JTree tree = new JTree();

		try {
			TCComponentGroupType type = ((TCComponentGroupType) session
					.getTypeComponent("Group"));
			TCComponentGroup group = type.find("NBTM");
			TMomUserBean bean = new TMomUserBean(group, null);
			DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(bean);
			getLibrary(node1, group, null);
			tree = new JTree(node1);
			tree.setRowHeight(20);
			DefaultTreeCellRenderer cellRenderer = (DefaultTreeCellRenderer) tree
					.getCellRenderer();
			cellRenderer.setLeafIcon(new ImageIcon("icons\\person_16.png"));
			cellRenderer.setOpenIcon(new ImageIcon("icons\\role_16.png"));
			cellRenderer.setClosedIcon(new ImageIcon("icons\\group_16.png"));

		} catch (TCException e) {
			// TODO Auto-generated catch block
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		}

		return tree;
	}

}
