package com.connor.zf.controlplan;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.TimeUnit;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;
import javax.swing.plaf.metal.MetalProgressBarUI;

import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class TMom004SetControlPlanOperation extends AbstractAIFOperation {
	private TCProperty[] properties;
	private InterfaceAIFComponent comp;
	private List<List<String>> dataValueList;
	private TCSession session;
//	private TCComponent form;
	private TCComponent meprocess;
	private List<String> deleteRows;
	private List<String> plmeidList;
	private boolean isOwning;
	private boolean isAutoSave;
	private boolean isNotStandard;
	private String UID;
	private List<String> HeadList = new ArrayList<String>();
	private Map<String,String> meopNameToID  = new HashMap<String,String>();//ID
	public TMom004SetControlPlanOperation( TCComponent meprocess, TCSession session,
			TCProperty[] properties, List<String> HeadList, List<List<String>> dataValueList,
			List<String> deleteRows, List<String> plmeidList, boolean isOwning, boolean isAutoSave,
			InterfaceAIFComponent comp,String UID,Map<String,String> meopNameToID) {
		this.meprocess = meprocess;
		this.session = session;
		this.properties = properties;
		this.dataValueList = dataValueList;
		this.deleteRows = deleteRows;
		this.plmeidList = plmeidList;
		this.HeadList = HeadList;
		this.meopNameToID=meopNameToID;

		this.isOwning = isOwning;
		this.isAutoSave = isAutoSave;
		this.comp=comp;
		this.UID=UID;
	}

	@Override
	public void executeOperation() throws Exception {
		//+++ӽ
		JFrame frame = new JFrame("ڱ...");
		//frame.setUndecorated(true); // ûб
		 frame.setSize(300, 70);
         frame.setLocationRelativeTo(null);
         frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
         frame.setLayout(new BorderLayout());
         JProgressBar progressBar = new JProgressBar();
         progressBar.setOrientation(JProgressBar.HORIZONTAL);
         progressBar.setSize(300, 50);
         progressBar.setMinimum(0);
         progressBar.setMaximum(100);
         progressBar.setBorderPainted(true);
         progressBar.setUI(new MetalProgressBarUI());
         progressBar.setBackground(Color.white);
         progressBar.setForeground(Color.green);
         progressBar.setStringPainted(true);
         frame.setAlwaysOnTop(true);
         frame.add(progressBar);
         frame.setVisible(true);
		//+++
		ResultSet rs = null;
		InputStream input = null;
		try {

		
			progressBar.setValue(1);//++++
			
			// ȡSQL
			input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);
			
			
			//ȡIDƶӦID
			if(meopNameToID.size()==0) {
				SqlUtilT.getTCConnection();
				ResultSet rsData = null;
				String sql13 = String.format(pro.getProperty("RB3_meopNameToID"), comp.getUid());
				rsData = SqlUtilT.read(sql13);
				while (rsData.next()) {
					meopNameToID.put(rsData.getString("GCMC"), rsData.getString("PROCESSID"));
				}
				SqlUtilT.free(rsData);
			}
			

			//+++±ͷ
			String headDataupdateSQL = String.format(pro.getProperty("CONTROLPLANHEADUPDATE"),HeadList.get(0),HeadList.get(1));
			System.out.println("+"+pro.getProperty("CONTROLPLANHEADUPDATE"));
			SqlUtilT.getTCConnection();
			SqlUtilT.update(new String[] {HeadList.get(2),HeadList.get(3),HeadList.get(4),HeadList.get(5),HeadList.get(6),HeadList.get(7),
					HeadList.get(8),HeadList.get(9),HeadList.get(10),HeadList.get(11),HeadList.get(12),HeadList.get(13),HeadList.get(14),
					HeadList.get(15)},
					headDataupdateSQL);
			
			//+++
			
			
			
			
			// ѯźID
			//String selectSQL = String.format(pro.getProperty("CONTROLPLANOPERATIONSELECT"), meprocess.getUid());
			// ȡݿ
			SqlUtilT.getTCConnection();
			//rs = SqlUtilT.read(selectSQL);
			//Map<String, String> itemIdMap = new HashMap<String, String>();
			//while (rs.next()) {
			//	itemIdMap.put(rs.getString("zf6_gybh"), rs.getString("ZF6_MEOPID"));
			//}
			//SqlUtilT.freeAll();
			// ɾ
			int Speed=1;
			int num=deleteRows.size()/9;
			for (int i = 0; i < deleteRows.size(); i++) {
				// ȡݿ
				String deleteSQL = String.format(pro.getProperty("CONTROLPLANDELETE"), deleteRows.get(i));
				SqlUtilT.getTCConnection();
				SqlUtilT.delete(deleteSQL);
				if(i==num*Speed) {
					Speed++;
					progressBar.setValue(Speed);//++++
				}
				//SqlUtilT.freeAll();
			}
			progressBar.setValue(10);//++++
			Speed=10;
			// ȡݿ
			SqlUtilT.getTCConnection();
			// ݿд
			isNotStandard = false;
			List<String> arr_GYBH = new ArrayList<String>();
			List<String> arr_CPGC = new ArrayList<String>();
			int num2=dataValueList.size()/90;
			for (int i = 0; i < dataValueList.size(); i++) {
				List<String> rowList = dataValueList.get(i);
//				//ݵд
//				if (rowList.get(2) == null || rowList.get(2).trim().equals("") || rowList.get(2).trim() == null) {
//					if (arr_GYBH.indexOf(rowList.get(1)) < 0)
//						arr_GYBH.add(rowList.get(1));
//					isNotStandard = true;
//				}
//				if (rowList.get(11) == null || rowList.get(11).trim().equals("") || rowList.get(11).trim() == null) {
//					if (arr_CPGC.indexOf(rowList.get(1)) < 0)
//						arr_CPGC.add(rowList.get(1));
//					isNotStandard = true;
//				}

				if (rowList.get(0) != null && !rowList.get(0).equals("") && plmeidList.contains(rowList.get(0))) {
					// ȡݿ
					String updateSQL = String.format(pro.getProperty("CONTROLPLANUPDATE"), rowList.get(0),UID);
					SqlUtilT.getTCConnection();
					SqlUtilT.update(new String[] { rowList.get(1), rowList.get(2), rowList.get(3), rowList.get(4),
							rowList.get(5), rowList.get(6), rowList.get(7), rowList.get(8), rowList.get(9),
							rowList.get(10), rowList.get(11), rowList.get(12),rowList.get(13), rowList.get(14),rowList.get(15),
							rowList.get(16), rowList.get(17),rowList.get(18), rowList.get(19)},
							updateSQL);
				} else if(rowList.get(0) != null && !rowList.get(0).equals("") ){
					String insertSQL = pro.getProperty("INSERTSQL");
					SqlUtilT.getTCConnection();
					SqlUtilT.write2(new String[] { rowList.get(0), meprocess.getUid(), meopNameToID.get(rowList.get(2)),UID,
							rowList.get(1), rowList.get(2), rowList.get(3), rowList.get(4),rowList.get(5),rowList.get(6), 
							rowList.get(7), rowList.get(8), rowList.get(9), rowList.get(10),rowList.get(11),rowList.get(12), 
							rowList.get(13), rowList.get(14), rowList.get(15), rowList.get(16),rowList.get(17),rowList.get(18), 
							rowList.get(19)}, insertSQL);
				}
				if(i==num2*(Speed-9)) {
					Speed++;
					progressBar.setValue(Speed);//++++
				}
			}
			progressBar.setValue(100);
			frame.setTitle("");
			frame.dispose();
			SqlUtilT.connection.commit();
			input.close();
//			if (isNotStandard && !isAutoSave) {
//				MessageBox.post(
//						"ɹ⵽Ƽƻд淶ܵҵָ鱨쳣ģ\nʾ"
//								+ (arr_GYBH.size() != 0 ? "\nձ" + arr_GYBH.toString() + "дĿδд" : "")
//								+ (arr_CPGC.size() != 0 ? "\nձ" + arr_CPGC.toString() + "дĿδдҪ" : ""),
//						"ɹ", MessageBox.WARNING);
//			}
			// MessageBox.post("ɹ", "ɹ", MessageBox.WARNING);
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
			throw e;
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}
	}
}



