package com.connor.zf.controlplanlibrary;

import java.awt.Color;
import java.awt.Component;
import java.awt.Event;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.UnsupportedEncodingException;
import java.util.EventObject;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.EventListenerList;
import javax.swing.table.TableCellEditor;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

public class TextAreaCellEditor extends JTextPane implements TableCellEditor,
		CaretListener {
	private static final long serialVersionUID = 5860619160549087886L;
	private EventListenerList listenerList = new EventListenerList();
	private ChangeEvent changeEvent = new ChangeEvent(this);
	private int index;// λ

	public TextAreaCellEditor() {
		// TODO Auto-generated constructor stub
		super();
		this.addCaretListener(this);
		// this.setLineWrap(true); //Զ
		// this.setWrapStyleWord(true);
	}

	public int getIndex() {
		return index;
	}

	@Override
	public void addCellEditorListener(CellEditorListener listener) {
		// TODO Auto-generated method stub
		listenerList.add(CellEditorListener.class, listener);
	}

	@Override
	public void cancelCellEditing() {
		// TODO Auto-generated method stub
		System.out.println(2);
	}

	@Override
	public Object getCellEditorValue() {
		// TODO Auto-generated method stub
		// System.out.println(3);
		return this.getText();
	}

	@Override
	public boolean isCellEditable(EventObject arg0) {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public void removeCellEditorListener(CellEditorListener listener) {
		// TODO Auto-generated method stub
		listenerList.remove(CellEditorListener.class, listener);
	}

	private void fireEditingStopped() {
		CellEditorListener listener;
		Object[] listeners = listenerList.getListenerList();
		for (int i = 0; i < listeners.length; i++) {
			if (listeners[i] == CellEditorListener.class) {
				// ֮i+1ΪһΪCellEditorListener.classClass󣩣
				// ŵһCellEditorListenerʵ
				listener = (CellEditorListener) listeners[i + 1];
				// changeEventȥ֪ͨ༭Ѿ༭
				// editingStoppedУJTablegetCellEditorValue()ȡصԪֵ
				// ҰֵݸTableValues(TableModel)setValueAt()
				try {
					listener.editingStopped(changeEvent);
				} catch (Exception e) {
					// TODO: handle exception
					System.out.println(e.toString());
				}
			}
		}
	}

	@Override
	public boolean shouldSelectCell(EventObject arg0) {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public boolean stopCellEditing() {
		// TODO Auto-generated method stub
		// ע͵fireEditingStopped();ȻGenderEditorĹ캯а
		// addActionListener()עȥʱֹ༭JComboBoxã
		// System.out.println("༭һԪٵһԪʱá");
		fireEditingStopped();// ֹ༭JTable
		return true;
	}

	@Override
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelect, int row, int column) {
		// TODO Auto-generated method stub
		setText(value == null ? "" : value.toString());
		// 
		if (table.getValueAt(row, table.getColumnCount() - 1) == null) {
			return new JScrollPane(this);
		}
		String special = table.getValueAt(row, table.getColumnCount() - 1)
				.toString();
		if (special.indexOf("|") >= 0) {
			String[] specials = special.split("\\|");
			for (int i = 0; i < specials.length; i++) {
				if (specials[i].indexOf("-") >= 0) {
					String[] columnName = specials[i].split("-");
					if (table.getColumnName(column).equals(columnName[0])) {
						setTextFont(value.toString(),
								Integer.parseInt(columnName[1]), "Y14.5M");
					}
				}
			}
		} else if (special.indexOf("-") >= 0) {
			String[] columnName = special.split("-");
			if (table.getColumnName(column).equals(columnName[0])) {
				setTextFont(value.toString(), Integer.parseInt(columnName[1]),
						"Y14.5M");
			}
		}
		// if(value!=null)
		// {
		// if(cloumn == 1)
		// {
		// setTextFont(value.toString(),"Y14.5M");
		// }
		// }
		// System.out.println(8)
		return new JScrollPane(this);
	}

	@Override
	public void caretUpdate(CaretEvent caretevent) {
		// TODO Auto-generated method stub
		index = caretevent.getMark();
		// System.out.println(index);
	}

	// 壬һַҪʽɴSimpleAttributeSetַֿ˳ʹDocumentinsertString
	private void setTextFont(String value, int index, String font) {
		// TODO Auto-generated method stub
		SimpleAttributeSet set = new SimpleAttributeSet();
		// StyleConstants.setForeground(set, Color.red);//ɫ
		StyleConstants.setFontFamily(set, font);// ʽ
		// StyleConstants.setFontSize(set, 14);
		SimpleAttributeSet set2 = new SimpleAttributeSet();
		// StyleConstants.setForeground(set, Color.red);//ɫ
		StyleConstants.setFontFamily(set2, "Courier New");// ʽ
		// StyleConstants.setFontSize(set2, 10);
		Document doc = this.getStyledDocument();
		try {
			// ǰҪɾ
			doc.remove(0, value.toString().length());
			value = value.replaceAll(" ", "");
			doc.insertString(doc.getLength(),
					value.toString().substring(0, index), set2);
			doc.insertString(doc.getLength(),
					value.toString().substring(index, index + 1), set);
			doc.insertString(
					doc.getLength(),
					value.toString().substring(index + 1,
							value.toString().length()), set2);
			if (value.toString()
					.substring(index + 1, value.toString().length()) == null
					|| value.toString()
							.substring(index + 1, value.toString().length())
							.equals("")) {
				doc.insertString(doc.getLength(), " ", set2);
			}
		} catch (BadLocationException e) {
			e.printStackTrace();
		} finally {
			set = null;
			doc = null;
			System.gc();
		}
	}
}
