package com.connor.zf.plm002;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.StringTokenizer;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import com.connor.zf.utils.TMomMethodUtil;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.commands.newitem.NamingRule;
import com.teamcenter.rac.commands.newitem.NamingRulesHelper;
import com.teamcenter.rac.commands.revise.RevisionNamingRuleHelper;
import com.teamcenter.rac.common.Activator;
import com.teamcenter.rac.common.lov.view.components.LOVDisplayer;
import com.teamcenter.rac.kernel.ServiceData;
import com.teamcenter.rac.kernel.SoaUtil;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentBOMWindow;
import com.teamcenter.rac.kernel.TCComponentBOMWindowType;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentNameRule;
import com.teamcenter.rac.kernel.TCComponentNameRuleType;
import com.teamcenter.rac.kernel.TCComponentRule;
import com.teamcenter.rac.kernel.TCComponentRuleType;
import com.teamcenter.rac.kernel.TCComponentType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCExceptionPartial;
import com.teamcenter.rac.kernel.TCPropertyDescriptor;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.services.rac.core.DataManagementService;
import com.teamcenter.services.rac.core._2006_03.DataManagement;


public class CreateProcessRouteDialog extends AbstractAIFDialog implements ActionListener{
	private TCSession session;
	private TCComponentItemRevision tarRevision;
	
	private JLabel idLabel;
	private JTextField idField;
	private JButton assignButton;
	private JLabel nameLabel;
	private JTextField nameField;
	private JPanel centerPanel;
	private JButton celButton;
	private JButton okButton;
	
	private JComboBox<String> ruleBox;
	private JTextField revField = new JTextField();
	final String type = "ZF6_GYLX";
	final String ITEMTYPE = "ZF6_GYLX";
	
	private LinkedHashMap<String, String> proHashMap = new LinkedHashMap<String, String>();
	private HashMap<String, String> itemMap = new HashMap<String, String>();
	private HashMap<String, String> revMap = new HashMap<String, String>();
	private HashMap<String, Boolean> boolMap = new HashMap<String, Boolean>();
	private HashMap<String, String> revMasterMap = new HashMap<String, String>();
	
	public CreateProcessRouteDialog(TCSession session,InterfaceAIFComponent targetComponent) {
		super(false);
		this.session = session;
		this.tarRevision = (TCComponentItemRevision) targetComponent;
		getPro();
		init();
	}

	private void init() {
		this.setTitle("·ߴ");
		idLabel = new JLabel("ID");
		idLabel.setPreferredSize(new Dimension(120,40));
		idField = new JTextField();
		idField.setPreferredSize(new Dimension(220,40));
		assignButton = new JButton("ָ");
		assignButton.setPreferredSize(new Dimension(66,40));
		nameLabel = new JLabel("ƣ");
		nameLabel.setPreferredSize(new Dimension(120,40));
		nameField = new JTextField();
		nameField.setPreferredSize(new Dimension(220,40));
		ruleBox = new JComboBox<String>();
		assignRule();
		ruleBox.setPreferredSize(new Dimension(220,40));
		
		centerPanel = new JPanel(new PropertyLayout());
		centerPanel.add("1.1.center",idLabel);
		centerPanel.add("1.2.center",idField);
		centerPanel.add("1.3.center",ruleBox);
		centerPanel.add("1.4.center",assignButton);
		centerPanel.add("2.1.center",nameLabel);
		centerPanel.add("2.2.center",nameField);
		int index = 3;
		for (Entry<String, String> entry : proHashMap.entrySet()) {
			String[] split = entry.getKey().split("=");
			JLabel label = new JLabel(split[0]);
			label.setPreferredSize(new Dimension(120,40));
			centerPanel.add(index + ".1.center",label);
			if("string".equals(entry.getValue())) {
				JTextField field = new JTextField();
				field.setPreferredSize(new Dimension(220,40));
				field.setName(split[1]);
				centerPanel.add(index + ".2.center",field);
			}else if("boolean".equals(entry.getValue())) {
				JComboBox<String> comboBox = new JComboBox<String>();
				comboBox.setPreferredSize(new Dimension(220,40));
				comboBox.setName(split[1]);
				comboBox.addItem("");
				comboBox.addItem("");
				centerPanel.add(index + ".2.center",comboBox);
			}else if("lov".equals(entry.getValue())) {			
				try {
					TCComponentType localTCComponentType = session.getTypeComponent("ZF6_GYLXRevision");
					TCPropertyDescriptor descriptor = localTCComponentType.getPropertyDescriptor(split[1]);
					LOVDisplayer combo = new LOVDisplayer(descriptor);
					combo.setName(split[1]);
					combo.setPreferredSize(new Dimension(240,40));
					centerPanel.add(index + ".2.center",combo);
				} catch (TCException e) {
					e.printStackTrace();
				}			
			}
			index++;
		}
		
		JScrollPane jsp = new JScrollPane(centerPanel);		
		
		okButton = new JButton("ȷ");
		celButton = new JButton("ȡ");
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(okButton);
		buttonPanel.add(celButton);
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER,jsp);
		this.add(BorderLayout.SOUTH,buttonPanel);
		
		assignButton.addActionListener(this);
		okButton.addActionListener(this);
		celButton.addActionListener(this);
		showDialog();
	}

	private void assignRule() {
		TCComponentNameRuleType nameRuleType;
		try {
			nameRuleType = (TCComponentNameRuleType) session.getTypeComponent("NameRule");
			TCComponentNameRule nameRule = nameRuleType.find("ZF6_GYLXMMGZ");
			String[] patterns = nameRule.getPatterns();
			for (String string : patterns) {
				ruleBox.addItem(string);
			}
		} catch (TCException e) {
			e.printStackTrace();
		}

	}

	/**
	 * õѡе
	 */
	private void getPro() {
		//ʾ=ʵ=string/boolean/lov
		String[] stringValues = session.getPreferenceService().getStringValues("ZF_Process_Create");
		for (String string : stringValues) {
			String[] split = string.split("=");
			if(split.length == 3) {
				proHashMap.put(split[0] + "=" +split[1],split[2]);
			}
		}
		
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.assignButton) {
			//ָid
			updateLastUsedPref();
			getAssignedIds();
//			try {
//				TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent(type);
//				String newID = itemType.getNewID();
//				idField.setText(newID);
//			} catch (TCException e1) {
//				e1.printStackTrace();
//			}
		}else if(e.getSource() == this.celButton) {
			dispose();
		}else if(e.getSource() == this.okButton) {
			revMap.clear();
			int componentCount = centerPanel.getComponentCount();
			for (int i = 6; i < componentCount; i++) {
				Component component = centerPanel.getComponent(i);
				if(component instanceof JTextField) {
					JTextField field = (JTextField) component;
					String name = field.getName();
					String value = field.getText();
					revMap.put(name, value);
				}else if(component instanceof JComboBox) {
					JComboBox comBox = (JComboBox) component;
					String name = comBox.getName();
					String value = comBox.getSelectedItem().toString();
					if("".equals(value)) {
						boolMap.put(name, true);
					}else if("".equals(value)) {
						boolMap.put(name, false);
					}
				}else if(component instanceof LOVDisplayer) {
					LOVDisplayer combox = (LOVDisplayer)component;
					revMap.put(combox.getName(), combox.getSelectedValue().toString());
				}
			}
			if(idField.getText().isEmpty()) {
				MessageBox.post("дID", "", MessageBox.ERROR);
				return;
			}else if(nameField.getText().isEmpty()) {
				MessageBox.post("дơ", "", MessageBox.ERROR);
				return;
			}
			TCComponentItem item = TMomMethodUtil.createNewItemSoa(session, idField.getText(), "A", type,
					nameField.getText(), "", "", itemMap, revMap, revMasterMap);
			if(item != null) {
				try {
					//boolean
					for(Entry<String, Boolean> entry : boolMap.entrySet()) {
						item.getLatestItemRevision().setLogicalProperty(entry.getKey(), entry.getValue());
					}
					//string
					for(Entry<String, String> entry : revMap.entrySet()) {
						item.getLatestItemRevision().setProperty(entry.getKey(), entry.getValue());
					}
					recreateBom(item);
					tarRevision.add("ZF6_R_GYLX", item.getLatestItemRevision());
					//item.getLatestItemRevision().add("IMAN_METarget",tarRevision);
					MessageBox.post("ɹ!!!", "ɹ", MessageBox.INFORMATION);
					this.disposeDialog();
					this.dispose();
				} catch (TCException e1) {
					e1.printStackTrace();
				}
			}
		}
		
	}
	
	@SuppressWarnings("deprecation")
	public void recreateBom(TCComponentItem item)
			throws TCException {
		TCComponentBOMWindow bomWindow = null;
		TCComponentBOMWindowType bomWindowType = (TCComponentBOMWindowType) session
				.getTypeComponent("BOMWindow");
		bomWindow = bomWindowType.create(null);
		TCComponentBOMLine topline = bomWindow.setWindowTopLine(item,
				item.getLatestItemRevision(), null, null);
		TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent("Item");
		TCComponentItem find = itemType.find(tarRevision.getStringProperty("item_id"));
		topline.add(find, find.getLatestItemRevision(), null, false, "");
		AIFComponentContext[] children = topline.getChildren();
		TCComponentBOMLine component = (TCComponentBOMLine) children[0].getComponent();
		component.cut();
		bomWindow.lock();
		topline.lock();
		bomWindow.unlock();
		bomWindow.save();
	}
	
	public static void throwServiceDataError(ServiceData data) throws Exception {
		if (data.sizeOfPartialErrors() > 0) {
			StringBuilder errInfo = new StringBuilder();
			for (int i = 0; i < data.sizeOfPartialErrors(); i++) {
				for (String msg : data.getPartialError(i).getMessages()) {
					errInfo.append(msg + "\n");
				}
			}
			throw new Exception(errInfo.toString());
		}
	}
	
	protected void updateLastUsedPref() {
		try {
			String string = (String) this.ruleBox.getSelectedItem();
			String string2 = "";// (String) this.revisionIdCombobox.getSelectedItem();
			boolean bl = false;
			boolean bl2 = false;
			String[] arrstring = new String[] { "item_id", "item_revision_id" };
			String[] arrstring2 = new String[] { ITEMTYPE, ITEMTYPE };
			NamingRule[] arrnamingRule = NamingRulesHelper.getInstance().getNamingRules(this.session, arrstring2, arrstring);
			String string3 = arrnamingRule[0].getCondition();
			String string4 = arrnamingRule[1].getCondition();
			if (string3 == null) {
				string3 = "";
			}
			if (string4 == null) {
				string4 = "";
			}
			bl = arrnamingRule[0].patternPresent(string);
			bl2 = arrnamingRule[1].patternPresent(string2);
			string = bl ? (String) this.ruleBox.getSelectedItem() : "";
			// string2 = bl2 ? (String) this.revisionIdCombobox.getSelectedItem() : "";
			StringBuilder stringBuilder = new StringBuilder();
			stringBuilder.append(string3);
			stringBuilder.append(":");
			stringBuilder.append(ITEMTYPE);
			stringBuilder.append(":");
			stringBuilder.append("item_id");
			stringBuilder.append(":");
			stringBuilder.append(string);
			String string5 = stringBuilder.toString();
			StringBuilder stringBuilder2 = new StringBuilder();
			stringBuilder2.append(string4);
			stringBuilder2.append(":");
			stringBuilder2.append(ITEMTYPE);
			stringBuilder2.append(":");
			stringBuilder2.append("item_revision_id");
			stringBuilder2.append(":");
			stringBuilder2.append(string2);
			String string6 = stringBuilder2.toString();
			String[] arrstring3 = null;
			if (string2.equals("") && !string.equals("")) {
				arrstring3 = new String[] { string5 };
			} else if (!string2.equals("") && string.equals("")) {
				arrstring3 = new String[] { string6 };
			} else if (!string2.equals("") && !string.equals("")) {
				arrstring3 = new String[] { string5, string6 };
			}
			if (arrstring3 != null) {
				// this.prefService = this.session.getPreferenceService();
				String[] arrstring4 = session.getPreferenceService().getStringArray(1, "TC_LAST_USED_PATTERNS");
				ArrayList<String> arrayList = new ArrayList<String>();
				int n = 0;
				int n2 = 0;
				int n3 = 0;
				int n4 = 0;
				while (n4 < arrstring4.length) {
					String string7 = arrstring4[n4];
					if (!string7.equals("")) {
						StringTokenizer stringTokenizer = new StringTokenizer(string7, ":");
						stringTokenizer.nextToken();
						String string8 = stringTokenizer.nextToken();
						String string9 = stringTokenizer.nextToken();
						if (ITEMTYPE.equals(string8)) {
							++n;
							if (string9.equals("item_id") && arrstring3[0] != null) {
								arrayList.add(n4, arrstring3[0]);
								++n2;
							}
							if (string9.equals("item_revision_id")) {
								if (arrstring3.length == 1 && arrstring3[0] != null) {
									arrayList.add(n4, arrstring3[0]);
									++n3;
								}
								if (arrstring3.length > 1 && arrstring3[1] != null) {
									arrayList.add(n4, arrstring3[1]);
									++n3;
								}
							}
						} else {
							arrayList.add(n4, arrstring4[n4]);
						}
					}
					++n4;
				}
				n4 = 0;
				n4 = arrstring4.length == 1 && arrstring4[0].equals("") ? 0 : arrstring4.length;
				int n5 = 0;
				int n6 = 0;
				int n7 = 0;
				while (n7 < arrstring3.length) {
					if (n < 1 && n2 < 1 && n3 < 1) {
						arrayList.add(n4, arrstring3[n7]);
						++n4;
					}
					if (n2 > 0 && n3 < 1 && !string2.equals("") && n5 == 0) {
						arrayList.add(n4, arrstring3[1]);
						++n5;
					}
					if (n3 > 0 && n2 < 1 && !string.equals("") && n6 == 0) {
						arrayList.add(n4, arrstring3[0]);
						++n6;
					}
					++n7;
				}
				String[] arrstring5 = arrayList.toArray(new String[arrayList.size()]);
				session.getPreferenceService().setStringArray(1, "TC_LAST_USED_PATTERNS", arrstring5);
			}
		} catch (TCException tCException) {
		}
	}

	public void getAssignedIds() {
		TCComponentItemType tCComponentItemType = null;
		boolean bl = true;
		boolean bl2 = true;
		try {
			tCComponentItemType = (TCComponentItemType) this.session.getTypeComponent(ITEMTYPE);
			DataManagementService dataManagementService = DataManagementService.getService((TCSession) this.session);
			RevisionNamingRuleHelper.getInstance().loadRevNamingRuleDetails(this.session, ITEMTYPE, null);
			int[] arrn = RevisionNamingRuleHelper.getInstance().getRevisionNamingRuleFormats();
			int n = arrn[0];
			int n2 = arrn[1];
			if (this.idField.getText().length() == 0) {
				DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties[] arrgenerateItemIdsAndInitialRevisionIdsProperties = new DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties[] {
						new DataManagement.GenerateItemIdsAndInitialRevisionIdsProperties() };
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].item = null;
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].itemType = ITEMTYPE;
				arrgenerateItemIdsAndInitialRevisionIdsProperties[0].count = 1;
				DataManagement.GenerateItemIdsAndInitialRevisionIdsResponse generateItemIdsAndInitialRevisionIdsResponse = dataManagementService
						.generateItemIdsAndInitialRevisionIds(arrgenerateItemIdsAndInitialRevisionIdsProperties);
				if (generateItemIdsAndInitialRevisionIdsResponse.serviceData.sizeOfPartialErrors() > 0) {
					this.idField.setText("");
					this.idField.requestFocusInWindow();
					TCExceptionPartial tCExceptionPartial = SoaUtil.checkPartialErrorsNoThrow((com.teamcenter.soa.client.model.ServiceData) generateItemIdsAndInitialRevisionIdsResponse.serviceData);
					MessageBox.post(this, (Throwable) tCExceptionPartial);
					return;
				}
				String string = null;
				String string2 = null;
				Map map = generateItemIdsAndInitialRevisionIdsResponse.outputItemIdsAndInitialRevisionIds;
				Iterator iterator = map.entrySet().iterator();
				if (iterator.hasNext()) {
					Map.Entry entry = (Entry) iterator.next();
					DataManagement.ItemIdsAndInitialRevisionIds[] arritemIdsAndInitialRevisionIds = (DataManagement.ItemIdsAndInitialRevisionIds[]) entry.getValue();
					DataManagement.ItemIdsAndInitialRevisionIds itemIdsAndInitialRevisionIds = arritemIdsAndInitialRevisionIds[0];
					string = itemIdsAndInitialRevisionIds.newItemId;
					if (n != 0) {
						/*
						 * if (n2 == 0) { this.assignRevIdWithRevisionRule(); }
						 */
					} else {
						string2 = itemIdsAndInitialRevisionIds.newRevId;
						this.revField.setText(string2);
					}
					bl = itemIdsAndInitialRevisionIds.isItemModify;
					bl2 = itemIdsAndInitialRevisionIds.isRevModify;
				}
				this.idField.setText(string);
				if (!bl) {
					this.idField.setEditable(false);
					this.ruleBox.setEnabled(false);
				}
				if (!bl2) {
					this.revField.setEditable(false);
					// this.revisionIdCombobox.setEnabled(false);
				}
				this.nameField.requestFocusInWindow();
				return;
			}
			boolean bl3 = true;
			// bl3 = this.validateId();
			/*
			 * if (!bl3) { this.idField.setText(""); this.idField.requestFocusInWindow();
			 * return; }
			 */
			if (n != 0) {
				if (n2 == 0) {
					// this.assignRevIdWithRevisionRule();
				}
			} else {
				String string = tCComponentItemType.getNewRev(null);
				bl2 = tCComponentItemType.isNewRevModifiable(null, string);
				this.revField.setText(string);
			}
			if (!bl2) {
				this.revField.setEditable(false);
			}
			this.nameField.requestFocusInWindow();
		} catch (TCException tCException) {
			MessageBox.post((Window) this, (Throwable) tCException);
		}
	}

}
