package com.connor.zf.plm003;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.xml.bind.JAXBException;

import com.connor.zf.plm.xmlUtil.CNCompontent;
import com.connor.zf.plm.xmlUtil.CNPart;
import com.connor.zf.plm.xmlUtil.CNPartList;
import com.connor.zf.plm.xmlUtil.CNProperty;
import com.connor.zf.plm.xmlUtil.CNXmlUtil;
import com.connor.zf.utils.JFomMethodUtil;
import com.connor.zf.utils.SqlUtilT;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentFaultCode;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.DateButton;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;



public class CreateToolingDialog extends AbstractAIFDialog implements ActionListener{
	private TCSession session;
	private TCComponentItemRevision tarRevision;
	
	final String GZDH_PRE = "ZF6_GZSJ_GZDH"; //װ
	final String JCDH_PRE = "ZF6_GZSJ_JCDH"; //
	final String GZMJDH_PRE = "ZF6_GZSJ_GZMJDH"; //װģ
	final String XML_PUID = "ZF6_GZSJ_ATT";
	final String newType = "ZF6_GZ";
	private LinkedHashMap<String, String> gzdhMap = new LinkedHashMap<String, String>();
	private LinkedHashMap<String, String> jcdhMap = new LinkedHashMap<String, String>();
	private LinkedHashMap<String, String> gzmjdhMap = new LinkedHashMap<String, String>();
	
	private JComboBox<String> gzdhBox;
	private JComboBox<String> jcdhBox;
	private JComboBox<String> gzmjdhBox;
	private JPanel centerPanel;
	
	private JButton okButton;
	private JButton celButton;
	private CNPart currentCNPart;
	
	int index = 4;
	
	private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-M-dd HH:mm");
	
	private HashMap<String, String> itemProMap = new HashMap<String, String>();
	
	private HashMap<String, String> mappingMap = new HashMap<String, String>();
			
	public CreateToolingDialog(TCSession session,InterfaceAIFComponent targetComponent){
		super(false);
		this.session = session;
		this.tarRevision = (TCComponentItemRevision) targetComponent;
		getData();	
		getMapping();
		init();		
	}

	private void init() {
		this.setTitle("װ");
		this.setPreferredSize(new Dimension(555,666));
		
		centerPanel = new JPanel(new PropertyLayout());
		JLabel oneLabel = new JLabel("װţ");
		oneLabel.setPreferredSize(new Dimension(150,30));
		gzdhBox = new JComboBox<String>();
		for (Entry<String, String> entry : gzdhMap.entrySet()) {
			gzdhBox.addItem(entry.getKey());
		}
		gzdhBox.setPreferredSize(new Dimension(350,30));	
		JLabel twoLabel = new JLabel("ţ");
		twoLabel.setPreferredSize(new Dimension(150,30));
		jcdhBox = new JComboBox<String>();
		for (Entry<String, String> entry : jcdhMap.entrySet()) {
			jcdhBox.addItem(entry.getKey());
		}
		jcdhBox.setPreferredSize(new Dimension(350,30));
		JLabel threeLabel = new JLabel("װģţ");
		threeLabel.setPreferredSize(new Dimension(150,30));
		gzmjdhBox = new JComboBox<String>();
		for (Entry<String, String> entry : gzmjdhMap.entrySet()) {
			gzmjdhBox.addItem(entry.getKey());
		}
		gzmjdhBox.setPreferredSize(new Dimension(350,30));
		centerPanel.add("1.1.center",oneLabel);
		centerPanel.add("1.2.center",gzdhBox);
		centerPanel.add("2.1.center",twoLabel);
		centerPanel.add("2.2.center",jcdhBox);
		centerPanel.add("3.1.center",threeLabel);
		centerPanel.add("3.2.center",gzmjdhBox);
		for (CNCompontent cnComp : this.currentCNPart.getCompontentList()) {
			List<CNProperty> propertyList = cnComp.getPropertyList();
			for (CNProperty cnProperty : propertyList) {
				JLabel label;
				if(cnProperty.getIsMust()) {
					label = new JLabel("<html>" +cnProperty.getDisplayName()+ "<font color=\"red\"> *</font></html>");
				}else {
					label = new JLabel(cnProperty.getDisplayName() + "");
				}
				label.setName(cnProperty.getRealName());
				label.setPreferredSize(new Dimension(150,30));
				centerPanel.add(index + ".1.center",label);
				if(cnProperty.getIsLov()) {
					
				}else {
					if(cnProperty.getPropertyType().toUpperCase().equals("STRING")) {
						JTextField field = new JTextField(cnProperty.getDefaultValue());
						field.setName(cnProperty.getRealName());
						field.setPreferredSize(new Dimension(350,30));
						centerPanel.add(index + ".2.center",field);
					}	
					else if(cnProperty.getPropertyType().toUpperCase().equals("BOOLEAN")) {
						JComboBox<Boolean> comboBox = new JComboBox<Boolean>();
						comboBox.addItem(true);
						comboBox.addItem(false);
						comboBox.setName(cnProperty.getRealName());
						comboBox.setPreferredSize(new Dimension(350,30));
						centerPanel.add(index + ".2.center",comboBox);
					}
					else if(cnProperty.getPropertyType().toUpperCase().equals("DATE")) {
						DateButton dateButton = new DateButton(sdf);
						dateButton.setName(cnProperty.getRealName());
						dateButton.setPreferredSize(new Dimension(350,30));
						centerPanel.add(index + ".2.center",dateButton);
					}
				}
				if(cnComp.getType().equals("I")) {
					itemProMap.put(cnProperty.getRealName(), "");
				}
				index++;
			}
		}
		JScrollPane jsp = new JScrollPane(centerPanel);
		
		okButton = new JButton("ȷ");
		celButton = new JButton("ȡ");
		okButton.addActionListener(this);
		celButton.addActionListener(this);
		JPanel buttonJPanel = new JPanel();
		buttonJPanel.add(okButton);
		buttonJPanel.add(celButton);
		
		this.setLayout(new BorderLayout());
		this.add(BorderLayout.CENTER,jsp);
		this.add(BorderLayout.SOUTH,buttonJPanel);
		this.setResizable(false);
		showDialog();
	}
	
	private void getMapping() {
		//ѡжӳ䣨ZF6_GZSJ_Mapping: ѡ:1=װư汾1;2=װư汾2
		String[] mappingValues = session.getPreferenceService().getStringValues("ZF6_GZSJ_Mapping");
		for (String string : mappingValues) {
			if(string.contains(tarRevision.getType() + ":")) {
				String[] split = string.split(":")[1].split(";");
				for (String value : split) {
					String[] split2 = value.split("=");
					mappingMap.put(split2[0], split2[1]);
				}			
			}
		}
	}
	
	private void getData() {
		changePreValues(GZDH_PRE,"=",gzdhMap);
		changePreValues(JCDH_PRE,"=",jcdhMap);
		changePreValues(GZMJDH_PRE,"=",gzmjdhMap);
		String puid = JFomMethodUtil.getOptionValue(XML_PUID, session);	
		TCComponent datasetcomp;
		try {
			datasetcomp = session.stringToComponent(puid);
			String filePath = JFomMethodUtil.downLoadFile(datasetcomp);
			Object object = CNXmlUtil.xmlToBean(filePath, CNPartList.class);
			CNPartList parts = (CNPartList) object;
			List<CNPart> partList = parts.getPartList();
			currentCNPart = partList.get(0);
		} catch (TCException | JAXBException | IOException e) {
			e.printStackTrace();
		}	
	}
	
	private void changePreValues(String preName,String splitSign,Map<String, String> map) {
		String[] stringValues = session.getPreferenceService().getStringValues(preName);
		map.put("", "");
		for (String string : stringValues) {
			String[] split = string.split(splitSign);
			if(split.length == 2) {
				map.put(split[0], split[1]);
			}		
		}
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getSource() == this.celButton) {
			this.disposeDialog();
		}else if(arg0.getSource() == this.okButton) {
			try {
				String newID = getNewID();
				TCComponentItemType itemType = (TCComponentItemType) session.getTypeComponent(newType);
				//id汾ͣƣ
				TCComponentItem newItem = itemType.create(newID,"",newType ,"", "", null);
				TCComponentItemRevision itemRevision = newItem.getLatestItemRevision();
				//
				for (int i = 6; i < centerPanel.getComponentCount(); i++) {
					Component component2 = centerPanel.getComponent(i);
					String propName = component2.getName();
					if (component2 instanceof JTextField) {
						JTextField field = (JTextField) component2;
						// Ϊnullǰ汾ԣƶҪ
						if ("object_name".equals(propName)) {
							itemRevision.setProperty(propName, field.getText());
							newItem.setProperty(propName, field.getText());
						} else if (itemProMap.get(propName) == null) {
							itemRevision.setProperty(propName, field.getText());
						} else {
							newItem.setProperty(propName, field.getText());
						}
					}
					else if(component2 instanceof JComboBox) {
						JComboBox comboBox = (JComboBox) component2;
						Boolean selectedItem = (Boolean) comboBox.getSelectedItem();
						//Ϊnullǰ汾
						if(itemProMap.get(propName) == null) {
							itemRevision.setLogicalProperty(propName, selectedItem);
						}else {
							newItem.setLogicalProperty(propName, selectedItem);
						}					
					}
				}
				//ӳ
				if(!mappingMap.isEmpty()) {
					for(Entry<String, String> entry : mappingMap.entrySet()) {
						itemRevision.setProperty(entry.getValue(), tarRevision.getStringProperty(entry.getKey()));
					}
				}
				TCComponentFolder folder = null;
				String folderName = "";
				AIFComponentContext[] whereReferenced = tarRevision.getItem().whereReferenced();
				if (whereReferenced != null) {
					for (AIFComponentContext con : whereReferenced) {
						InterfaceAIFComponent component2 = con.getComponent();
						if (component2 instanceof TCComponentFolder) {
							TCComponentFolder tempfolder = (TCComponentFolder) component2;
							String owning_user = tempfolder.getProperty("owning_user");
							String string = session.getUser().toString();
							if (string.equals(owning_user)) {
								folder = tempfolder;
								folderName = folder.getStringProperty("object_name");
								System.out.println("ҵļ" + folderName);
								break;
							}
						}
					}
				}else {
					folder = session.getUser().getHomeFolder();
					folderName = folder.getStringProperty("object_name");
				}			
				folder.add("contents", newItem);
				MessageBox.post("ɹ,ļС" + folderName,"ʾ",2);
			} catch (TCException | SQLException e) {
				e.printStackTrace();
			}
		}
		
	}
	
	/**
	 * õװID
	 * @throws TCException 
	 * @throws SQLException 
	 */
	private String getNewID() throws TCException, SQLException {
		/**
		 * 3)ڶĹװZF6_GZRevisionitem_idΪװ--Դitem_id-װģߴ-2n
		 * ԴidΪ515020-01ĶIDΪC-SY-515020-01-R-02
		 * ӦѡΪգΪʱȡ-šɣC-515020-01-R-02
		 */	
		String gzdh = gzdhMap.get(gzdhBox.getSelectedItem().toString());
		String jcdh = jcdhMap.get(jcdhBox.getSelectedItem().toString());
		String gzmjdh = gzmjdhMap.get(gzmjdhBox.getSelectedItem().toString());
		String newID = "";
		if(!gzdh.isEmpty()) {
			newID = gzdh + "-";
		}
		if(!jcdh.isEmpty()) {
			newID = newID + jcdh + "-";
		}
		newID = newID + tarRevision.getStringProperty("item_id") + "-";
		if(!gzmjdh.isEmpty()) {
			newID = newID + gzmjdh + "-";
		}
		SqlUtilT.getTCConnection();
		String sql = String.format("select MAX(pitem_id) max from dbo.PITEM t1, dbo.PZF6_GZ t2 where t1.puid = t2.puid and pitem_id like '%s%%'", newID);
		String string = "";
		ResultSet rs = SqlUtilT.read(sql);
		if(rs.next()) {
			string = rs.getString("max");
		}
		if(string == null || string.isEmpty()) {
			newID = newID + "001";
		}else {
			if(string.contains("-")) {
				String[] split = string.split("-");
				DecimalFormat df = new DecimalFormat("000");
				String format = df.format(Integer.parseInt(split[split.length-1]) + 1);
				newID = newID + format;
			}		
		}	
		return newID;
	}
}
