package com.connor.zf.utils;


import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;

public class CheckBoxTableHeaderRenderer implements TableCellRenderer{
	
	private JTableHeader tableHeader;
	private JCheckBox selectBox;
	//checkboxڵ
	private int IND_BOOLEAN;    
	//ɫ
	private static final Color BG=new Color(53,53,53);   

	public CheckBoxTableHeaderRenderer(final JTable table,int IND_BOOLEAN1,JCheckBox check) {
        this.tableHeader = table.getTableHeader();
        this.IND_BOOLEAN=IND_BOOLEAN1;
        this.selectBox = check;
        tableHeader.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                if (e.getClickCount() > 0) {
                    // ѡ
                    int selectColumn = tableHeader.columnAtPoint(e.getPoint());
                    if (selectColumn == IND_BOOLEAN) {
                        boolean value = !selectBox.isSelected();
                        selectBox.setSelected(value);
                        for(int index = 0; index < table.getRowCount(); index ++){
                        	table.setValueAt(value, index, IND_BOOLEAN);
                        }
                        tableHeader.repaint();
                    }
                }
            }
        });
    }

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
		String valueStr = (String) value;
        JLabel label = new JLabel(valueStr);
        label.setHorizontalAlignment(SwingConstants.CENTER); // ͷǩ
        selectBox.setHorizontalAlignment(SwingConstants.CENTER);// ͷǩ
        selectBox.setBorderPainted(true);
        JComponent component = (column == IND_BOOLEAN) ? selectBox : label;
        component.setOpaque(true);
        component.setForeground(Color.WHITE);
        component.setBackground(BG);
        component.setFont(tableHeader.getFont());
        component.setBorder(BorderFactory.createMatteBorder(0, 0, 0, 1, Color.WHITE));
        component.setPreferredSize(new Dimension(component.getPreferredSize().width,25));
        return component;
	}

}