package com.connor.zf.utils;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentFormType;
import com.teamcenter.rac.kernel.TCComponentItemRevisionType;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.FileUtility;

public class JFomMethodUtil {

	
	/**
	 * ļ
	 * 
	 * @param comps
	 * @return
	 * @throws TCException
	 * @throws IOException
	 */
	public static String downLoadFile(TCComponent comp) {
		if (comp == null) {
			return "";
		}
		String value = "";
		String tempPath = System.getenv("TEMP");
		// MessageBox.post(" tempPath =
		// "+tempPath,"INFO",MessageBox.INFORMATION);
		if (tempPath == null) {
			tempPath = "";
		} else if (!tempPath.endsWith("\\")) {
			tempPath = tempPath + "\\";
		}
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
		// for(TCComponent comp : comps){
		try {
			if (comp instanceof TCComponentDataset) {
				TCComponentTcFile[] tcFiles = ((TCComponentDataset) comp)
						.getTcFiles();
				File file = null;
				if (tcFiles != null && tcFiles.length != 0) {
					file = tcFiles[0].getFmsFile();
					String fileName = file.getName();
					String fileDix = fileName.substring(
							fileName.lastIndexOf("."), fileName.length());
					fileName = tempPath + sdf.format(new Date()) + fileDix;
					File dirFile = new File(fileName);
					FileUtility.copyFile(file, dirFile);

					return fileName;
				}
			}
		} catch (TCException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// }
		return value;
	}
	
	/**
	 * ȡѡֵ
	 * @param prefName
	 * @param session
	 * @return
	 */
	public static String getOptionValue(String prefName, TCSession session) {
		String value = null;
		TCPreferenceService service = session.getPreferenceService();
		 value = service.getString(TCPreferenceService.TC_preference_site, prefName);
		
		return value;
	}
	
	/**
	 * ȡѡֵ
	 * @param prefName
	 * @param session
	 * @return
	 */
	public static String[] getOptionValues(String prefName, TCSession session) {
		String[] values = null;
		TCPreferenceService service = session.getPreferenceService();
		values = service.getStringValues(prefName);
		
		return values;
	}
	
	/**
	 * ȡmapping
	 * name:value
	 * @param prefName
	 * @param session
	 * @return
	 */
	public static HashMap<String, String> getMapping(String prefName, TCSession session) {
		HashMap<String, String> map = new HashMap<String, String>();
		TCPreferenceService service = session.getPreferenceService();
		String[] prefValues = service.getStringArray(TCPreferenceService.TC_preference_site, prefName);
		if (prefValues != null) {
			for (String value : prefValues) {
				String[] values = value.split("\\:");
				if (values != null && values.length == 2)
					map.put(values[0], values[1]);
			}
		}
		return map;
	}
	
}
