package com.connor.zf.zygyk;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.connor.renben.process.plm.util.CreateNewBOHandler;
import com.connor.zf.editClassAttr.JAutoCompleteComboBox;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentBOMLine;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentItemType;
import com.teamcenter.rac.kernel.TCComponentNameRule;
import com.teamcenter.rac.kernel.TCComponentNameRuleType;
import com.teamcenter.rac.kernel.TCComponentQuery;
import com.teamcenter.rac.kernel.TCComponentQueryType;
import com.teamcenter.rac.kernel.TCComponentRevisionRule;
import com.teamcenter.rac.kernel.TCComponentRevisionRuleType;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Arrays;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import org.eclipse.core.commands.AbstractHandler;

public class CreateZYGYKHandler extends AbstractHandler{ // implements DocumentListener
	
	private TCComponentItemRevision itemRevision;
	private JLabel revLabel;//տ
	private JAutoCompleteComboBox revField;
	@Override
	public Object execute(ExecutionEvent arg0) throws ExecutionException {
		// TODO Auto-generated method stub
		
		
		
		AbstractAIFApplication app = AIFUtility.getCurrentApplication();
		
		InterfaceAIFComponent targetComponent = app.getTargetComponent();
		
		TCSession session =(TCSession) app.getSession();
		
		String type = targetComponent.getType();
		
		if(type.equals("ZF6_ZCTRevision")) {
			
			itemRevision = (TCComponentItemRevision)targetComponent;
			
			new Thread() {
				
				public void run() {
					
					JFrame frame = new JFrame();
					
					frame.setLayout(new PropertyLayout());
					
					frame.setPreferredSize(new Dimension(450,170));
					
					JTextField textField = new JTextField();
//					textName.setEditable(false);
					textField.setPreferredSize(new Dimension(300,20));
					JButton btn = new JButton("ָ");
					frame.add("1.1.left.center",new JLabel (" ID:  "));
					frame.add("1.2.left.center",textField);
					frame.add("1.3.left.center",btn);
//					btn.add
//					btn.getDocument().addDocumentListener(this);
					btn.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent e) {
							// TODO Auto-generated method stub
							try {
								String zctId = itemRevision.getStringProperty("item_id");
								
								TCComponentItemType itemTypeComp = (TCComponentItemType) session.getTypeComponent("ZF6_ZYGYK");
								
								String pfmeaId = "HZF-TE-"+zctId+"-";
								
							
								int ids = getItemRevision(session,pfmeaId);
								
								while(true) {
									
									ids = ids+1;
									
									String format = String.format("%03d", ids);
									
									String idString = pfmeaId+format;
									
									TCComponentItem find = itemTypeComp.find(idString);
									
									if(find==null) {
										pfmeaId = idString;
										break;
									}
									
								}
								
								textField.setText(pfmeaId);
								textField.setEditable(false);
								
							} catch (Exception er) {
								// TODO Auto-generated catch block
								er.printStackTrace();
							}
						}
					});
					frame.add("2.1.left.center",new JLabel (" : "));
					
					JTextField textField2 = new JTextField();
//					textName.setEditable(false);
					textField2.setPreferredSize(new Dimension(300,20));
					frame.add("2.2.left.center",textField2);
					
					//汾
					TCPreferenceService service = session.getPreferenceService();
					String[] strs = service.getStringValues("ZF_Revision_Rule");
					frame.add("3.1.left.center",new JLabel (" 汾: "));
					//revLabel.setPreferredSize(new Dimension(80, 30));
					revField = new JAutoCompleteComboBox();
					revField.setPreferredSize(new Dimension(300, 30));
					revField.setSelectedItem((strs==null||strs.length==0?"":strs[0]));//Ĭӵһ
					revField.setEditable(false);
					for (String str : strs) {
							revField.addItem(str);
					}
					frame.add("3.2.left.center",revField);
					
					
					
					
					JButton btn1 = new JButton("");
					btn1.setEnabled(false);
					textField2.getDocument().addDocumentListener(new DocumentListener() {
						
						@Override
						public void removeUpdate(DocumentEvent e) {
							// TODO Auto-generated method stub
							if(!textField2.getText().trim().equals("")) {
								btn1.setEnabled(true);
							}else {
								btn1.setEnabled(false);
							}
						}
						
						@Override
						public void insertUpdate(DocumentEvent e) {
							// TODO Auto-generated method stub
							if(!textField2.getText().trim().equals("")) {
								btn1.setEnabled(true);
							}else {
								btn1.setEnabled(false);
							}
						}
						
						@Override
						public void changedUpdate(DocumentEvent e) {
							// TODO Auto-generated method stub
							if(!textField2.getText().trim().equals("")) {
								btn1.setEnabled(true);
							}else {
								btn1.setEnabled(false);
							}
						}
					});
					
					
					btn1.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent e) {
							// TODO Auto-generated method stub
							try {
								revField.setEditable(true);
								String revNo=revField.getText();
								revField.setEditable(false);
								TCComponentItemType itemTypeComp = (TCComponentItemType) session.getTypeComponent("ZF6_ZYGYK");
//								/itemTypeComp.getNewRev(null)
								TCComponentItem create = itemTypeComp.create(textField.getText(), revNo ,"ZF6_ZYGYK",textField2.getText() , "", null);
								String obName = create.getStringProperty("object_string");
								textField.setText("");
								textField2.setText("");
								btn1.setEnabled(false);
								Boolean flag = false;
								String folderName = "";
//								MessageBox.post("","ʾ",2);
								String userId = session.getUser().getUserId();
								AIFComponentContext[] whereReferenced = itemRevision.getItem().whereReferenced();
								for(AIFComponentContext context:whereReferenced) {
									
									InterfaceAIFComponent component = context.getComponent();
									
									if(component instanceof TCComponentFolder) {
										
										TCComponentFolder folder = (TCComponentFolder)component;
										
										String userName = folder.getReferenceProperty("owning_user")
												.getStringProperty("user_id");
										if(userId.equals(userName)) {
											flag = true;
											folderName = folder.getStringProperty("object_name");
											folder.add("contents", create);
											break;
										}
									}
								}
								
								if(flag) {
									MessageBox.post(obName+""+folderName+"ļ","ʾ",2);
								}else {
									session.getUser().getHomeFolder().add("contents", create);
									MessageBox.post(obName+"HOME","ʾ",2);
								}
								
								
							} catch (TCException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							
						}
					});
					JButton btn2 = new JButton("ȡ");
					btn2.addActionListener(new ActionListener() {
						
						@Override
						public void actionPerformed(ActionEvent e) {
							
//							try {
////								TCComponentRevisionRuleType revisionRuleType = (TCComponentRevisionRuleType) session.getTypeComponent("RevisionRule");
////								String[] revs = revisionRuleType.getRevisionNamingRule();
////								System.out.println("revs====>"+Arrays.toString(revs));
////								System.out.println("======="+revisionRuleType.getPasteRelationNames());
//								TCComponentNameRuleType nameRuleType = (TCComponentNameRuleType) session.getTypeComponent("RevisionRule");
//								if(nameRuleType!=null) {
//									TCComponentNameRule nameRule = nameRuleType.find("ZF6_TZ");
//									if(nameRule!=null) {
//										String[] patterns = nameRule.getPatterns();
//										System.out.println("revs1====>"+Arrays.toString(patterns));
//									}
//								}
//								TCComponentNameRuleType nameRuleType2 = (TCComponentNameRuleType) session.getTypeComponent("RevisionNameRule");
//								if(nameRuleType2!=null) {
//									TCComponentNameRule nameRule2 = nameRuleType2.find("ZF6_TZ");
//									if(nameRule2!=null) {
//										String[] patterns = nameRule2.getPatterns();
//										System.out.println("revs2====>"+Arrays.toString(patterns));
//									}
//								}
////								//TCComponentRevisionRule revisionRule=revisionRuleType..find("ZF6_ZYGYK");
////								TCComponentNameRuleType nameRuleType = (TCComponentNameRuleType) session.getTypeComponent("NameRule");
////								TCComponentNameRule nameRule = nameRuleType.find("ZF6_TZ");
////								String[] patterns = nameRule.getPatterns();
////								System.out.println("revs====>"+Arrays.toString(patterns));
//							} catch (TCException e1) {
//								// TODO Auto-generated catch block
//								e1.printStackTrace();
//							}
							
							// TODO Auto-generated method stub
							frame.dispose();
							
						}
					});
					frame.add("4.1.left.center",btn1);
					frame.add("4.2.left.center",btn2);
					Toolkit toolkit = Toolkit.getDefaultToolkit();

		    		int x = (int)(toolkit.getScreenSize().getWidth()-frame.getWidth())/2;

		    		int y = (int)(toolkit.getScreenSize().getHeight()-frame.getHeight())/2;

		    		frame.setLocation(x, y);
					frame.pack();
					frame.setResizable(false);
					frame.show();
					
				}
				
				
			}.start();
			
			
//			CreateNewBOHandler handler = new CreateNewBOHandler("ZF6_ZYGYK");
//			handler.execute(arg0);
			
			
		}else {
			MessageBox.post("ѡZF6_ZCTRevision","ʾ",2);
		}
		
		
		return null;
	}
	public static int getItemRevision(TCSession session, String itemId) throws Exception {
		System.out.println("Search Revision: " + itemId );
		if (isEmpty(itemId)) {
			return 0;
		} else {
			String queryName = "Item Revision...";
			String[] keys = new String[]{getText(session, "ItemID")};
			String[] vals = new String[]{itemId};
			TCComponent[] res = query(session, queryName, keys, vals);
			
			if(res==null) {
				return 0;
			}

			return res.length;
			
		}
	}
	public static boolean isEmpty(String str) {
		return str == null || "".equals(str.trim());
	}
	public static String getText(TCSession session, String str) throws Exception {
		if (isEmpty(str)) {
			return str;
		} else {
			String res = session.getTextService().getTextValue(str);
			return !isEmpty(res) ? res : str;
		}
	}
	public static TCComponent[] query(TCSession session, String queryName, String[] keys, String[] vals)
			throws Exception {
		System.out.println("Query: " + queryName);
		System.out.println("keys = " + Arrays.toString(keys));
		System.out.println("vals = " + Arrays.toString(vals));
		TCComponentQueryType queryType = (TCComponentQueryType) session.getTypeComponent("ImanQuery");
		TCComponentQuery query = (TCComponentQuery) queryType.find(queryName);
		if (query == null) {
			System.out.println("null"+queryName);
		} else {
			query.clearCache();
			query.refresh();
			return query.execute(keys, vals);
		}
		return null;
	}
//	@Override
//	public void insertUpdate(DocumentEvent e) {
//		// TODO Auto-generated method stub
//		
//	}
//	@Override
//	public void removeUpdate(DocumentEvent e) {
//		// TODO Auto-generated method stub
//		
//	}
//	@Override
//	public void changedUpdate(DocumentEvent e) {
//		// TODO Auto-generated method stub
//		
//	}
}
