package com.connor.zf.zygyk;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Array;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.UUID;

import javax.xml.crypto.Data;

import com.connor.zf.controlplan.SqlUtilT;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFCommand;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.commands.reserve.ReserveOperation;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentICO;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentMEOPRevision;
import com.teamcenter.rac.kernel.TCComponentMEProcess;
import com.teamcenter.rac.kernel.TCComponentMEProcessRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSKeyLov;
import com.teamcenter.rac.kernel.ics.ICSProperty;
import com.teamcenter.rac.kernel.ics.ICSPropertyDescription;
import com.teamcenter.rac.util.MessageBox;

public class ZYGYKCommand extends AbstractAIFCommand {

	private AbstractAIFApplication app;
	private TCSession session;
	private InterfaceAIFComponent comp;
	private boolean isReImport=true;//Ƿµ룬µtrueôݾʹӿƼƻȡfalseݴϸ汾̳
	private TCComponentItemRevision meop = null;
	public ZYGYKCommand(AbstractAIFApplication app, TCSession session,
			InterfaceAIFComponent comp,boolean isReImport) {
		// TODO Auto-generated constructor stub
		this.session = session;
		this.app = app;
		this.comp = comp;
		this.isReImport=isReImport;
	}

	@Override
	public void executeModal() throws Exception {
		//жǷǩ
		if(((TCComponent) comp).isCheckedOut()) {
			MessageBox.post("ҵտڱ༭(ǩ)", "", MessageBox.ERROR);
			return;
		}
		//ûǩڴʱǩ
		new ReserveOperation(new AIFComponentContext(comp,
					comp, "context")).executeModeless();
		
		TCComponentItemRevision itemRevision = (TCComponentItemRevision) this.comp;
		
		
		
		//жǷ°汾
		ResultSet rs0 = null;
		ResultSet rs1 = null;
		ResultSet rs2 = null;
		InputStream input = null;
		SqlUtilT.getTCConnection();
		input = new BufferedInputStream(getClass().getResourceAsStream(
				"/sql.properties"));
		Properties pro = new Properties();
		pro.load(input);
		TCComponent[] Revisions=itemRevision.getReferenceListProperty("revision_list");
		String revisionID=itemRevision.getProperty("item_revision_id");
		// ȡݿӡ
		SqlUtilT.getTCConnection();
		String sql0 = String.format(pro.getProperty("RB3_ZYGYKHEADSELECT"), comp.getUid());
		rs0 = SqlUtilT.read(sql0);
		
		SqlUtilT.getTCConnection();
		String sql1 = String.format(pro.getProperty("RB3_PRODUCTSELECT"), comp.getUid());
		rs1 = SqlUtilT.read(sql1);
		
		SqlUtilT.getTCConnection();
		String sql2 = String.format(pro.getProperty("RB3_PROCESSSELECT"), comp.getUid());
		rs2 = SqlUtilT.read(sql2);
		
		
					
		System.out.println("revisionID====>"+revisionID);
		System.out.println("Revisions====>"+Revisions);
		
		if(Revisions.length>1&&!rs0.next()&&!rs1.next()&&!rs2.next()&&!isReImport) {//µ򲻼̳
			System.out.println("ǵһ汾");
			List<String> addData0=new ArrayList<String>();
			List<List<String>> addData1=new ArrayList<List<String>>();
			List<List<String>> addData2=new ArrayList<List<String>>();
			
			char revID=revisionID.toCharArray()[0];
			String lastRevID="";
			String flagTime = "2008-10-01 14:42:32";
			SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			Date lastRevData = (Date) format.parse(flagTime);
			String lastRevUid="";
			for(TCComponent rev:Revisions) {
				if(rev.getProperty("release_status_list")!="") {
					if(lastRevData.before(rev.getDateProperty("date_released"))) {
						lastRevData=(Date) rev.getDateProperty("date_released");
						lastRevUid=rev.getUid();
						lastRevID=rev.getProperty("item_revision_id");
					}
				}
//				if(rev.getProperty("item_revision_id").equals(lastRevID)) {
//					lastRevUid=rev.getUid();
//					break;
//				}
			}
			System.out.println("lastRevID========>"+lastRevID);
			System.out.println("lastRevUid========>"+lastRevUid);
			
			
			try {
				//ȡϸ汾ıͷ
				SqlUtilT.getTCConnection();
				sql0 = String.format(pro.getProperty("RB3_ZYGYKHEADSELECT"), lastRevUid);
				rs0 = SqlUtilT.read(sql0);
				
				sql1 = String.format(pro.getProperty("RB3_PRODUCTSELECT"), lastRevUid);
				rs1 = SqlUtilT.read(sql1);
				
				sql2 = String.format(pro.getProperty("RB3_PROCESSSELECT"), lastRevUid);
				rs2 = SqlUtilT.read(sql2);
				
				while(rs0.next()) {
					addData0.add(UUID.randomUUID().toString().replace("-", ""));
					addData0.add(itemRevision.getUid());
					addData0.add(rs0.getString("GYKLX"));
					addData0.add(rs0.getString("CPXH"));
					addData0.add(rs0.getString("GXMC"));
					addData0.add(rs0.getString("SLYSGG"));
					addData0.add(rs0.getString("SLYSCZ"));
					addData0.add(rs0.getString("SBXH"));
					addData0.add(rs0.getString("CHSBXH"));
					addData0.add(rs0.getString("YHSBXH"));
					addData0.add(rs0.getString("DJDPXH"));
					addData0.add(rs0.getString("LJMC"));
				}
				
				
				
				while(rs1.next()) {
					List<String> dataList=new ArrayList<String>();
					dataList.add(UUID.randomUUID().toString().replace("-", ""));
					dataList.add(itemRevision.getUid());
					dataList.add(rs1.getString("NO"));
					dataList.add(rs1.getString("JCXM"));
					dataList.add(rs1.getString("ZYD"));
					dataList.add(rs1.getString("YQ"));
					dataList.add(rs1.getString("JCFF"));//5
					dataList.add(rs1.getString("SJ1"));
					dataList.add(rs1.getString("ZJPC"));
					dataList.add(rs1.getString("SJ2"));
					dataList.add(rs1.getString("JYPC"));
					dataList.add(rs1.getString("FYJH"));//10
					addData1.add(dataList);
				}
				
				while(rs2.next()) {
					List<String> dataList=new ArrayList<String>();
					dataList.add(UUID.randomUUID().toString().replace("-", ""));
					dataList.add(itemRevision.getUid());
					dataList.add(rs2.getString("NO"));
					dataList.add(rs2.getString("JCXM"));
					dataList.add(rs2.getString("ZYD"));
					dataList.add(rs2.getString("YQ"));
					dataList.add(rs2.getString("JCFF"));//5
					dataList.add(rs2.getString("RL"));
					dataList.add(rs2.getString("PL"));
					dataList.add(rs2.getString("FYJH"));
					addData2.add(dataList);
				}
				
			System.out.println("°汾1ݣ"+addData1);
			System.out.println("°汾2ݣ"+addData2);
			
			//1
			System.out.println("--------1-----------");
			System.out.println("addData1===>"+addData1);
			for(int i=0;i<addData1.size();i++) {
				List<String> dataList=new ArrayList<String>();
				dataList=addData1.get(i);
				String[] data=dataList.toArray(new String[]{});
				String insertSQL = pro.getProperty("RB3_PRODUCTINSERT");
				SqlUtilT.getTCConnection();
				SqlUtilT.write2(data, insertSQL);
				
			}
			SqlUtilT.connection.commit();
			//2
			System.out.println("--------2-----------");
			System.out.println("addData2===>"+addData2);
			for(int i=0;i<addData2.size();i++) {
				List<String> dataList=new ArrayList<String>();
				dataList=addData2.get(i);
				String[] data=dataList.toArray(new String[]{});
				String insertSQL = pro.getProperty("RB3_PROCESSINSERT");
				SqlUtilT.getTCConnection();
				SqlUtilT.write2(data, insertSQL);
				
			}
			SqlUtilT.connection.commit();
			
			
			//ͷ
			System.out.println("--------ͷ-----------");
			System.out.println("addData0===>"+addData0);
			String[] data=addData0.toArray(new String[]{});
			System.out.println("data===>"+Arrays.toString(data));
			String insertSQL = "insert into ZF6_ZYGYKHEAD values(?,?,?,?,?,?,?,?,?,?,?,?)";
			SqlUtilT.write2(data, insertSQL);
			SqlUtilT.connection.commit();//ύ
			
			
			
			
			}catch (Exception e) {
				MessageBox.post(e.toString(), "", MessageBox.ERROR);
				e.printStackTrace();
			}finally {
				if (rs0 != null) {
					SqlUtilT.free(rs0);
				}
				if (rs1 != null) {
					SqlUtilT.free(rs1);
				}
				if (rs2 != null) {
					SqlUtilT.free(rs2);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
			}
		}

		
		// TODO Auto-generated method stub
		// ѡжPUIDȡ
		final List<List<String>> productData = new ArrayList<List<String>>();
		final List<List<String>> processData = new ArrayList<List<String>>();
		final List<String> productPlmeidList = new ArrayList<String>();
		final List<String> processPlmeidList = new ArrayList<String>();
		
		final List<String> headList = new ArrayList<String>();//ͷ
		
		ResultSet rs = null;
		ResultSet machiningParameterRs = null;
		ResultSet controlRequirementRs = null;
		ResultSet headrs=null;
		try {
			// ȡݿ
			SqlUtilT.getTCConnection();
			String sql = String.format(pro.getProperty("RB3_PRODUCTSELECT"), comp.getUid());
			rs = SqlUtilT.read(sql);
			while (rs.next()) {
				List<String> rowList = new ArrayList<String>();
				rowList.add(rs.getString("PLMEID"));
				rowList.add(rs.getString("NO"));
				rowList.add(rs.getString("JCXM"));
				rowList.add(rs.getString("ZYD"));
				rowList.add(rs.getString("YQ"));
				rowList.add(rs.getString("JCFF"));
				rowList.add(rs.getString("SJ1"));
				rowList.add(rs.getString("ZJPC"));
				rowList.add(rs.getString("SJ2"));
				rowList.add(rs.getString("JYPC"));
				rowList.add(rs.getString("FYJH"));
				productData.add(rowList);
				productPlmeidList.add(rs.getString("PLMEID"));
			}
			SqlUtilT.getTCConnection();
			sql = String.format(pro.getProperty("RB3_PROCESSSELECT"), comp.getUid());
			machiningParameterRs = SqlUtilT.read(sql);
			while (machiningParameterRs.next()) {
				List<String> rowList = new ArrayList<String>();
				rowList.add(machiningParameterRs.getString("PLMEID"));
				rowList.add(machiningParameterRs.getString("NO"));
				rowList.add(machiningParameterRs.getString("JCXM"));
				rowList.add(machiningParameterRs.getString("ZYD"));		
				rowList.add(machiningParameterRs.getString("YQ"));
				rowList.add(machiningParameterRs.getString("JCFF"));
				rowList.add(machiningParameterRs.getString("RL"));
				rowList.add(machiningParameterRs.getString("PL"));
				rowList.add(machiningParameterRs.getString("FYJH"));		
				processData.add(rowList);
				processPlmeidList.add(machiningParameterRs.getString("PLMEID"));
			}
			
			sql = String.format(pro.getProperty("RB3_ZYGYKHEADSELECT"), comp.getUid());
			headrs = SqlUtilT.read(sql);
			while (headrs.next()) {
				headList.add(headrs.getString("PLMEID"));
				headList.add(headrs.getString("PUID"));
				headList.add(headrs.getString("GYKLX"));
				headList.add(headrs.getString("CPXH"));
				headList.add(headrs.getString("GXMC"));
				headList.add(headrs.getString("SLYSGG"));
				headList.add(headrs.getString("SLYSCZ"));
				headList.add(headrs.getString("SBXH"));
				headList.add(headrs.getString("CHSBXH"));
				headList.add(headrs.getString("YHSBXH"));
				headList.add(headrs.getString("DJDPXH"));
				headList.add(headrs.getString("LJMC"));
			}
			System.out.println("headList===>"+headList);
			if(headList.size()==0) {
				headList.add(UUID.randomUUID().toString().replace("-", ""));
				headList.add(comp.getUid());
				for(int i=0;i<10;i++) {
					headList.add("");
				}
				
				//ͷ
				String[] data=headList.toArray(new String[]{});
				System.out.println("data===>"+Arrays.toString(data));
				String insertSQL = "insert into ZF6_ZYGYKHEAD values(?,?,?,?,?,?,?,?,?,?,?,?)";
				SqlUtilT.write2(data, insertSQL);
				SqlUtilT.connection.commit();//ύ
			}
			
		} catch (Exception e) {
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
		} finally {
			if (rs != null) {
				SqlUtilT.free(rs);
			}
			if (machiningParameterRs != null) {
				SqlUtilT.free(machiningParameterRs);
			}
			if (controlRequirementRs != null) {
				SqlUtilT.free(controlRequirementRs);
			}
			if (headrs != null) {
				SqlUtilT.free(headrs);
			}
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}

		
		
		//ݵǰѡжȡ
		//TCComponentItemRevision itemRevision = (TCComponentItemRevision)comp;
		AIFComponentContext[] aifccs = itemRevision.whereReferenced();
		System.out.println("aifccs====>"+aifccs.toString());
		
		for (AIFComponentContext aifcc_MEOP : aifccs) {
			if (aifcc_MEOP.getComponent().getType().indexOf("ZF6_GXRevision")>=0) {
				meop = (TCComponentItemRevision)aifcc_MEOP.getComponent();
				break;
			}
		}
		
		
		//+++ȡտƼƻѡ°汾ݸҵտΪʼ
		if(productData.size()<=0&&processData.size()<=0)
		{
			//ȡ
			TCComponentItemRevision meprocess = null;
			System.out.println("meop===>"+meop);
			if(meop != null)
			{
				TCComponent[] its = meop.getItem().whereUsed(TCComponent.WHERE_USED_ALL);
				System.out.println("its===>"+its);
				for (TCComponent tcComponent : its) {
					System.out.println("tcComponent.gettype====>"+tcComponent.getType());
					if (tcComponent.getType().indexOf("ZF6_GYLXRevision")>=0) {
						meprocess = (TCComponentItemRevision)tcComponent;
						break;
					}
				}
			}
			System.out.println("meprocess===>"+meprocess);
			if(meprocess == null)
			{
				MessageBox.post("δҵգ", "", MessageBox.ERROR);
				return;
			}
			
			
			//String meprocessUid = meprocess.getItem().getUid();
			String meopId = meop.getItem().getStringProperty("item_id");
			//String itemType = getControlType((TCComponentItem)meprocess.getItem());
			
			
			TCComponent[] ControlComponents = meprocess.getReferenceListProperty("ZF6_R_KZJH");
			System.out.println("ControlComponents===>"+ControlComponents);
			System.out.println("ControlComponentslength===>"+ControlComponents.length);
			
			String controlUid="";
			for(int i=0;i<ControlComponents.length;i++) {
				if(ControlComponents[i].getType().indexOf("ZF6_KZJH") >= 0) {
					TCComponent[] ControlRevisions=ControlComponents[i].getReferenceListProperty("revision_list");
					
					controlUid=ControlRevisions[ControlRevisions.length-1].getUid();//ѡ°汾UID
				}
			}
			System.out.println("controlUid===>"+controlUid);
			//++++
			
			ResultSet rsData = null;
			try {
				// ȡݿ
				SqlUtilT.getTCConnection();
				input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
				
			
				String sql = String.format(pro.getProperty("RB3_CONTROLPLANTOGYK"), controlUid,meopId);
				rsData = SqlUtilT.read(sql);
				System.out.println("sql===========>"+sql);
				Integer rowIndexprocess = 0;
				Integer rowIndexproduct = 0;
				int flag=0;
				int sflag=0;
				int zflag=0;
				int xflag=0;
				int BH=1;
				
				
				Map<String,String> map=new HashMap<String,String>();
				Map<String,List<String>> maptoList=new HashMap<String,List<String>>();
				List<String> rowList = new ArrayList<String>();
				//String ss=rsData.toString();
				List<String> RowList = new ArrayList<String>();
				System.out.print("========>"+sql);
				while (rsData.next()) {
					System.out.println("rsData===>"+rsData.getString("CP"));
					System.out.println("rsData===>"+rsData.getString("GC"));
					if(!rsData.getString("CP").equals("")) {
						System.out.println("-----------ȡƷ-----------");
						//ȡƷԱ
						if(rsData.getString("XM").indexOf("׼")>=0) {
							if(map.size()>0) {
								
								rowList.set(6, map.get("Ա׼"));
								rowList.set(7, (map.get("ԼƵ")==null&& map.get("Ƶ").equals("ÿ"))?"ÿ":map.get("ԼƵ"));
								rowList.set(8, map.get("Ա׼"));
								rowList.set(9, map.get("Ƶ"));
								System.out.println("һ׼ʱռϸ===="+rowList);
								List<String> row = new ArrayList<String>();
								for(int i=0;i<rowList.size();i++) {
									row.add(rowList.get(i));
								}
								productData.add(row);
								System.out.println("productData"+productData);
								map.clear();
								rowList.clear();
							}
							
							//׼쿪ʼʱʼ
							rowIndexproduct++;
							rowList.add(UUID.randomUUID().toString().replace("-", ""));//0plmeid
							rowList.add(String.valueOf(rowIndexproduct));//1NO
							rowList.add(String.valueOf(rsData.getString("CP")));//2Ŀ
							rowList.add(String.valueOf(rsData.getString("TSTXFL")));//3Ҫ
							rowList.add(String.valueOf(rsData.getString("CPGC")));//4Ҫ
							rowList.add(String.valueOf(rsData.getString("JSCLJS")));//5鷽
							rowList.add(String.valueOf(""));//6Ա׼
							rowList.add(String.valueOf(""));//7ԼƵ
							rowList.add(String.valueOf(""));//8Ա׼
							rowList.add(String.valueOf(""));//9Ƶ
							rowList.add(String.valueOf(rsData.getString("FYJH")));//10Ӧƻ
							System.out.println("++++++++++ռԱ׼");
							map.put("Ա׼", rsData.getString("RL"));
						}else if(rsData.getString("XM").indexOf("Լ")>=0) {
							System.out.println("++++++++++ռԼƵ");
							map.put("ԼƵ", rsData.getString("RL")+"/"+rsData.getString("PL"));
						}else if(rsData.getString("XM").indexOf("Ѳ")>=0) {
							System.out.println("++++++++++ռԱ");
							map.put("Ա׼", rsData.getString("RL"));
							if(rsData.getString("PL").equals("ÿ")) {
								map.put("Ƶ", rsData.getString("PL"));
							}else {
								map.put("Ƶ", rsData.getString("RL")+"/"+rsData.getString("PL"));
							}
							
						}
//						if(map.size()==4) {
//							List<String> rowList = new ArrayList<String>();
//							rowList.add(UUID.randomUUID().toString().replace("-", ""));//0plmeid
//							rowList.add(String.valueOf(rowIndexproduct));//1NO
//							rowList.add(String.valueOf(rsData.getString("CP")));//2Ŀ
//							rowList.add(String.valueOf(rsData.getString("TSTXFL")));//3Ҫ
//							rowList.add(String.valueOf(rsData.getString("CPGC")));//4Ҫ
//							rowList.add(String.valueOf(rsData.getString("JSCLJS")));//5鷽
//							rowList.add(String.valueOf(map.get("Ա׼")));//6Ա׼
//							rowList.add(String.valueOf(map.get("ԼƵ")));//7ԼƵ
//							rowList.add(String.valueOf(map.get("Ա׼")));//8Ա׼
//							rowList.add(String.valueOf(map.get("Ƶ")));//9Ƶ
//							rowList.add(String.valueOf(rsData.getString("FYJH")));//10Ӧƻ
//							productData.add(rowList);
//							
//							map.clear();
//							rowIndexproduct++;
//						}
					}else if(!rsData.getString("GC").equals("")) {
						System.out.println("-----------ȡ-----------");
						if(map.size()>0) {
							
							rowList.set(6, map.get("Ա׼"));
							rowList.set(7, map.get("ԼƵ"));
							rowList.set(8, map.get("Ա׼"));
							rowList.set(9, map.get("Ƶ"));
							System.out.println("===>ռʣƷݣ"+rowList);
							List<String> row = new ArrayList<String>();
							for(int i=0;i<rowList.size();i++) {
								row.add(rowList.get(i));
							}
							productData.add(row);
							System.out.println("productData"+productData);
							map.clear();
							rowList.clear();
							
						}
						//ȡԱ
						rowIndexprocess++;
						List<String> rowLists = new ArrayList<String>();
						rowLists.add(UUID.randomUUID().toString().replace("-", ""));//0plmeid
						rowLists.add(String.valueOf(rowIndexprocess));//1NO
						rowLists.add(String.valueOf(rsData.getString("GC")));//2Ŀ
						rowLists.add(String.valueOf(rsData.getString("TSTXFL")));//3Ҫ
						rowLists.add(String.valueOf(rsData.getString("CPGC")));//4Ҫ
						rowLists.add(String.valueOf(rsData.getString("JSCLJS")));//5鷽
						rowLists.add(String.valueOf(rsData.getString("RL")));//6
						rowLists.add(String.valueOf(rsData.getString("PL")));//7Ƶ
						rowLists.add(String.valueOf(rsData.getString("FYJH")));//8Ӧƻ
						processData.add(rowLists);
						
						
					}
					
					
					
				}
				if(map.size()>0) {
					System.out.println("-------ռ-------");
					
					rowList.set(6, map.get("Ա׼"));
					rowList.set(7, map.get("ԼƵ"));
					rowList.set(8, map.get("Ա׼"));
					rowList.set(9, map.get("Ƶ"));
					System.out.println("rowList====>"+rowList);
					List<String> row = new ArrayList<String>();
					for(int i=0;i<rowList.size();i++) {
						row.add(rowList.get(i));
					}
					productData.add(row);
					System.out.println("productData"+productData);
					map.clear();
					rowList.clear();
					
				}

		
			} catch (Exception e) {
				MessageBox.post(e.toString(), "", MessageBox.ERROR);
				e.printStackTrace();
			} finally {
				if (rsData != null) {
					SqlUtilT.free(rsData);
				}
				if (input != null) {
					try {
						input.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				SqlUtilT.freeAll();
			}
		
	}
		
		
System.out.println("productData======>"+productData);
		new Thread() {
			@Override
			public void run() {
				new ZYGYKDialog(app, session, comp, meop,productData, processData,productPlmeidList, processPlmeidList,
						headList);
				super.run();
			}
		}.start();
		super.executeModal();
	}

	
	
	
	
	/**
	 * ȡµĿƼƻ
	 * @param item2 ѡеĹ
	 * @return
	 * @throws Exception
	 */
	private String getControlType(TCComponentItem tccmep) throws Exception {
		String kzjhType = null;

		AIFComponentContext[] tccmepChildrens = tccmep.getChildren();
		for (AIFComponentContext tccmepChildren : tccmepChildrens) {
			if (tccmepChildren.getComponent() instanceof TCComponentItem) {
				TCComponentItem kzjh = (TCComponentItem) tccmepChildren.getComponent();
				String itemType = kzjh.getType();
				System.out.println("kzjh=========================>"+kzjh);
				if ("RB3_SCKZJH".equals(itemType))
				{
					//жǷΪƼƻ
					return itemType;
				}
				
				if ("RB3_SSCKZJH".equals(itemType))
				{
					return itemType;
				}
					
				if ("RB3_YJKZJH".equals(itemType))
				{
					return itemType;
				}
			}
		}
		return kzjhType;
	}
	
	
	//+++LOVֵʱȡֵֻţǶӦֵ
//	TCComponentICO[] icos = item.getClassificationObjects();//ȡ
//	if (icos.length <= 0) {
//		continue;
//	}
//	ICSProperty[] icsValues = icos[0].getICSProperties(true);//ȡԵֵ
//	ICSPropertyDescription[] icsDNames = icos[0].getICSPropertyDescriptors();//ȡԵ
//	for (ICSPropertyDescription icsName : icsDNames) {
//		//ȡװ
//		if (icsName.getName().indexOf("װ") >= 0 || icsName.getName().indexOf("") >= 0||icsName.getName().indexOf("ɰ״") >= 0||icsName.getName().indexOf("ʯ״") >= 0) {
//			String value ="";
//			for (ICSProperty icsValue : icsValues) {
//				if (icsValue.getId() == icsName.getId()) {
//					if(ClassID.substring(0,2).equals("13")) {
//						//ȡlovֵicsValueicsValue.getValue()ȡֵѡʱgetValueȡֻ˳ţֻͨgetClassDisplayableValueȡ
//						value = getClassDisplayableValue(icsValue.getValue(),icsName);
//					}else {
//						value = icsValue.getValue();
//					}
//				}
//			}
//			values[0] = value;
//		}
	
	
	
	/**
	   * ȡLOVʾֵ
	   * +++keyţȡţkey͵ֵvalueƥ䣬getValueOfKey(key)ԵStringֵ
	   * @param icsD
	   * @return
	   */
	 public static String getClassDisplayableValue(String value ,ICSPropertyDescription icsD)
	  {
	   String result = "";
	   ICSKeyLov lov1 = icsD.getFormat().getKeyLov();
	   if (lov1 != null) {
	    String[] keys = lov1.getKeys();
	    for (String key : keys) {
	     if(value.equals(key))
	     {
	      result = lov1.getValueOfKey(key);
	      return result;
	     }
	    }
	   }
	   return result;
	  }
	
}
