package com.connor.zf.zygyk;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.Properties;

import com.connor.zf.controlplan.SqlUtilT;
import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFOperation;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentUser;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;

public class ZYGYKOperation extends AbstractAIFOperation {

	private AbstractAIFApplication app;
	private TCSession session;
	private InterfaceAIFComponent comp;
	private TCComponent form;
	private TCProperty[] properties;
	private List<String> valueList;

	private List<List<String>> productData;
	private List<List<String>> processData;

	private List<String> productPlmeidList;
	private List<String> processPlmeidList;

	private List<String> productDeleteList;
	private List<String> processDeleteList;

	public ZYGYKOperation(AbstractAIFApplication app, TCSession session,
			InterfaceAIFComponent comp, List<List<String>> productData, List<List<String>> processData,
			List<String> productPlmeidList,List<String> processPlmeidList, 
			List<String> productDeleteList, List<String> processDeleteList,
			List<String> valueList) {
		// TODO Auto-generated constructor stub
		this.app = app;
		this.session = session;
		this.comp = comp;
		this.productData = productData;
		this.processData = processData;
		this.productPlmeidList = productPlmeidList;
		this.processPlmeidList = processPlmeidList;
		this.productDeleteList = productDeleteList;
		this.processDeleteList = processDeleteList;
		this.valueList = valueList;
	}

	@Override
	public void executeOperation() throws Exception {
		// TODO Auto-generated method stub
		// 
		InputStream input = null;
		try {
//			// 
//			// жǷǰ汾
//			String userName = ((TCComponentItemRevision) this.comp).getReferenceProperty("owning_user")
//					.getStringProperty("user_id");
//			TCComponentUser user = session.getUser();
//			if (user.getUserId().equals(userName)) {
//				// TMomMethodUtil.setByPass(session, true);
//				this.form.lock();
//				this.properties[0].setStringValue(this.valueList.get(0));
//				this.properties[1].setStringValue(this.valueList.get(1));
//				this.properties[2].setStringValue(this.valueList.get(2));
//				this.properties[3].setStringValue(this.valueList.get(3));
//				this.properties[4].setStringValue(this.valueList.get(4));
//				this.form.save();
//				this.form.unlock();
//				this.form.refresh();
//			}

			// ȡSQL
			input = new BufferedInputStream(getClass().getResourceAsStream("/sql.properties"));
			Properties pro = new Properties();
			pro.load(input);

			//±ͷ
			String headupdateSQL = String.format(pro.getProperty("RB3_ZYGYKHEADUPDATE"), valueList.get(0),comp.getUid());
			System.out.println("headupdateSQL===>"+headupdateSQL);
			System.out.println("valueList+++++>"+valueList);
			SqlUtilT.getTCConnection();
			SqlUtilT.update(new String[] { valueList.get(2), valueList.get(3), valueList.get(4),valueList.get(5),
					valueList.get(6), valueList.get(7), valueList.get(8), valueList.get(9),valueList.get(10),valueList.get(11)},
					headupdateSQL);
			
			// ɾ
			for (int i = 0; i < this.productDeleteList.size(); i++) {
				// ȡݿ
				String deleteSQL = String.format(pro.getProperty("RB3_PRODUCTDELETE"),
						productDeleteList.get(i),comp.getUid());
				SqlUtilT.getTCConnection();
				SqlUtilT.delete(deleteSQL);
				SqlUtilT.freeAll();
			}
			for (int i = 0; i < this.processDeleteList.size(); i++) {
				// ȡݿ
				String deleteSQL = String.format(pro.getProperty("RB3_PROCESSDELETE"),
						processDeleteList.get(i),comp.getUid());
				SqlUtilT.getTCConnection();
				SqlUtilT.delete(deleteSQL);
				SqlUtilT.freeAll();
			}

			// ȡݿ
			SqlUtilT.getTCConnection();

			for (int i = 0; i < productData.size(); i++) {
				List<String> rowList = productData.get(i);

				if (rowList.get(0) != null && !rowList.get(0).equals("")
						&& productPlmeidList.contains(rowList.get(0))) {
					// ȡݿ
					String updateSQL = String.format(pro.getProperty("RB3_PRODUCTUPDATE"), rowList.get(0),comp.getUid());
					SqlUtilT.getTCConnection();
					SqlUtilT.update(new String[] { rowList.get(1), rowList.get(2), rowList.get(3), rowList.get(4),rowList.get(5),
							rowList.get(6), rowList.get(7), rowList.get(8), rowList.get(9),rowList.get(10)},
							updateSQL);
				} else {
					String insertSQL = pro.getProperty("RB3_PRODUCTINSERT");
					SqlUtilT.getTCConnection();
					SqlUtilT.write2(new String[] { rowList.get(0), comp.getUid(), rowList.get(1), rowList.get(2),
							rowList.get(3), rowList.get(4),rowList.get(5),
							rowList.get(6), rowList.get(7), rowList.get(8), rowList.get(9),rowList.get(10) }, insertSQL);
				}

			}

			for (int i = 0; i < processData.size(); i++) {
				List<String> rowList = processData.get(i);

				if (rowList.get(0) != null && !rowList.get(0).equals("")
						&&processPlmeidList.contains(rowList.get(0))) {
					// ȡݿ
					String updateSQL = String.format(pro.getProperty("RB3_PROCESSUPDATE"), rowList.get(0),comp.getUid());
					SqlUtilT.getTCConnection();
					SqlUtilT.update(new String[] { rowList.get(1), rowList.get(2), rowList.get(3), rowList.get(4),
							rowList.get(5), rowList.get(6), rowList.get(7), rowList.get(8) },
							updateSQL);
				} else {
					String insertSQL = pro.getProperty("RB3_PROCESSINSERT");
					SqlUtilT.getTCConnection();
					SqlUtilT.write2(new String[] { rowList.get(0), comp.getUid(), rowList.get(1), rowList.get(2),
							rowList.get(3), rowList.get(4),rowList.get(5), rowList.get(6),
							rowList.get(7), rowList.get(8) }, insertSQL);
				}

			}

			
			SqlUtilT.connection.commit();
			input.close();
		} catch (Exception e) {
			// TODO: handle exception
			MessageBox.post(e.toString(), "", MessageBox.ERROR);
			e.printStackTrace();
			throw e;
		} finally {
			if (input != null) {
				try {
					input.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			SqlUtilT.freeAll();
		}

	}

}
