package com.connor.renben.process.plm.util;

import java.awt.Graphics;

import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.HeadlessException;
import java.awt.Image;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.tree.DefaultMutableTreeNode;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.SpreadsheetVersion;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellValue;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Name;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.AreaReference;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.ss.util.CellReference;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFClientAnchor;
import org.apache.poi.xssf.usermodel.XSSFDrawing;
import org.apache.poi.xssf.usermodel.XSSFFont;
import org.apache.poi.xssf.usermodel.XSSFFormulaEvaluator;
import org.apache.poi.xssf.usermodel.XSSFName;
import org.apache.poi.xssf.usermodel.XSSFRichTextString;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentDatasetType;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCProperty;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.FileUtility;
import com.teamcenter.rac.util.MessageBox;

/**
 * Excel Toolling
 * 
 * @author hub 2015-09-06
 */
public class ExcelUtil07 {
	// private static Registry reg = Registry.getRegistry(this);
	// private static XSSFSheet sheet;
	// private static final int MY_ROWS = 46;
	private static Map<int[], int[]> map = new HashMap<int[], int[]>();
	private static final String EXCEL_XLS = "xls";
	private static final String EXCEL_XLSX = "xlsx";

	
	public static  String getID(String ID) {
		if(ID.indexOf("-")>-1) {
			String[] iDs=ID.split("-");
			String id="";
			for(int i=0;i<iDs.length-1;i++) {
				if(i==0) {
					id=iDs[i];
				}else {
					id=id+"-"+iDs[i];
				}
			}
			return id;
		}else {
			return ID;
		}
	}
	/**
	 * ȡEXCEL
	 * 
	 * @param File excel_file
	 * @return List<List<String>> صϢ
	 * @throws IOException
	 * @throws FileNotFoundException
	 */
//	public static List<List<String>> readExcel(File excel_file) throws FileNotFoundException, IOException {
//		if (excel_file == null || !excel_file.exists()) {
//			return null;
//		}
//		// صееϢ
//		List<List<String>> lines_msg = new ArrayList<List<String>>();
//		XSSFWorkbook workBook = new XSSFWorkbook(new FileInputStream(excel_file));
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(workBook);
//		XSSFSheet sheet = workBook.getSheetAt(0);
//		XSSFRow title_row = sheet.getRow(0);
//
//		// õеĿ
//		int col_count = title_row.getPhysicalNumberOfCells();
//		System.out.println(" SHEET COL COUNT " + col_count);
//		// õеĿ
//		int row_count = sheet.getLastRowNum();
//		System.out.println(" SHEET ROW COUNT " + row_count);
//		for (int j = 0; j < row_count + 1; j++) {
//			// صеϢ
//			XSSFRow row = sheet.getRow(j);
//			List<String> line_msg = new ArrayList<String>();
//			for (int i = 0; i < col_count; i++) {
//				String value = getStringCellValue(evaluator, row.getCell((short) i));
//				line_msg.add(value);
//			}
//			lines_msg.add(line_msg);
//		}
//		// insertRow(sheet,4,1);
//		return lines_msg;
//	}
//
//	/**
//	 * ȡƼƻEXCEL
//	 * 
//	 * @param File excel_file
//	 * @return List<List<String>> صϢ
//	 * @throws IOException
//	 * @throws FileNotFoundException
//	 */
//	public static List<List<String>> readControlPlanExcel(File excel_file) throws FileNotFoundException, IOException {
//		if (excel_file == null || !excel_file.exists()) {
//			return null;
//		}
//		// صееϢ
//		List<List<String>> lines_msg = new ArrayList<List<String>>();
//		XSSFWorkbook workBook = new XSSFWorkbook(new FileInputStream(excel_file));
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(workBook);
//		XSSFSheet sheet = workBook.getSheetAt(0);
//		XSSFRow title_row = sheet.getRow(0);
//		int startRow = 9;
//		// ȡϲԪ
//		Map<int[], int[]> regionCellMap = getRegionCell(sheet);
//
//		// õеĿ
//		int col_count = title_row.getPhysicalNumberOfCells();
//		System.out.println(" SHEET COL COUNT " + col_count);
//		// õеĿ
//		int row_count = sheet.getLastRowNum();
//		System.out.println(" SHEET ROW COUNT " + row_count);
//		for (int j = startRow; j < row_count + 1; j++) {
//			// صеϢ
//			XSSFRow row = sheet.getRow(j);
//			List<String> line_msg = new ArrayList<String>();
//			for (int i = 0; i < 15; i++) {
//				if(i== 5 || i == 10)
//				{
//					continue;
//				}
//				String value = getStringCellValue(evaluator, row.getCell((short) i));
//				if (value == null || value.equals("")) {
//					line_msg.add(getRegionValue(workBook, sheet, j, i));
//				} else {
//					line_msg.add(value);
//				}
//			}
//			// к
//			line_msg.add(((Integer) (j - startRow)).toString());
//			// ϲԪ
//			line_msg.add(toControlPlanRegionCell(regionCellMap, j));
//			if (line_msg.get(0) != null) {
//				lines_msg.add(line_msg);
//			}
//		}
//		// insertRow(sheet,4,1);
//		return lines_msg;
//	}
//
//	/**
//	 * ȡίEXCEL
//	 * 
//	 * @param File excel_file
//	 * @return List<List<String>> صϢ
//	 * @throws IOException
//	 * @throws FileNotFoundException
//	 */
//	public static List<List<String>> readEntrustingContentExcel(File excel_file)
//			throws FileNotFoundException, IOException {
//		if (excel_file == null || !excel_file.exists()) {
//			return null;
//		}
//		// صееϢ
//		List<List<String>> lines_msg = new ArrayList<List<String>>();
//		XSSFWorkbook workBook = new XSSFWorkbook(new FileInputStream(excel_file));
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(workBook);
//		XSSFSheet sheet = workBook.getSheetAt(0);
//		XSSFRow title_row = sheet.getRow(0);
//		int startRow = 0;
//		// ȡϲԪ
//		Map<int[], int[]> regionCellMap = getEntrustingContentRegionCell(sheet);
//
//		// õеĿ
//		int col_count = title_row.getPhysicalNumberOfCells();
//		System.out.println(" SHEET COL COUNT " + col_count);
//		// õеĿ
//		int row_count = sheet.getLastRowNum();
//		System.out.println(" SHEET ROW COUNT " + row_count);
//		for (int j = startRow; j < row_count + 1; j++) {
//			// صеϢ
//			XSSFRow row = sheet.getRow(j);
//			List<String> line_msg = new ArrayList<String>();
//			for (int i = 0; i < 3; i++) {
//				String value = getStringCellValue(evaluator, row.getCell((short) i));
//				if (value == null || value.equals("")) {
//					line_msg.add(getRegionValue(workBook, sheet, j, i));
//				} else {
//					line_msg.add(value);
//				}
//			}
//			// ϲԪ
//			line_msg.add(toEntrustingContentRegionCell(regionCellMap, j));
//			if (line_msg.get(0) != null) {
//				lines_msg.add(line_msg);
//			}
//		}
//		// insertRow(sheet,4,1);
//		return lines_msg;
//	}
//
//	public static void main(String[] args) {
//		try {
//			List<List<String>> strList = readExcel(new File("F:\\ConnorĿ\\Ŀ\\ϵͳ\\Ƽƻ\\Ƽƻģ3.xlsx"));
//			for (List<String> list : strList) {
//				for (String str : list) {
//					System.out.print(str + "|");
//				}
//				System.out.println();
//			}
//
//		} catch (FileNotFoundException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//	}
//
//	public void writeSignName(String intExcelFilePath, String outExcelFilePath, String signName, String msgValue,
//			int sheetIndex, int rowIndex, int cellIndex) throws IOException {
//		// ļ·
//		FileOutputStream outPut = new FileOutputStream(new File(outExcelFilePath));
//		// ļ·
//		FileInputStream inPut = new FileInputStream(new File(intExcelFilePath));
//		XSSFWorkbook wb = new XSSFWorkbook(inPut);
//		wb.getName("");
//		AreaReference[] areaR2 = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007 ,wb.getName("").getRefersToFormula());
//		AreaReference areaR = null;
//		CellReference[] cellR = areaR.getAllReferencedCells();
//		cellR[0].getSheetName();// s
//		cellR[0].getCol();//
//		cellR[0].getRow();//
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(wb);
//		XSSFSheet sheet = wb.getSheetAt(sheetIndex);
//		XSSFRow row = sheet.getRow(rowIndex);
//		XSSFCell cell = row.getCell(cellIndex);
//		String value = getStringCellValue(evaluator, cell);
//		if (value.startsWith(signName)) {
//			value = value.substring(0, signName.length());
//		}
//		cell.setCellValue(value + msgValue);
//		wb.write(outPut);
//		inPut.close();
//		outPut.close();
//	}

	/***
	 * д뵽EXCEL д뵥ݣ
	 * 
	 * @param xls_write_Address
	 * @param beanListAll
	 * @param sheetnames
	 * @throws IOException
	 */
	/*
	 * public void writeExcel(String xls_write_Address, String path,
	 * List<JFomPasteBean> beanListAll, int index) throws IOException {
	 * FileOutputStream output = new FileOutputStream(new File(path)); // ȡļ·
	 * FileInputStream input = new FileInputStream(new File(xls_write_Address));
	 * XSSFWorkbook wb = new XSSFWorkbook(input);// (new XSSFSheet sheet =
	 * wb.getSheetAt(0); for (int i = 0; i < beanListAll.size(); i++) {
	 * JFomPasteBean bean = beanListAll.get(i); XSSFRow row = null; Boolean isCreat
	 * = false; if ((i + 3) > sheet.getLastRowNum()) { row = sheet.createRow(i + 3);
	 * isCreat = true; } else { row = sheet.getRow(i + 3); isCreat = false; }
	 * 
	 * for (int cols = 0; cols < 7; cols++) { XSSFCell cell = null; if (isCreat) {
	 * cell = row.createCell(cols); } else { cell = row.getCell(cols); }
	 * cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ switch (cols) {
	 * 
	 * case 0: cell.setCellValue(bean.getIndexStr());// д break; case 1:
	 * cell.setCellValue(bean.getProductName());// д break; case 2: //
	 * cell.setCellValue(bean.getPicturePath());// д insertPicture(wb, sheet,
	 * bean.getPicturePath(), (short) 2, (i + 3)); break; case 3:
	 * cell.setCellValue(bean.getDatasetName());// д break; case 4:
	 * cell.setCellValue(bean.getItemRevisionId());// д break; case 5:
	 * cell.setCellValue("");// д
	 * 
	 * break; case 6: // cell.setCellType(XSSFCell.CELL_TYPE_);// ıʽ
	 * cell.setCellValue(bean.getReleaseDateStr());// д break;
	 * 
	 * } } } // } wb.write(output); output.close(); input.close();
	 * System.out.println("-------WRITE EXCEL OVER-------"); }
	 */
	/**
	 * ȡԪ
	 * 
	 * @param wb
	 * @param cellName
	 * @return
	 * @throws IOException
	 */
//	public static String getNamedCellValue(XSSFWorkbook wb, String cellName) throws IOException {
//		String value = null;
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(wb);
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return "";
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007 ,name.getRefersToFormula());
//		if (areaRs != null)
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						XSSFSheet sheet = wb.getSheet(sheetName);
//						XSSFRow row = sheet.getRow(rowIndex);
//						XSSFCell cell = row.getCell(colIndex);
//						value = getStringCellValue(evaluator, cell);
//					}
//				}
//			}
//		return value;
//	}

//	/**
//	 * õԪ
//	 * 
//	 * @param wb
//	 * @param cellName
//	 * @return
//	 * @throws IOException
//	 */
//	public static void setNamedCellValue(XSSFWorkbook wb, String cellName, String cellValue) throws IOException {
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007 ,name.getRefersToFormula());
//		if (areaRs != null) {
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						XSSFSheet sheet = wb.getSheet(sheetName);
//						XSSFRow row = sheet.getRow(rowIndex);
//						XSSFCell cell = row.getCell(colIndex);
//						cell.setCellValue(cellValue);
//					}
//				}
//			}
//		}
//	}

	/**
	 * ͼƬָĵԪ
	 * 
	 * @param wb
	 * @param sheet1
	 * @param picPath
	 * @param colIndex
	 * @param rowIndex
	 */
//	public static void insertPicture(XSSFWorkbook wb, XSSFSheet sheet1, ImageIcon imageIcon, String cellName,
//			double columns, int rows) {
//
//		// ȰѶͼƬŵһByteArrayOutputStreamУԱByteArray
//		try {
//			if (imageIcon == null) {
//				return;
//			}
//			ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
//			ImageIO.write(toBufferedImage(imageIcon.getImage()), "jpg", byteArrayOut);
//			// ͼĶһsheetֻܻȡһһҪע㣩
//			XSSFDrawing patriarch = sheet1.createDrawingPatriarch();
//			// anchorҪͼƬ
//			XSSFName name = wb.getName(cellName);
//			if (name == null) {
//				return;
//			}
//			AreaReference[] areaRs = AreaReference.generateContiguous(SpreadsheetVersion.EXCEL2007 ,name.getRefersToFormula());
//			if (areaRs != null) {
//				for (AreaReference areaR : areaRs) {
//					CellReference[] cellRs = areaR.getAllReferencedCells();
//					if (cellRs != null) {
//						for (CellReference cellR : cellRs) {
//							String sheetName = cellR.getSheetName();
//							short colIndex = cellR.getCol();
//							int rowIndex = cellR.getRow();
//							XSSFSheet sheet = wb.getSheet(sheetName);
//							XSSFRow row = sheet.getRow(rowIndex);
//							XSSFClientAnchor anchor = new XSSFClientAnchor(13, 13, 0, 0, (short) colIndex, rowIndex,
//									(short) (colIndex + columns), rowIndex + rows);
//							anchor.setAnchorType(3);
//							// ͼƬ
//							patriarch.createPicture(anchor,
//									wb.addPicture(byteArrayOut.toByteArray(), XSSFWorkbook.PICTURE_TYPE_JPEG));
//						}
//					}
//				}
//			}
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//	}
//
//	/**
//	 * ImageתBufferedImage
//	 * 
//	 * @param image
//	 * @return
//	 */
//	public static BufferedImage toBufferedImage(Image image) {
//		if (image instanceof BufferedImage) {
//			return (BufferedImage) image;
//		}
//
//		// This code ensures that all the pixels in the image are loaded
//		image = new ImageIcon(image).getImage();
//
//		// Determine if the image has transparent pixels; for this method's
//		// implementation, see e661 Determining If an Image Has Transparent Pixels
//		// boolean hasAlpha = hasAlpha(image);
//
//		// Create a buffered image with a format that's compatible with the screen
//		BufferedImage bimage = null;
//		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
//		try {
//			// Determine the type of transparency of the new buffered image
//			int transparency = Transparency.OPAQUE;
//			/*
//			 * if (hasAlpha) { transparency = Transparency.BITMASK; }
//			 */
//
//			// Create the buffered image
//			GraphicsDevice gs = ge.getDefaultScreenDevice();
//			GraphicsConfiguration gc = gs.getDefaultConfiguration();
//			bimage = gc.createCompatibleImage(image.getWidth(null), image.getHeight(null), transparency);
//		} catch (HeadlessException e) {
//			// The system does not have a screen
//		}
//
//		if (bimage == null) {
//			// Create a buffered image using the default color model
//			int type = BufferedImage.TYPE_INT_RGB;
//			// int type = BufferedImage.TYPE_3BYTE_BGR;//by wang
//			/*
//			 * if (hasAlpha) { type = BufferedImage.TYPE_INT_ARGB; }
//			 */
//			bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
//		}
//
//		// Copy image to buffered image
//		Graphics g = bimage.createGraphics();
//
//		// Paint the image onto the buffered image
//		g.drawImage(image, 0, 0, null);
//		g.dispose();
//
//		return bimage;
//	}
//
//	/***
//	 * д뵽EXCEL д뵥ݣ
//	 * 
//	 * @param xls_write_Address
//	 * @param ls
//	 * @param sheetnames
//	 * @throws IOException
//	 */
//	public void writeExcel(String xls_write_Address, ArrayList<ArrayList> ls, String[] sheetnames) throws IOException {
//		FileOutputStream output = new FileOutputStream(new File(xls_write_Address)); // ȡļ·
//		XSSFWorkbook wb = new XSSFWorkbook();// (new
//												// BufferedInputStream(output));
//		for (int sn = 0; sn < ls.size(); sn++) {
//			XSSFSheet sheet = wb.createSheet(String.valueOf(sn));
//			wb.setSheetName(sn, sheetnames[sn]);
//			ArrayList<String[]> ls2 = ls.get(sn);
//			for (int i = 0; i < ls2.size(); i++) {
//				XSSFRow row = sheet.createRow(i);
//				String[] s = ls2.get(i);
//				for (int cols = 0; cols < s.length; cols++) {
//					XSSFCell cell = row.createCell(cols);
//					cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//					cell.setCellValue(s[cols]);// д
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//	}
//
//	/**
//	 * ݵԪҵԪ
//	 * 
//	 * @param inputFilePath
//	 * @param cellName
//	 * @return
//	 */
//	public static List<String> getExcelNamedCellValue(String inputFilePath, String[] cellNames) {
//		List<String> valueList = new ArrayList<String>();
//		if (!new File(inputFilePath).exists()) {
//			for (int i = 0; i < cellNames.length; i++)
//				valueList.add("");
//			return valueList;
//		}
//		try {
//			FileInputStream is = new FileInputStream(new File(inputFilePath));
//			XSSFWorkbook wb = new XSSFWorkbook(is);
//			for (String name : cellNames)
//				valueList.add(getNamedCellValue(wb, name));
//			is.close();
//		} catch (FileNotFoundException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		return valueList;
//	}
//
//	/**
//	 * Թ̱Ϣд
//	 * 
//	 * @param xls_write_Address
//	 * @param ls
//	 * @throws IOException
//	 */
//	/*
//	 * public static void writeExcel(String outPath, InputStream input,
//	 * List<JFomProjectChangeBean> beanListAll) throws IOException {
//	 * 
//	 * FileOutputStream output = new FileOutputStream(new File(outPath)); // ȡļ·
//	 * // FileInputStream input= new FileInputStream(); XSSFWorkbook wb = new
//	 * XSSFWorkbook(input);// (new XSSFSheet sheet = wb.getSheetAt(0); int startRow
//	 * = 2; for (int i = 0; i < beanListAll.size(); i++) { JFomProjectChangeBean
//	 * bean = beanListAll.get(i); XSSFRow row = null; Boolean isCreat = false; if
//	 * ((i + startRow) > sheet.getLastRowNum()) { row = sheet.createRow(i +
//	 * startRow); isCreat = true; } else { row = sheet.getRow(i + startRow); isCreat
//	 * = false; }
//	 * 
//	 * for (int cols = 0; cols < 12; cols++) { XSSFCell cell = null; if (isCreat) {
//	 * cell = row.createCell(cols); } else { cell = row.getCell(cols); }
//	 * cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ switch (cols) {
//	 * 
//	 * case 0: cell.setCellValue(bean.getIndexStr());// д break; case 1:
//	 * cell.setCellValue(bean.getECRCode());// д break; case 2:
//	 * cell.setCellValue(bean.getInternalCode());// д break; case 3:
//	 * cell.setCellValue(bean.getDrawingNo());// д break; case 4:
//	 * cell.setCellValue(bean.getPartStatus());// д break; case 5:
//	 * cell.setCellValue(bean.getInitiator());// д break; case 6:
//	 * cell.setCellValue(bean.getSureDate());// д break; case 7:
//	 * cell.setCellValue(bean.getChangeMsgBef());// д break; case 8:
//	 * cell.setCellValue(bean.getChangeMsg());// д break; case 9:
//	 * cell.setCellValue(bean.getChargePerson());// д break; case 10:
//	 * cell.setCellValue("");// д break; case 11: cell.setCellValue("");// д
//	 * break; } } } // } wb.write(output); output.close(); input.close();
//	 * System.out.println("-------WRITE EXCEL OVER-------"); }
//	 */
//	/**
//	 * õԪ
//	 * 
//	 * @param row1
//	 * @param index
//	 * @param str
//	 */
//	public static void setCellValue(XSSFRow row1, int index, String str) {
//		XSSFCell cell = row1.getCell(index);
//		cell.setCellType(XSSFCell.CELL_TYPE_STRING);
//		cell.setCellValue(str);
//	}
//
//	/**
//	 * õԪ
//	 * 
//	 * @param row1
//	 * @param index
//	 * @param str
//	 */
//	public static void setCellValue(Row row1, int index, String str) {
//		Cell cell = row1.getCell(index);
//		cell.setCellType(XSSFCell.CELL_TYPE_STRING);
//		cell.setCellValue(str);
//	}
//
//	/**
//	 * Թ̱Ϣд
//	 * 
//	 * @param xls_write_Address
//	 * @param ls
//	 * @throws IOException
//	 */
//	/*
//	 * public static void writeExcelBomExport(String outPath, InputStream input,
//	 * List<JFomBomExportBean> beanListAll, JFomBomExportProjBean projBean) throws
//	 * IOException {
//	 * 
//	 * FileOutputStream output = new FileOutputStream(new File(outPath)); // ȡļ·
//	 * // FileInputStream input= new FileInputStream(); XSSFWorkbook wb = new
//	 * XSSFWorkbook(input);// (new XSSFSheet sheet = wb.getSheetAt(0); int startRow
//	 * = 4; if (projBean != null) { XSSFRow row1 = sheet.getRow(0);
//	 * setCellValue(row1, 11, projBean.getPROJ_NAME()); setCellValue(row1, 14,
//	 * projBean.getPROJ_MODE()); setCellValue(row1, 16, projBean.getPRODUCT_LIFE());
//	 * row1 = sheet.getRow(1); setCellValue(row1, 11, projBean.getPROJ_CUSTOMER());
//	 * setCellValue(row1, 14, projBean.getPROJ_MEMBER()); } for (int i = 0; i <
//	 * beanListAll.size(); i++) { JFomBomExportBean bean = beanListAll.get(i);
//	 * XSSFRow row = null; Boolean isCreat = false; if ((i + startRow) >
//	 * sheet.getLastRowNum()) { row = sheet.createRow(i + startRow); isCreat = true;
//	 * } else { row = sheet.getRow(i + startRow); isCreat = false; }
//	 * 
//	 * for (int cols = 0; cols < 22; cols++) { XSSFCell cell = null; if (isCreat) {
//	 * cell = row.createCell(cols); } else { cell = row.getCell(cols); }
//	 * cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ int indexStr =
//	 * bean.getIndexStr(); if (cols == (indexStr + 1)) {
//	 * cell.setCellValue(JFomUtil.JF3_INDEX_STR);// д }
//	 * 
//	 * switch (cols) {
//	 * 
//	 * case 0: cell.setCellValue(bean.getIndexExt());// д break; case 7:
//	 * cell.setCellValue(bean.getWlNumber());// д break; case 8:
//	 * cell.setCellValue(bean.getMPS()); break; case 9:
//	 * cell.setCellValue(bean.getCustomerNo()); break; case 10:
//	 * cell.setCellValue(bean.getWlName()); break; case 11:
//	 * cell.setCellValue(bean.getK3code()); break; case 12: insertPicture(wb, sheet,
//	 * bean.getPicturePath(), (short) 14, i + startRow); break; case 13:
//	 * cell.setCellValue(bean.getMaterialName()); break; case 14:
//	 * cell.setCellValue(bean.getMaterialSize()); break; case 15:
//	 * cell.setCellValue(bean.getMaterialStander()); break; case 16:
//	 * cell.setCellValue(bean.getMaterialPark()); break; case 17:
//	 * cell.setCellValue(bean.getJingzhong()); break; case 18:
//	 * cell.setCellValue(bean.getMaozhong()); break; case 19:
//	 * cell.setCellValue(bean.getGongyi()); break; case 20:
//	 * cell.setCellValue(bean.getGongyingshang()); break; default: break; } } } // }
//	 * wb.write(output); output.close(); input.close();
//	 * System.out.println("-------WRITE EXCEL OVER-------"); }
//	 */
//	public static void insertPicture(XSSFWorkbook wb, XSSFSheet sheet1, String picPath, short colIndex, int rowIndex) {
//
//		// FileOutputStream fileOut = null;
//		BufferedImage bufferImg = null;
//		// ȰѶͼƬŵһByteArrayOutputStreamУԱByteArray
//		try {
//			if (!new File(picPath).exists()) {
//				return;
//			}
//			String dexStr = picPath.substring(picPath.lastIndexOf(".") + 1, picPath.length());
//			ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
//			System.out.println(picPath);
//			bufferImg = ImageIO.read(new File(picPath));
//			ImageIO.write(bufferImg, dexStr, byteArrayOut);
//			// XSSFWorkbook wb = new XSSFWorkbook();
//			// XSSFSheet sheet1 = wb.createSheet("test picture");
//			// ͼĶһsheetֻܻȡһһҪע㣩
//			XSSFDrawing patriarch = sheet1.createDrawingPatriarch();
//			// anchorҪͼƬ
//			XSSFClientAnchor anchor = new XSSFClientAnchor(13, 13, 0, 0, (short) colIndex, rowIndex,
//					(short) (colIndex + 1), rowIndex + 1);
//			anchor.setAnchorType(3);
//			// ͼƬ
//			patriarch.createPicture(anchor, wb.addPicture(byteArrayOut.toByteArray(), XSSFWorkbook.PICTURE_TYPE_JPEG));
//
//		} catch (Exception e) {
//			e.printStackTrace();
//		}
//
//	}
//	//ͼƬ
//	public static void CopyPic(File path1,String path2) {
//		// ļֽ
//        FileInputStream fis = null;
//        // ļֽ
//        FileOutputStream fos = null;
//
//        try {
//            // ļֽ
//            fis = new FileInputStream(path1);
//            // ļֽ
//            fos = new FileOutputStream(path2);
//
//            //׼һbyte[]飬洢ֽ룬СΪ1024ֽڣ1KB
//            byte[] bytes = new byte[1024];
//
//            int readCount = 0;
//            // ʼд
//            while ((readCount = fis.read(bytes)) != -1) {
//                // жֽд
//                fos.write(bytes, 0, readCount);
//            }
//
//            // ˢ¹ܵǿ
//            fos.flush();
//
//        } catch (FileNotFoundException e) {
//            e.printStackTrace();
//        } catch (IOException e) {
//            e.printStackTrace();
//        } finally {
//            if (fis != null) {
//                try {
//                    fis.close();
//                } catch (IOException e) {
//                    e.printStackTrace();
//                }
//            }
//            if (fos != null) {
//                try {
//                    fos.close();
//                } catch (IOException e) {
//                    e.printStackTrace();
//                }
//            }
//        }
//	}
//	
//	//
//	
//	
//
//	/**
//	 * ƳϲĵԪ ϲԪsheet.addMergedRegion(new CellRangeAddress(check_index-1,
//	 * check_index+12+check_rows, 0, 0));
//	 * 
//	 * @param startRow
//	 * @param endRow
//	 * @return
//	 */
//	public static boolean removeMergen(XSSFSheet sheet, int startRow, int endRow) {
//		boolean isOK = false;
//		int count = sheet.getNumMergedRegions();
//		for (int i = 0; i < count; i++) {
//			CellRangeAddress address = sheet.getMergedRegion(i);
//			System.out.println(address.getFirstRow() + "|" + address.getLastRow());
//			if (address.getFirstRow() == startRow && address.getLastRow() == endRow) {
//				sheet.removeMergedRegion(i);
//				isOK = true;
//				break;
//			}
//		}
//		return isOK;
//	}
//
//	/**
//	 * ϲԪsheet.addMergedRegion(new CellRangeAddress(check_index-1,
//	 * check_index+12+check_rows, 0, 0));
//	 * 
//	 * @param startRow
//	 * @param endRow
//	 * @return
//	 */
//	public static boolean combine(XSSFSheet sheet, int[] rows, int[] columns) {
//		boolean isOK = false;
//		if (rows.length > 0 && columns.length > 0) {
//			sheet.addMergedRegion(
//					new CellRangeAddress(rows[0], rows[rows.length - 1], columns[0], columns[columns.length - 1]));
//			isOK = true;
//		}
//		return isOK;
//	}
//
//	/**
//	 * ȡַ
//	 * 
//	 * @param inStr
//	 * @return
//	 */
//	public static String changeStringToInt(String inStr) {
//		int index = inStr.indexOf(".");
//		System.out.println(index);
//		String outStr = null;
//		if (index != -1) {
//
//			outStr = inStr.substring(0, index);
//		} else {
//			outStr = inStr;
//
//		}
//		// System.out.println(outStr);
//		return outStr;
//	}
//
//	/**
//	 * ȡһȵַ
//	 * 
//	 * @param inStr
//	 * @param inLen
//	 * @return
//	 */
//	public static String changeStringToInt(String inStr, int inLen) {
//		int index = inStr.indexOf(".");
//		inLen++;
//		System.out.println(index);
//		String outStr = null;
//		if (index != -1 && (inStr.length() - index) >= inLen) {
//
//			outStr = inStr.substring(0, index + inLen);
//		} else {
//			outStr = inStr;
//
//		}
//		// System.out.println(outStr);
//		return outStr;
//	}
//
//	/**
//	 * floatתɱλַ
//	 * 
//	 * @param f Ҫתfloat
//	 * @return
//	 */
//	public static String changeFloatToStr(float f) {
//		DecimalFormat decimalFormat = new DecimalFormat(".0");// 췽ַʽС2λ,0.
//		String str = decimalFormat.format(f);// format صַ
//		return str;
//	}
//
//	/**
//	 * ַתint
//	 * 
//	 * @param str
//	 * @return
//	 */
//	public static float changeStrToFloat(String str) {
//		float temp_int = 0;
//		try {
//			temp_int = Float.parseFloat(str.trim());
//			return temp_int;
//		} catch (NumberFormatException e) {
//			System.out.println(e.getMessage());
//			return -1;
//		}
//	}
//
//	/**
//	 * formualʱ滻ԭеĵԪŵµĵԪ
//	 * 
//	 * @param originStr
//	 * @param subStr
//	 * @param index
//	 * @param index2
//	 * @return
//	 */
//	public static String replaceSubString(String originStr, String subStr, int index, int index2) {
//		StringBuffer sbO = new StringBuffer();
//		sbO.append(subStr);
//		sbO.append(index);
//		StringBuffer sbR = new StringBuffer();
//		sbR.append(subStr);
//		sbR.append(index2);
//		String resultStr = originStr.replace(sbO.toString(), sbR.toString());
//		return resultStr;
//	}
//
//	/**
//	 * ȡEXCELϢ
//	 * 
//	 * @param String excel_file
//	 * @return List<List<String>> Ϣ
//	 * @throws IOException
//	 * @throws FileNotFoundException
//	 */
//	public static List<List<String>> readExcel(String excel_file) throws FileNotFoundException, IOException {
//		if (excel_file == null) {
//			return null;
//		}
//		File file = new File(excel_file);
//		// ȡEXCELݵľ߼ĺ
//		return readExcel(file);
//	}
//
//	/**
//	 * ȡҵָBean
//	 * 
//	 * @param result
//	 * @return
//	 */
//	public static List<CXBean> getCXBean(Map<Integer, List<String>> result) {
//		List<CXBean> cxBeans = new ArrayList<CXBean>();
//		for (Integer key : result.keySet()) {
//			CXBean cxBean = new CXBean();
//			cxBean.setNo((int) Float.parseFloat(result.get(key).get(3)));
//			cxBean.setJcxm((result.get(key).get(6)));
//			cxBean.setJsyq(result.get(key).get(9));
//			cxBean.setClqj((result.get(key).get(10)));
//			cxBean.setZjpc(result.get(key).get(11) + "&" + result.get(key).get(12));
//			if (result.get(key).contains("xj")) {
//				cxBean.setZjpc("");
//				cxBean.setXjpc(result.get(key).get(11) + "&" + result.get(key).get(12));
//			} else {
//				cxBean.setXjpc(result.get(key).get(result.get(key).size() - 2) + "&"
//						+ result.get(key).get(result.get(key).size() - 1));
//			}
//			cxBean.setTstx(result.get(key).get(8));
//			cxBean.setSj(true);
//			if (result.get(key).get(12).indexOf("ĩ") > -1) {
//				cxBean.setMj(true);
//			}
//			cxBeans.add(cxBean);
//		}
//		return cxBeans;
//	}
//
//	public static String combinationString(String s) {
//		String result = "";
//		List<String> sList = new ArrayList<String>();
//		List<String> sList2 = new ArrayList<String>();
//		if (s.indexOf("&") > -1) {
//			String[] ss = s.split("&");
//			if (ss[0].indexOf("/") > -1) {
//				String[] sss = ss[0].split("/");
//				for (int i = 0; i < sss.length; i++) {
//					sList.add(sss[i]);
//				}
//			} else {
//				sList.add(ss[0]);
//			}
//			if (ss[1].indexOf("/") > -1) {
//				String[] sss = ss[1].split("/");
//				for (int i = 0; i < sss.length; i++) {
//					sList2.add(sss[i]);
//				}
//			} else {
//				sList2.add(ss[1]);
//			}
//
//			if (sList.size() == sList2.size()) {
//				StringBuffer sb = new StringBuffer();
//				for (int i = 0; i < sList.size(); i++) {
//					sb.append(sList.get(i) + "/" + sList2.get(i) + "&");
//				}
//				if (sb != null && sb.length() != 0) {
//					result = sb.substring(0, sb.length() - 1);
//				}
//			}
//		}
//		return result;
//
//	}
//
//	/**
//	 * ȡƼƻϢ
//	 * 
//	 * @param String excel_file
//	 * @return List<List<String>> Ϣ
//	 * @throws IOException
//	 * @throws FileNotFoundException
//	 */
//	public static Map<Integer, List<String>> readExcel(String excel_file, String cellName)
//			throws FileNotFoundException, IOException {
//		if (excel_file == null) {
//			return null;
//		}
//		File file = new File(excel_file);
//		XSSFWorkbook xwb = new XSSFWorkbook(new FileInputStream(file));
//		Map<Integer, List<String>> result = new LinkedHashMap<Integer, List<String>>();
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(xwb);
//		XSSFSheet sheet = xwb.getSheetAt(0);
//		XSSFRow row;
//		String cell;
//		for (int i = sheet.getFirstRowNum(); i < sheet.getPhysicalNumberOfRows(); i = i + 2) {
//
//			row = sheet.getRow(i);
//			if (getRegionValue(xwb, sheet, i, 1).toString().equals(cellName)) {
//				List<String> rowValue = new ArrayList<String>();
//				int lastRow = getRegionIndex(sheet, i, 1, cellName);
//				for (int j = row.getFirstCellNum(); j < row.getLastCellNum(); j++) {
//					if (j == 10) {
//						continue;
//					}
//					if ((row.getCell(j) == null || row.getCell(j).toString().equals("")) && i <= lastRow) {
//						String s = getRegionValue(xwb, sheet, i, j);
//						if (s == null) {
//							cell = "";
//						} else {
//							if (j == 9) {
//								if (row.getCell(10) != null && !row.getCell(10).toString().equals("")) {
//									s = s + "/" + sheet.getRow(i - 1).getCell(10).toString() + "/"
//											+ row.getCell(10).toString();
//								}
//							}
//							cell = s;
//						}
//					} else {
//						cell = getStringCellValue(evaluator, row.getCell(j));
//					}
//					System.out.print(cell + ",");
//					rowValue.add(cell);
//				}
//				result.put((int) Float.parseFloat(rowValue.get(3)), rowValue);
//			}
//			System.out.println("**********************");
//		}
//		return result;
//	}
//
//	/**
//	 * ȡԪλ
//	 * 
//	 * @param wb
//	 * @param cellName
//	 * @return
//	 * @throws IOException
//	 */
//	public static int[] getNamedCellIndex(XSSFWorkbook wb, String cellName) throws IOException {
//		int[] index = new int[2];
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(wb);
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return null;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(name.getRefersToFormula());
//		if (areaRs != null) {
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						index[0] = cellR.getCol();
//						index[1] = cellR.getRow();
//						// colIndex = cellR.getCol();
//						// rowIndex = cellR.getRow();
//					}
//				}
//			}
//		}
//		return index;
//	}
//
//	/**
//	 * ȡԪ
//	 * 
//	 * @param wb
//	 * @param cellName
//	 * @return
//	 * @throws IOException
//	 */
//	public static int getNamedColumnIndex(XSSFWorkbook wb, String cellName) throws IOException {
//		int index = -1;
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(wb);
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return -1;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(name.getRefersToFormula());
//		if (areaRs != null)
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						XSSFSheet sheet = wb.getSheet(sheetName);
//						XSSFRow row = sheet.getRow(rowIndex);
//						return colIndex;
//					}
//				}
//			}
//		return index;
//	}
//
//	/**
//	 * ȡϲԪ
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @param cellIndex
//	 * @return
//	 */
//	public static String getRegionValue(XSSFWorkbook workbook, XSSFSheet sheet, int rowIndex, int cellIndex) {
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(workbook);
//		for (int i = 0; i < sheet.getNumMergedRegions(); i++) {
//			CellRangeAddress region = sheet.getMergedRegion(i);
//			int colIndex = region.getFirstColumn();
//			int lastColIndex = region.getLastColumn();
//			int rowNum = region.getFirstRow();
//			int lastRowNum = region.getLastRow();
//			// System.out.println(rowNum+"+++++++"+colIndex+"++++++++++"+lastRowNum+"++++++++++++"+lastColIndex);
//			if (rowIndex <= lastRowNum && rowIndex >= rowNum && cellIndex <= lastColIndex && cellIndex >= colIndex) {
//				return getStringCellValue(evaluator, sheet.getRow(rowNum).getCell((short) colIndex));
//			}
//		}
//		return null;
//	}
//
//	/**
//	 * ȡEXCELϲԪ
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @param cellIndex
//	 * @return
//	 */
//	public static Map<int[], int[]> getRegionCell(XSSFSheet sheet) {
//		Map<int[], int[]> regionCellMap = new HashMap<int[], int[]>();
//		for (int i = 0; i < sheet.getNumMergedRegions(); i++) {
//			CellRangeAddress region = sheet.getMergedRegion(i);
//			int colIndex = region.getFirstColumn();
//			int lastColIndex = region.getLastColumn();
//			int rowNum = region.getFirstRow();
//			int lastRowNum = region.getLastRow();
//			if (rowNum >= 13) {
//				// System.out.println(rowNum+"+++++++"+colIndex+"++++++++++"+lastRowNum+"++++++++++++"+lastColIndex);
//				// м
//				int[] rows = new int[lastRowNum - (rowNum - 1)];
//				// м
//				for (int j = 0; j < rows.length; j++) {
//					rows[j] = rowNum + j;
//				}
//				int[] columns = new int[lastColIndex - (colIndex - 1)];
//				for (int j = 0; j < columns.length; j++) {
//					columns[j] = colIndex + j + 1;
//				}
//				regionCellMap.put(rows, columns);
//			}
//		}
//		return regionCellMap;
//	}
//	
//	/**
//	 * ȡEXCELϲԪ
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @param cellIndex
//	 * @return
//	 */
//	public static Map<int[], int[]> getEntrustingContentRegionCell(XSSFSheet sheet) {
//		Map<int[], int[]> regionCellMap = new HashMap<int[], int[]>();
//		for (int i = 0; i < sheet.getNumMergedRegions(); i++) {
//			CellRangeAddress region = sheet.getMergedRegion(i);
//			int colIndex = region.getFirstColumn();
//			int lastColIndex = region.getLastColumn();
//			int rowNum = region.getFirstRow();
//			int lastRowNum = region.getLastRow();
//			if (rowNum >= 0) {
//				// System.out.println(rowNum+"+++++++"+colIndex+"++++++++++"+lastRowNum+"++++++++++++"+lastColIndex);
//				// м
//				int[] rows = new int[lastRowNum - (rowNum - 1)];
//				// м
//				for (int j = 0; j < rows.length; j++) {
//					rows[j] = rowNum + j;
//				}
//				int[] columns = new int[lastColIndex - (colIndex - 1)];
//				for (int j = 0; j < columns.length; j++) {
//					columns[j] = colIndex + j + 1;
//				}
//				regionCellMap.put(rows, columns);
//			}
//		}
//		return regionCellMap;
//	}
//
//	/**
//	 * תΪƼƻϲԪ
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @param cellIndex
//	 * @return
//	 */
//	public static String toControlPlanRegionCell(Map<int[], int[]> regionCell, int row) {
//		Iterator<Map.Entry<int[], int[]>> it = regionCell.entrySet().iterator();
//		StringBuffer sb = new StringBuffer();
//		while (it.hasNext()) {
//			Map.Entry<int[], int[]> entry = it.next();
//			StringBuffer rowSb = new StringBuffer();
//			StringBuffer columnSb = new StringBuffer();
//			for (int k = 0; k < entry.getKey().length; k++) {
//				rowSb.append(entry.getKey()[k] - 13);
//				rowSb.append(",");
//			}
//			for (int k = 0; k < entry.getValue().length; k++) {
//				columnSb.append(entry.getValue()[k]);
//				columnSb.append(",");
//			}
//			if (entry.getKey()[0] == row) {
//				sb.append(rowSb.substring(0, rowSb.length() - 1) + "/" + columnSb.substring(0, columnSb.length() - 1)
//						+ "-");
//			}
//		}
//		if (sb.length() > 0) {
//			return sb.toString().substring(0, sb.length() - 1);
//		} else {
//			return "";
//		}
//	}
//
//	/**
//	 * תΪίݺϲԪ
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @param cellIndex
//	 * @return
//	 */
//	public static String toEntrustingContentRegionCell(Map<int[], int[]> regionCell, int row) {
//		Iterator<Map.Entry<int[], int[]>> it = regionCell.entrySet().iterator();
//		StringBuffer sb = new StringBuffer();
//		while (it.hasNext()) {
//			Map.Entry<int[], int[]> entry = it.next();
//			StringBuffer rowSb = new StringBuffer();
//			StringBuffer columnSb = new StringBuffer();
//			for (int k = 0; k < entry.getKey().length; k++) {
//				rowSb.append(entry.getKey()[k]);
//				rowSb.append(",");
//			}
//			for (int k = 0; k < entry.getValue().length; k++) {
//				columnSb.append(entry.getValue()[k] - 1);
//				columnSb.append(",");
//			}
//			if (entry.getKey()[0] == row) {
//				sb.append(rowSb.substring(0, rowSb.length() - 1) + "/" + columnSb.substring(0, columnSb.length() - 1)
//						+ "-");
//			}
//		}
//		if (sb.length() > 0) {
//			return sb.toString().substring(0, sb.length() - 1);
//		} else {
//			return "";
//		}
//	}
//
//	/**
//	 * õԪָʽ
//	 * 
//	 * @param wb
//	 * @param s          
//	 * @param firstIndex ʼλ
//	 * @param lastIndex  λ
//	 * @param fontSize   С
//	 * @param FontName   ʽ
//	 * @return
//	 */
//	public static XSSFRichTextString setCellFont(XSSFWorkbook wb, String s, int firstIndex, int lastIndex, int fontSize,
//			String FontName) {
//		XSSFRichTextString ts = new XSSFRichTextString(s);
//		XSSFFont font1 = (XSSFFont) wb.createFont();
//		font1.setFontHeightInPoints((short) 8); // ߶
//		font1.setFontName(""); // 
//		// font1.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD); // 
//		XSSFFont font = (XSSFFont) wb.createFont();
//		font.setFontHeightInPoints((short) fontSize); // ߶
//		font.setFontName(FontName); // 
//		// font.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD); // 
//		ts.applyFont(firstIndex, lastIndex, font);
//		ts.applyFont(lastIndex, ts.length(), font1);
//		return ts;
//	}
//
//	/**
//	 * ȡԪС
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @param cellIndex
//	 * @param cellValue
//	 */
//	public static int getRegionIndex(XSSFSheet sheet, int rowIndex, int cellIndex, String cellValue) {
//		int lastRow = 0;
//		for (int i = 0; i < sheet.getNumMergedRegions(); i++) {
//			CellRangeAddress region = sheet.getMergedRegion(i);
//			int colIndex = region.getFirstColumn();
//			int lastColIndex = region.getLastColumn();
//			int rowNum = region.getFirstRow();
//			int lastRowNum = region.getLastRow();
//			if (sheet.getRow(rowNum).getCell(colIndex).toString().equals(cellValue)) {
//				lastRow = lastRowNum;
//			}
//		}
//		return lastRow;
//	}
//
//	/**
//	 * ȡԪΪַ͵
//	 * 
//	 * @param cell ExcelԪ
//	 * @return String Ԫ
//	 */
//	private static String getStringCellValue(XSSFFormulaEvaluator evaluator, XSSFCell cell) {
//		if (cell == null) {
//			return "";
//		}
//		String strCell = "";
//		switch (cell.getCellType()) {
//		case XSSFCell.CELL_TYPE_STRING:
//			strCell = cell.getStringCellValue();
//			break;
//		case XSSFCell.CELL_TYPE_NUMERIC:
//			// strCell = cell.getStringCellValue();
//			if (DateUtil.isCellDateFormatted(cell)) {
//				SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
//				Date date = cell.getDateCellValue();
//				if (date != null)
//					strCell = sdf.format(date);
//			} else {
//
//				strCell = "" + cell.getNumericCellValue();
//				if (strCell.endsWith(".0")) {
//					strCell = strCell.substring(0, strCell.indexOf(".0"));
//				}
//			}
//			break;
//		case XSSFCell.CELL_TYPE_BOOLEAN:
//			strCell = String.valueOf(cell.getBooleanCellValue());
//			break;
//		case XSSFCell.CELL_TYPE_BLANK:
//			strCell = "";
//			break;
//		case XSSFCell.CELL_TYPE_ERROR:
//			strCell = String.valueOf(cell.getErrorCellValue());
//			break;
//		case XSSFCell.CELL_TYPE_FORMULA:
//			CellValue value = evaluator.evaluate(cell);
//			try {
//				strCell = value.getStringValue();
//				if (strCell == null) {
//					strCell = "" + value.getNumberValue();
//					if (strCell.endsWith(".0")) {
//						strCell = strCell.substring(0, strCell.indexOf(".0"));
//					}
//				}
//			} catch (Exception e) {
//
//				strCell = "" + value.getNumberValue();
//				if (strCell.endsWith(".0")) {
//					strCell = strCell.substring(0, strCell.indexOf(".0"));
//				}
//			}
//			break;
//
//		default:
//			strCell = "";
//			break;
//		}
//		if (strCell.equals("") || strCell == null) {
//			return "";
//		}
//		// System.out.println(" === Type =" + cell.getCellType() + " Value =" +
//		// strCell);
//		return strCell;
//	}
//
//	/**
//	 * 
//	 * 
//	 * @param starRow
//	 * @param rows
//	 */
//	public static void insertRow(XSSFSheet sheet, int starRow, int rows) {
//		XSSFRow sourceRow = sheet.getRow(starRow);
//		sheet.shiftRows(starRow + 1, sheet.getLastRowNum(), rows, true, false);
//		for (int i = 0; i < rows; i++) {
//			XSSFRow targetRow = null;
//			XSSFCell sourceCell = null;
//			XSSFCell targetCell = null;
//			short m;
//			targetRow = sheet.createRow(starRow + 1);
//			targetRow.setHeight(sourceRow.getHeight());
//			System.out.println(sourceRow.getLastCellNum());
//			for (m = sourceRow.getFirstCellNum(); m < sourceRow.getLastCellNum(); m++) {
//				System.out.println(m);
//				sourceCell = sourceRow.getCell(m);
//				targetCell = targetRow.createCell(m);
//				targetCell.setCellStyle(sourceCell.getCellStyle());
//				targetCell.setCellType(sourceCell.getCellType());
//			}
//		}
//	}
//
//	/***
//	 * sheetвһ
//	 * 
//	 * @param sheet
//	 * @param startRow
//	 * @param rows
//	 * @return
//	 */
//	public static XSSFSheet insertRows(XSSFSheet sheet, int startRow, int rows) {
//		XSSFRow sourceRow = sheet.getRow(startRow);
//		sheet.shiftRows(startRow + 1, sheet.getLastRowNum(), rows, true, false);
//		for (int i = 0; i < rows; i++) {
//			XSSFRow targetRow = null;
//			XSSFCell sourceCell = null;
//			XSSFCell targetCell = null;
//			short m;
//			targetRow = sheet.createRow(startRow + 1);
//			targetRow.setHeight(sourceRow.getHeight());
//			System.out.println(sourceRow.getLastCellNum());
//			for (m = sourceRow.getFirstCellNum(); m < sourceRow.getLastCellNum(); m++) {
//				System.out.println(m);
//				sourceCell = sourceRow.getCell(m);
//				targetCell = targetRow.createCell(m);
//				targetCell.setCellStyle(sourceCell.getCellStyle());
//				targetCell.setCellType(sourceCell.getCellType());
//			}
//		}
//		return sheet;
//	}
//
//	/**
//	 * 鵥ԪǷ
//	 * 
//	 * @param value
//	 * @return
//	 */
//	public static boolean CheckCellValueIsNumber(String value) {
//		boolean is_ok = false;
//		if (value.equals("")) {
//			return false;
//		}
//		try {
//			Float.parseFloat(value);
//		} catch (NumberFormatException e) {
//			e.printStackTrace();
//			System.out.println("===>" + value);
//			is_ok = true;
//		}
//		return is_ok;
//	}
//
////	/**
////	 * ƴɵϵ˺ϵ绰
////	 * 
////	 * @param persion
////	 * @param phone
////	 * @return
////	 */
////	public static String connectPhoneAndPersion(String persion, String phone) {
////		StringBuffer persionPhoneSb = new StringBuffer();
////		if (persion != null && phone != null) {
////
////			String[] persions = null;
////			String[] phones = null;
////			if (persion.contains("")) {
////				persions = persion.split("");
////			} else if (persion.contains("\\/")) {
////				persions = persion.split("\\/");
////			} else if (persion.contains("")) {
////				persions = persion.split("");
////			} else {
////				persions = new String[] { persion };
////			}
////
////			if (phone.contains("")) {
////				phones = phone.split("");
////			} else if (phone.contains("\\/")) {
////				phones = phone.split("\\/");
////			} else if (phone.contains("")) {
////				phones = phone.split("");
////			} else {
////				phones = new String[] { phone };
////			}
////
////			if (persions != null && phones != null) {
////				int persionCount = persions.length;
////				int phonesCount = phones.length;
////				if (persionCount == phonesCount) {
////					for (int i = 0; i < persionCount; i++) {
////						persionPhoneSb.append(persions[i]).append("/")
////								.append(phones[i]).append("  ");
////
////					}
////				}
////			}
////		}
////
////		return persionPhoneSb.toString();
////	}
//
//	/***
//	 * ҵָ
//	 * 
//	 * @param xls_write_Address
//	 * @param ls
//	 * @param sheetnames
//	 * @param row_num
//	 * @param col_num
//	 * @throws IOException
//	 * 
//	 */
//	public static void writeExcelForCX(String xls_write_Address, File file, ArrayList<ArrayList<String>> ls,
//			int row_num, int col_num) throws IOException {
//		InputStream is = new FileInputStream(file);
//		XSSFWorkbook wb = new XSSFWorkbook(is);// (new
//		is.close();
//		FileOutputStream output = new FileOutputStream(new File(xls_write_Address)); // ȡļ·
//		XSSFCellStyle style = wb.createCellStyle();
////		style.setBorderBottom(XSSFCellStyle.BORDER_THIN);
////		style.setBorderTop(XSSFCellStyle.BORDER_THIN);
////		style.setBorderRight(XSSFCellStyle.BORDER_THIN);
////		style.setAlignment(XSSFCellStyle.ALIGN_CENTER);
//		XSSFFont font = wb.createFont();
//		font.setFontHeightInPoints((short) 8);
//		style.setFont(font);
//		XSSFSheet sheet = wb.getSheetAt(0);
//		sheet.setForceFormulaRecalculation(true);
//		if (ls != null)
//			for (int i = 0; i < ls.size(); i++) {
//				if (i % 27 == 0 && i != 0) {
//					row_num += 11;
//				}
//				XSSFRow row = sheet.getRow(i + row_num - 1);
//				ArrayList<String> ls2 = ls.get(i);
//				for (int cols = 0; cols < ls2.size(); cols++) {
//					XSSFCell cell = row.getCell(cols + col_num - 1);
//					if (cell == null) {
//						cell = row.createCell(cols + col_num - 1);
//					}
////				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
////				cell.setCellStyle(style);// ӱ߿
//					if (cols + col_num == 9) {
//						String cpgc = ls2.get(cols);
//						System.out.println(cpgc);
//						String[] strs = cpgc.split("special");
//						System.out.println("strs.length=>" + strs.length);
//						if (cpgc != null && cpgc != "") {
//							if (!" ".equals(strs[1])) {
//								String special = strs[1];
//								if (special.indexOf("|") <= 0) {
//									if ("Ʒ///".equals(special.split("-")[0])) {
//										int index = Integer.valueOf(special.split("-")[1]);
//										if (strs[0] != null && strs[0] != "") {
//											cell.setCellValue(setCellFont(wb, strs[0], index, index + 1, 8, "Y14.5M"));
//										}
//									}
//
//								} else {
//									String[] tstxs = special.split("\\|");
//									for (String str : tstxs) {
//										if ("Ʒ///".equals(str.split("-")[0])) {
//											int index = Integer.valueOf(str.split("-")[1]);
//											if (strs[0] != null && strs[0] != "") {
//												cell.setCellValue(
//														setCellFont(wb, strs[0], index, index + 1, 8, "Y14.5M"));
//											}
//										}
//									}
//								}
//							} else {
//								// ֱдstrs[0]
//								cell.setCellValue(strs[0]);
//							}
//						}
//					} else
//						cell.setCellValue(ls2.get(cols));// д
//				}
//
//			}
//		else
//			MessageBox.post("ƿƼƻ", "", MessageBox.WARNING);
//		wb.write(output);
//		output.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//	}
//
//	/**
//	 * ҵָ
//	 * 
//	 * @param string
//	 * @param is
//	 * @param zx
//	 * @param strings
//	 * @param i
//	 * @param j
//	 */
//	public static void writeExcelForZX(String xls_write_Address, File file, ArrayList<ArrayList<String>> ls,
//			int row_num, int col_num) throws IOException {
//		InputStream is = new FileInputStream(file);
//		XSSFWorkbook wb = new XSSFWorkbook(is);// (new
//		is.close();
//		FileOutputStream output = new FileOutputStream(new File(xls_write_Address)); // ȡļ·
//		XSSFCellStyle style = wb.createCellStyle();
//		style.setBorderBottom(XSSFCellStyle.BORDER_THIN);
//		style.setBorderTop(XSSFCellStyle.BORDER_THIN);
//		style.setBorderRight(XSSFCellStyle.BORDER_THIN);
//		style.setBorderLeft(XSSFCellStyle.BORDER_THIN);
//		style.setAlignment(XSSFCellStyle.ALIGN_CENTER);
//		XSSFFont font = wb.createFont();
//		font.setFontHeightInPoints((short) 8);
//		style.setFont(font);
//		XSSFSheet sheet = wb.getSheetAt(0);
//		for (int i = 0; i < ls.size(); i++) {
//			if (i % 30 == 0 && i != 0) {
//				row_num += 10;
//			}
//			XSSFRow row = sheet.getRow(i + row_num - 1);
//			ArrayList<String> ls2 = ls.get(i);
//			for (int cols = 0; cols < ls2.size(); cols++) {
//				XSSFCell cell = null;
//				if (cols == ls2.size() - 1)
//					cell = row.getCell(cols + col_num - 1);
//				else
//					cell = row.getCell(cols + col_num - 1);
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
////				cell.setCellStyle(style);// ӱ߿
//				if (cols + col_num == 11) {
//					String cpgc = ls2.get(cols);
//					System.out.println(cpgc);
//					String[] strs = cpgc.split("special");
//					System.out.println("strs.length=>" + strs.length);
//					if (cpgc != null && cpgc != "") {
//						if (!" ".equals(strs[1])) {
//							String special = strs[1];
//							if (special.indexOf("|") <= 0) {
//								if ("Ʒ///".equals(special.split("-")[0])) {
//									int index = Integer.valueOf(special.split("-")[1]);
//									if (strs[0] != null && strs[0] != "") {
//										cell.setCellValue(setCellFont(wb, strs[0], index, index + 1, 8, "Y14.5M"));
//									}
//								}
//
//							} else {
//								String[] tstxs = special.split("\\|");
//								for (String str : tstxs) {
//									if ("Ʒ///".equals(str.split("-")[0])) {
//										int index = Integer.valueOf(str.split("-")[1]);
//										if (strs[0] != null && strs[0] != "") {
//											cell.setCellValue(setCellFont(wb, strs[0], index, index + 1, 8, "Y14.5M"));
//										}
//									}
//								}
//							}
//						} else {
//							// ֱдstrs[0]
//							cell.setCellValue(strs[0]);
//						}
//					}
//				} else
//					cell.setCellValue(ls2.get(cols));// д
//			}
//
//		}
//		wb.write(output);
//		output.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//	}
//
//	/**
//	 * սҵָ
//	 * 
//	 * @param string
//	 * @param is
//	 * @param zx
//	 * @param strings
//	 * @param i
//	 * @param j
//	 */
//	public static void writeExcelForSJ(String xls_write_Address, File file, ArrayList<ArrayList<String>> ls,
//			List<String> productNameList24, List<String> productNameList18) throws IOException {
//		InputStream is = new FileInputStream(file);
//		XSSFWorkbook wb = new XSSFWorkbook(is);// (new
//		is.close();
//		FileOutputStream output = new FileOutputStream(new File(xls_write_Address)); // ȡļ·
////		writeExcelWithOneCellName(wb, "豸", rb3_jqsb);
//		XSSFCellStyle style = wb.createCellStyle();
//		style.setBorderBottom(XSSFCellStyle.BORDER_THIN);
//		style.setBorderTop(XSSFCellStyle.BORDER_THIN);
//		style.setBorderRight(XSSFCellStyle.BORDER_THIN);
//		style.setBorderLeft(XSSFCellStyle.BORDER_THIN);
//		style.setAlignment(XSSFCellStyle.ALIGN_CENTER);
//		XSSFFont font = wb.createFont();
//		font.setFontHeightInPoints((short) 8);
//		style.setFont(font);
//		XSSFSheet s = wb.getSheetAt(0);
//		s.setForceFormulaRecalculation(true);
//		if (productNameList24 != null) {
//			setNamedCellValue(wb, "ʮĴ",
//					productNameList24.toString().substring(1, productNameList24.toString().length() - 1));
//		}
//		if (productNameList18 != null) {
//			setNamedCellValue(wb, "ʮ˴",
//					productNameList18.toString().substring(1, productNameList18.toString().length() - 1));
//		}
//		int[] indexs = getNamedCellIndex(wb, "豸");
//		int startRow = indexs[1] + 1;
//		int startColumn = indexs[0];
//		for (int i = 0; i < productNameList24.size(); i++) {
//
//			Row r = s.getRow(startRow + i);
//			setCellValue(r, startColumn, productNameList24.get(i));
//		}
//		for (int i = 0; i < productNameList18.size(); i++) {
//			Row r = s.getRow(startRow + productNameList24.size() + i);
//			setCellValue(r, startColumn, productNameList18.get(i));
//		}
//
//		int row_num = 0;
//		int t = 0;
//		for (int i = 0; i < ls.size(); i++) {
//			if (t % 12 == 0 && i != 0) {
//				t = 0;
//				row_num += 29;
//			}
//
//			ArrayList<String> ls2 = ls.get(i);
//			System.out.println("SJ_data.size===============>" + ls2.size());
//			System.out.println("SJ_data====================>" + ls2.toString());
//			for (int j = 0; j < ls2.size() + 1; j++) {
//				int namedCellIdx = wb.getNameIndex("head" + String.valueOf(j + 1));
//				if (namedCellIdx != -1) {
//					Name aNamedCell = wb.getNameAt(namedCellIdx);
//					AreaReference[] arefs = AreaReference.generateContiguous(aNamedCell.getRefersToFormula());
//					CellReference[] crefs = arefs[0].getAllReferencedCells();
//					for (int k = 0; k < crefs.length; k++) {
//						Row r = s.getRow(crefs[k].getRow() + row_num + 1);
//						Cell c = r.getCell(crefs[k].getCol());
//						if (j == 2) {
//							toSpecial(j, wb, c, ls2);
//						} else if (namedCellIdx != wb.getNameIndex("head7"))
//							c.setCellValue(ls2.get(j));
//						else
//							c.setCellValue("");
//					}
//				}
//
//			}
//			t++;
//			row_num++;
//		}
//		wb.write(output);
//		output.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//	}

	// 20181220-ReinhartEdit
	/***
	 * ȴҵָ
	 * 
	 * @param xls_write_Address
	 * @param ls
	 * @param sheetnames
	 * @param row_num
	 * @param col_num
	 * @throws IOException
	 * 
	 */
//	public static void writeExcelForRCL(String xls_write_Address, File file, ArrayList<ArrayList<String>> ls,
//			int row_num, int col_num) throws IOException {
//		// InputStream is = new FileInputStream(file);
//		// XSSFWorkbook wb = new XSSFWorkbook(is);// (new
//		// is.close();
//		// FileOutputStream output = new FileOutputStream(new File(
//		// xls_write_Address)); // ȡļ·
//
//		// XSSFCellStyle style = wb.createCellStyle();
//		// MessageBox.post("In Processing", "Step", MessageBox.WARNING);
//
//		// MessageBox.post(xls_write_Address, "Step", MessageBox.WARNING);
//
//		// ȡExcelĵ
//		// File finalXlsxFile = new File("D:/NBTMȴָ.xlsx");
//		File finalXlsxFile = new File(xls_write_Address);
//		Workbook workBook = getWorkbok(finalXlsxFile);
//		// sheet Ӧһҳ
//		Sheet getSheet = workBook.getSheetAt(0);
//
////		style.setBorderBottom(XSSFCellStyle.BORDER_THIN);
////		style.setBorderTop(XSSFCellStyle.BORDER_THIN);
////		style.setBorderRight(XSSFCellStyle.BORDER_THIN);
////		style.setAlignment(XSSFCellStyle.ALIGN_CENTER);
//		// XSSFFont font = wb.createFont();
//		/// font.setFontHeightInPoints((short) 8);
//		// style.setFont(font);
//
//		if (ls != null) {
//
//			int rowNumber = getSheet.getLastRowNum(); // һд0ʼ
//			System.out.println("ԭʼ" + ls.size());
//
//			// Ȱģļ
//			for (int i = 0; i < 10; i++) {
//				Row row = getSheet.getRow(i + 26);
//
//				if (row == null) {
//					row = getSheet.createRow(i + 26);
//				}
//				try {
//					Cell Itemcell = row.getCell(2);
//					if (Itemcell == null) {
//						Itemcell = row.createCell(2);
//					}
//					Itemcell.setCellValue("");// д
//
//					Cell Valuecell = row.getCell(6);
//					if (Valuecell == null) {
//						Valuecell = row.createCell(6);
//					}
//					Valuecell.setCellValue("");// д
//
//					Cell Processcell = row.getCell(10);
//					if (Processcell == null) {
//						Processcell = row.createCell(10);
//					}
//					Processcell.setCellValue("");// д
//
//					Cell Doublecell = row.getCell(14);
//					if (Doublecell == null) {
//						Doublecell = row.createCell(14);
//					}
//					Doublecell.setCellValue("");// д
//
//				} catch (Exception ex) {
//					System.out.println(ex.toString());
//					MessageBox.post(ex.toString(), "Error", MessageBox.ERROR);
//
//					return;
//				}
//
//			}
//			// System.out.println("Ȱģļ" );
//
//			// Ȱģļ
//			// д
//			// System.out.println(ls.size());
//			for (int i = 0; i < ls.size(); i++) {
//
//				System.out.println("дʵݣ");
//				Row row = getSheet.getRow(i + 26);
//
//				if (row == null) {
//					row = getSheet.createRow(i + 26);
//				}
//
//				ArrayList<String> ls2 = ls.get(i);
//				// System.out.println(ls2.get(i));
//				// MessageBox.post(ls2.get(0), "Step", MessageBox.WARNING);
//
//				try {
//
//					Cell Itemcell = row.getCell(2);
//					if (Itemcell == null) {
//						Itemcell = row.createCell(2);
//					}
//					System.out.println(ls2.get(1));
//					Itemcell.setCellValue(ls2.get(1));// д
//
//					Cell Valuecell = row.getCell(6);
//					if (Valuecell == null) {
//						Valuecell = row.createCell(6);
//					}
//					System.out.println(ls2.get(2));
//					Valuecell.setCellValue(ls2.get(2));// д
//
//					Cell Processcell = row.getCell(10);
//					if (Processcell == null) {
//						Processcell = row.createCell(10);
//					}
//					System.out.println(ls2.get(3));
//					Processcell.setCellValue(ls2.get(3));// д
//
//					Cell Doublecell = row.getCell(14);
//					if (Doublecell == null) {
//						Doublecell = row.createCell(14);
//					}
//					System.out.println(ls2.get(4));
//					Doublecell.setCellValue(ls2.get(4));// д
//
//				} catch (Exception ex) {
//					System.out.println(ex.toString());
//					MessageBox.post(ex.toString(), "Error", MessageBox.ERROR);
//
//					return;
//				}
//
//			}
//			// д
//
//			// FileOutputStream output = new FileOutputStream("D:/MYȴָ.xlsx"); //
//			// ȡļ·
//			FileOutputStream output = new FileOutputStream(xls_write_Address); // ȡļ·
//
//			workBook.write(output);
//			// wb.write(output);
//
//			if (output != null) {
//				output.flush();
//				output.close();
//			}
//
//			// System.out.println("Start output data to Excel end!!!!!");
//			// MessageBox.post(" output data to Excel end!!!!!", "Step",
//			// MessageBox.WARNING);
//
//		} else {
//			MessageBox.post("ƿƼƻ", "", MessageBox.WARNING);
//		}
//
//		System.out.println("-------WRITE EXCEL OVER-------");
//	}
//
//	public static void toSpecial(int cols, XSSFWorkbook wb, Cell cell, ArrayList<String> cell_Date) {
//		String cpgc = cell_Date.get(cols);
////		System.out.println(cpgc);
//		String[] strs = cpgc.split("special");
////		System.out.println(strs.length);
//		if (cpgc != null || cpgc != "") {
//			if (!"null".equals(strs[1]) && !" ".equals(strs[1])) {
//				String special = strs[1];
//				if (special.indexOf("|") <= 0) {
//					if ("Ʒ///".equals(special.split("-")[0])) {
//						int index = Integer.valueOf(special.split("-")[1]);
//						if (strs[0] != null && strs[0] != "") {
//							cell.setCellValue(setCellFont(wb, strs[0], index, index + 1, 8, "Y14.5M"));
//						}
//					}
//
//				} else {
//					String[] tstxs = special.split("\\|");
//					for (String str : tstxs) {
//						if ("Ʒ///".equals(str.split("-")[0])) {
//							int index = Integer.valueOf(str.split("-")[1]);
//							if (strs[0] != null && strs[0] != "") {
//								cell.setCellValue(setCellFont(wb, strs[0], index, index + 1, 8, "Y14.5M"));
//							}
//						}
//					}
//				}
//			} else {
//				// ֱдstrs[0]
//				cell.setCellValue(strs[0]);
//			}
//		}
//
//	}
//
//	public static void writeExcelWithOneCellName(XSSFWorkbook wb, String cellName, String value) {
//
//		int namedCellIdx = wb.getNameIndex(cellName);
//		if (namedCellIdx != -1) {
//			Name aNamedCell = wb.getNameAt(namedCellIdx);
//			AreaReference[] arefs = AreaReference.generateContiguous(aNamedCell.getRefersToFormula());
//			for (int i = 0; i < arefs.length; i++) {
//				CellReference[] crefs = arefs[i].getAllReferencedCells();
//				for (int j = 0; j < crefs.length; j++) {
//					Sheet s = wb.getSheet(crefs[j].getSheetName());
//					Row r = s.getRow(crefs[j].getRow());
//					Cell c = r.getCell(crefs[j].getCol());
//					c.setCellValue(value);
//				}
//			}
//		}
//	}
//
//	/**
//	 * ֵд뵽Excel
//	 * 
//	 * @param output
//	 * @param file
//	 * @param cellName
//	 * @param cellValue
//	 */
//	public static void writeExcelWithCellName(File file, String fileOutUrl, Map<String, String> map, int code,
//			String meop_name) {
//		try {
//			InputStream is = new FileInputStream(file);
//			Workbook wb = new XSSFWorkbook(is);// retrieve workbook
//			is.close();
//			FileOutputStream output = new FileOutputStream(new File(fileOutUrl));
//			boolean is_first = true;
//			for (String key : map.keySet()) {
//				if (is_first && "Ʒ".equals(key) && (code == 3 || code == 4 || code == 5)) {
//					int a1CellIndex = wb.getNameIndex("head");
//					if (a1CellIndex != -1) {
//						Name a1NameCell = wb.getNameAt(a1CellIndex);
//						AreaReference[] a1ARF = AreaReference.generateContiguous(a1NameCell.getRefersToFormula());
//						CellReference[] a1CRF = a1ARF[0].getAllReferencedCells();
//						Sheet s = wb.getSheet(a1CRF[0].getSheetName());
//						Row r = s.getRow(a1CRF[0].getRow());
//						Cell c = r.getCell(a1CRF[0].getCol());
//						System.out.println(key + ":" + c.getStringCellValue());
//						c.setCellValue(c.getStringCellValue() + map.get(key));
//						is_first = false;
//					}
//				}
//
//				if ("".equals(key)) {
//					SetFont(wb, map.get(key), meop_name);
//				}
//
//				else {
//
//					int namedCellIdx = wb.getNameIndex(key);
//					if (namedCellIdx != -1) {
//						Name aNamedCell = wb.getNameAt(namedCellIdx);
//						AreaReference[] arefs = AreaReference.generateContiguous(aNamedCell.getRefersToFormula());
//						for (int i = 0; i < arefs.length; i++) {
//							CellReference[] crefs = arefs[i].getAllReferencedCells();
//
//							for (int j = 0; j < crefs.length; j++) {
//
//								Sheet s = wb.getSheet(crefs[j].getSheetName());
//								Row r = s.getRow(crefs[j].getRow());
//								Cell c = r.getCell(crefs[j].getCol());
//								if (code == 2) {
//									c.setCellValue(map.get(key).split("/")[0]);
//								} else
//									c.setCellValue(map.get(key));
//							}
//						}
//					}
//				}
//			}
//			wb.write(output);
//			output.close();
//
//		} catch (Exception e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//	}
//
//	/**
//	 * str1str2
//	 * 
//	 * @param wb
//	 * @param str1
//	 * @param str2
//	 * @throws IOException
//	 */
//	private static void SetFont(Workbook wb, String str1, String str2) throws IOException {
//		int index = 0;
//		int start_index = 0;
//		int end_index = str1.length();
//		String meop_name = str2.split("/")[0];
//		if (str1.indexOf("") != -1)
//			start_index = str1.indexOf("");
//		if (str1.lastIndexOf("װ") != -1)
//			end_index = str1.lastIndexOf("װ") + 2;
//		str1 = str1.substring(start_index, end_index);
//		while ((index = str1.indexOf(meop_name, index)) != -1) {
//			int next_index = index + meop_name.length();
//			boolean begin = index - 1 < 0 || str1.charAt(index - 1) == '-';
//			boolean end = next_index > str1.length() || next_index + 1 > str1.length() ? true
//					: str1.charAt(next_index) == '-';
//			if (begin && end)
//				break;
//			else
//				index = index + meop_name.length();
//		}
//		XSSFRichTextString ts = new XSSFRichTextString(str1);
//		XSSFFont font1 = (XSSFFont) wb.createFont();
//		font1.setFontHeightInPoints((short) 10); // ߶
//		font1.setFontName(""); // 
//		XSSFFont font = (XSSFFont) wb.createFont();
//		font.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD);
//		font.setFontHeightInPoints((short) 12); // ߶
//		font.setFontName("");
//		ts.applyFont(index, index + meop_name.length(), font);
//		ts.applyFont(index + meop_name.length(), ts.length(), font1);
////		XSSFFont font = (XSSFFont) wb.createFont();
////		
////		font.setBoldweight(XSSFFont.BOLDWEIGHT_BOLD);  
////		ts.applyFont(index, index+str2.length(), font);
//		int namedCellIdx = wb.getNameIndex("");
//		if (namedCellIdx != -1) {
//			Name aNamedCell = wb.getNameAt(namedCellIdx);
//			AreaReference[] arefs = AreaReference.generateContiguous(aNamedCell.getRefersToFormula());
//			for (int i = 0; i < arefs.length; i++) {
//				CellReference[] crefs = arefs[i].getAllReferencedCells();
//				for (int j = 0; j < crefs.length; j++) {
//					Sheet s = wb.getSheet(crefs[j].getSheetName());
//					Row r = s.getRow(crefs[j].getRow());
//					Cell c = r.getCell(crefs[j].getCol());
//					c.setCellValue(ts);
//				}
//			}
//		}
//	}

	/**
	 * 
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param tcResource   ļ·
	 * @param relationType ϵ
	 * @param fileName     ļ
	 */
	public static void setExcelToItem(TCSession session, TCComponentItemRevision item, String tcResource,
			String fileName, String relationType, String excelType, boolean isDelete) {
		try {
			String as1[] = { tcResource };// ļ·
			String as2[] = { "excel" };
			String as3[] = { excelType };
			String as4[] = { "Plain" };
			TCComponentDatasetType tccomponentDatasetType = (TCComponentDatasetType) session
					.getTypeComponent("Dataset");
			TCComponentDataset tccomponentDataset = tccomponentDatasetType.create(fileName, "excel", excelType);
			tccomponentDataset.setFiles(as1, as3, as4, as2);
			AIFComponentContext[] zyzdsChildrens = item.getChildren();
			TCComponentItemRevision zyzdsRev = item;
			for (AIFComponentContext zyzdsChildren : zyzdsChildrens) {
				if (excelType.equals(zyzdsChildren.getComponent().getType())) {
					TCComponentDataset dateSet = (TCComponentDataset) zyzdsChildren.getComponent();
					if (dateSet.getStringProperty("object_name").equals(fileName)) {
						dateSet.delete();
						zyzdsRev.remove(relationType, dateSet);
					}
				}
			}
			item.add(relationType, tccomponentDataset);
			if (isDelete) {
				new File(tcResource).delete();
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * ȡ÷ж
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param relationType ϵ
	 */
	public static TCComponentDataset[] getComponentToDatasets(TCSession session, TCComponentItemRevision item,
			String relationType) {
		try {
			TCComponent[] zyzdsChildrens = item.getRelatedComponents(relationType);
			TCComponentDataset[] Childrens = new TCComponentDataset[zyzdsChildrens.length];
			if (zyzdsChildrens == null || zyzdsChildrens.length < 1) {
				return null;
			}
			for (int ii = 0; ii < zyzdsChildrens.length; ii++) {

				if (zyzdsChildrens[ii] instanceof TCComponentDataset) {
					//

					Childrens[ii] = (TCComponentDataset) zyzdsChildrens[ii];

					//
				}

//				

			}

			return Childrens;

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * ȡ
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param relationType ϵ
	 */

	public static TCComponentDataset getComponentToDataset(TCSession session, TCComponentItemRevision item,
			String relationType) {
		try {
			TCComponent[] zyzdsChildrens = item.getRelatedComponents(relationType);
			if (zyzdsChildrens == null || zyzdsChildrens.length < 1) {
				return null;
			}
			for (TCComponent zyzdsChildren : zyzdsChildrens) {

				return (TCComponentDataset) zyzdsChildren;
//				

			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * ȡ
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param relationType ϵ
	 */
	public static TCComponentDataset getExcelToDataset(TCSession session, TCComponentItemRevision item,
			String relationType, String fileType) {
		try {
			TCComponent[] zyzdsChildrens = item.getRelatedComponents(relationType);
			if (zyzdsChildrens == null || zyzdsChildrens.length < 1) {
				return null;
			}
			for (TCComponent zyzdsChildren : zyzdsChildrens) {
				if (fileType.equals(zyzdsChildren.getType())) {
					return (TCComponentDataset) zyzdsChildren;
//					TCComponentTcFile[] tcFile = dateSet.getTcFiles();
//					return tcFile[0].getFmsFile();
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * ȡ
	 * 
	 * @param session
	 * @param item         İ汾
	 * @param relationType ϵ
	 */
	public static File getExcelToItem(TCSession session, TCComponentItemRevision item, String relationType,
			String fileType) {
		try {
			TCComponent[] zyzdsChildrens = item.getRelatedComponents(relationType);
			if (zyzdsChildrens == null || zyzdsChildrens.length < 1) {
				return null;
			}
			for (TCComponent zyzdsChildren : zyzdsChildrens) {
				if (fileType.equals(zyzdsChildren.getType())) {
					TCComponentDataset dateSet = (TCComponentDataset) zyzdsChildren;
					TCComponentTcFile[] tcFile = dateSet.getTcFiles();
					return tcFile[0].getFmsFile();
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * ȡϲԪ
	 * 
	 * @param value      ֵ
	 * @param startIndex ʼ
	 * @return
	 */
	public static void getCombineRow(String value, int startIndex) {
		// TODO Auto-generated method stub
		String[] sombines = null;
		if (value != null && !value.equals("")) {
			if (value.indexOf("-") >= 0) {
				sombines = value.split("-");
			} else {
				sombines = new String[] { value };
			}
		}
		for (int j = 0; j < sombines.length; j++) {
			if (sombines[j].indexOf("/") >= 0) {
				int[] row;
				int[] cloumn;
				String[] cells = sombines[j].split("/");
				if (cells[0].indexOf(",") >= 0) {
					String[] rows = cells[0].split(",");
					row = new int[rows.length];
					for (int k = 0; k < rows.length; k++) {
						row[k] = Integer.parseInt(rows[k]) + startIndex;
					}
				} else {
					row = new int[] { Integer.parseInt(cells[0]) + startIndex };
				}
				if (cells[1].indexOf(",") >= 0) {
					String[] cloumns = cells[1].split(",");
					cloumn = new int[cloumns.length];
					for (int k = 0; k < cloumns.length; k++) {
						cloumn[k] = Integer.parseInt(cloumns[k]) - 1;
					}
				} else {
					cloumn = new int[] { Integer.parseInt(cells[1]) - 1 };
				}
				map.put(row, cloumn);
			}
		}
	}

	/**
	 * ȡԪ
	 * 
	 * @param wb
	 * @param cellName
	 * @return
	 * @throws IOException
	 */
//	public static int getOneNamedCellIndex(XSSFWorkbook wb, String cellName) throws IOException {
//		int index = -1;
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(wb);
//		XSSFName name = wb.getName(cellName);
//		if (name == null) {
//			return -1;
//		}
//		AreaReference[] areaRs = AreaReference.generateContiguous(name.getRefersToFormula());
//		if (areaRs != null)
//			for (AreaReference areaR : areaRs) {
//				CellReference[] cellRs = areaR.getAllReferencedCells();
//				if (cellRs != null) {
//					for (CellReference cellR : cellRs) {
//						String sheetName = cellR.getSheetName();
//						short colIndex = cellR.getCol();
//						int rowIndex = cellR.getRow();
//						XSSFSheet sheet = wb.getSheet(sheetName);
//						XSSFRow row = sheet.getRow(rowIndex);
//						return colIndex;
//					}
//				}
//			}
//		return index;
//	}

	/**
	 * --ƼƻEXCEL
	 * 
	 * @param controlPlanBean ƼƻϢ
	 * @param input           ģļ
	 * @param outputFilePath  Ҫȫ·
	 * @throws IOException
	 */
//	public static int writeAixinControlPlanToExcel(TMomControlPlanBean controlPlanBean, InputStream input,
//			String outputFilePath, String type) throws IOException {
//
//		FileOutputStream output = new FileOutputStream(new File(outputFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		map.clear();
//		int startRow = 14;
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			for (int i = 0; i < (simpleBeanList.size()); i++)
//				insertRow(sheet, 14, 1);// 
//			XSSFRow row1 = sheet.getRow(5);
//			setCellValue(row1, 10, controlPlanBean.getSorName());
//			setCellValue(row1, 13, controlPlanBean.getControlPlanNo());
//			XSSFRow row2 = sheet.getRow(8);
//			setCellValue(row2, 0, controlPlanBean.getCustromPartNumber());
//			setCellValue(row2, 4, controlPlanBean.getPartNameDesc());
//			setCellValue(row2, 6, controlPlanBean.getMode());
//			setCellValue(row2, 8, controlPlanBean.getSupplier());
//			setCellValue(row2, 10, controlPlanBean.getKeyPersion());// ˴Ҫ޸
//			setCellValue(row2, 13, controlPlanBean.getKeyPhone());// ˴Ҫ޸
//			XSSFRow row3 = sheet.getRow(9);
//			setCellValue(row3, 7, controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row3, 9, controlPlanBean.getCustromApprovalDateStr());
//			XSSFRow row4 = sheet.getRow(10);
//			setCellValue(row4, 0, controlPlanBean.getCoreTeam());
//			setCellValue(row4, 10, controlPlanBean.getCreateDateStr());
//			setCellValue(row4, 13, controlPlanBean.getUpdateDateStr());
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
//			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
//				getCombineRow(bean.getHbdyg(), startRow);
//			}
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			if ((i + startRow) > sheet.getLastRowNum()) {
//				row = sheet.createRow(i + startRow);
//				isCreat = true;
//			} else {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}
//			// ȡַλ
//			String[] columnNames = null;
//			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
//			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
//				try {
//					if (bean.getSpecial().indexOf("|") >= 0) {
//						columnNames = bean.getSpecial().split("\\|");
//					} else {
//						columnNames = new String[] { bean.getSpecial() };
//					}
//					if (columnNames != null && columnNames.length > 0) {
//						for (int i1 = 0; i1 < columnNames.length; i1++) {
//							if (columnNames[i1].indexOf("-") >= 0) {
//								String[] columnName = columnNames[i1].split("-");
//								// ͨƻȡ
//								int cellindex = -1;
//								if (columnName[0].indexOf(",") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
//								} else if (columnName[0].indexOf("/") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
//								} else {
//									cellindex = getOneNamedCellIndex(wb, columnName[0]);
//								}
//								if (cellindex > -1) {
//									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
//								}
//							}
//						}
//					}
//				} catch (Exception e) {
//					// TODO: handle exception
//					e.printStackTrace();
//				}
//			}
//			for (int cols = 0; cols <= 15; cols++) {
//				XSSFCell cell = null;
//				if (isCreat) {
//					cell = row.createCell(cols);
//				} else {
//					cell = row.getCell(cols);
//				}
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//
//				switch (cols) {
//
//				case 0:
//					if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[1]);
//					} else if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getPartProcessNumber());
//					}
//					break;
//				case 1:
//					if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[1]);
//					} else if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcessName());
//					}
//					break;
//				case 2:
//					if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[1]);
//					} else if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getMachineDevice());
//					}
//					break;
//				case 3:
//					if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[1]);
//					} else if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSmjy(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSmjy());
//					}
//					break;
//				case 4:
//					// String noo = bean.();
//					if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[1]);
//					} else if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getBubbledPrintNo(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getBubbledPrintNo());
//					}
//					break;
//				case 5:
//					if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProduct().split("\n")[1]);
//					} else if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProduct().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProduct());
//					}
//					break;
//				case 6:
//					if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcess().split("\n")[1]);
//					} else if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcess().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcess());
//					}
//					break;
//				case 7:
//					if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[1]);
//					} else if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSpecialClass());
//					}
//					break;
//				case 8:
//					if (bean.getConceal().equals("1")) {
//						String processName = bean.getProcessName();// .split("\n")[1];
//						String productId = bean.getMeopId().split("_")[0];
//						StringBuffer value = new StringBuffer();
//						System.out.println(value.length());
//						if (type.indexOf("CHINESE") != -1) {
//							String name = processName.split("\n")[0];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(3, name.length() - 1);
//							}
//							value.append("" + name + "ҵָ/" + productId);
//							// cell.setCellValue(""+processName+"ҵָ/"+productId);
//						}
//						if (type.indexOf("ENGLISH") != -1) {
//							String name = processName.split("\n")[1];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(8, name.length() - 1);
//							}
//							if (value.length() != 0)
//								value.append("\n");
//							value.append("In " + name + " OP INS/" + productId);
//
//						}
//						cell.setCellValue(value.toString());
//					} else {
//						if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("ENGLISH")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[1]);
//						} else if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("CHINESE")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[0]);
//						} else if (indexMap.get(cols) != null) {
//							cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
//									indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
//						} else {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance());
//						}
//					}
////					if (bean.getUpProductProcessSpecificationTolerance() == null) {
////						cell.setCellValue("");
////					} else if (!bean
////							.getUpProductProcessSpecificationTolerance().trim()
////							.isEmpty()
////							&& !bean.getDownProductProcessSpecificationTolerance()
////									.trim().isEmpty())
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance()
////								+ " "
////								+ bean.getUpProductProcessSpecificationTolerance()
////								+ "/"
////								+ bean.getDownProductProcessSpecificationTolerance());
////					else {
////						
////					}
//					break;
//				case 9:
//					if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[1]);
//					} else if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("CHINESE")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
//					}
//					break;
//				case 10:
//					if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[1]);
//					} else if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleSize());
//					}
//					break;
//				case 11:
//					if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[1]);
//					} else if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleFreq());
//					}
//					break;
//				case 12:
//					if (bean.getResp() != null && bean.getResp().indexOf("\n") >= 0
//							&& bean.getResp().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getResp().split("\n")[1]);
//					} else if (bean.getResp() != null && bean.getResp().indexOf("\n") >= 0
//							&& bean.getResp().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getResp().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getResp(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getResp());
//					}
//					break;
//				case 13:
//					if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[1]);
//					} else if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getControlMethod());
//					}
//					break;
//				case 14:
//					if (bean.getOperationCriteria() != null && bean.getOperationCriteria().indexOf("\n") >= 0
//							&& bean.getOperationCriteria().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getOperationCriteria().split("\n")[1]);
//					} else if (bean.getOperationCriteria() != null && bean.getOperationCriteria().indexOf("\n") >= 0
//							&& bean.getOperationCriteria().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getOperationCriteria().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getOperationCriteria(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getOperationCriteria());
//					}
//					break;
//				case 15:
//					if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[1]);
//					} else if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getReactionPlan());
//					}
//					break;
//
//				default:
//					break;
//
//				}
//			}
//		}
//		if (map != null && map.size() != 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				List<Integer> columnIndex = new ArrayList<Integer>();
//				for (int i = 0; i < entry.getValue().length; i++) {
//					if (entry.getValue()[i] == 3 || entry.getValue()[i] == 5
//							|| (entry.getValue()[i] >= 18 && entry.getValue()[i] <= 20)) {
//						continue;
//					} else if (entry.getValue()[i] == 4) {
//						columnIndex.add(entry.getValue()[i] - 1);
//					} else if (entry.getValue()[i] >= 7 && entry.getValue()[i] <= 17) {
//						columnIndex.add(entry.getValue()[i] - 3);
//					} else {
//						columnIndex.add(entry.getValue()[i]);
//					}
//				}
//				int[] column = new int[columnIndex.size()];
//				for (int i = 0; i < columnIndex.size(); i++) {
//					column[i] = columnIndex.get(i);
//				}
//				if (column.length > 0) {
//					combine(sheet, entry.getKey(), column);
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVERax-------");
//
//		return 0;
//	}
//
//	/**
//	 * ƴɵϵ˺ϵ绰
//	 * 
//	 * @param persion
//	 * @param phone
//	 * @return
//	 */
//	public static String connectPhoneAndPersion(String persion, String phone) {
//		StringBuffer persionPhoneSb = new StringBuffer();
//		if (persion != null && phone != null) {
//
//			String[] persions = null;
//			String[] phones = null;
//			if (persion.contains("")) {
//				persions = persion.split("");
//			} else if (persion.contains("\\/")) {
//				persions = persion.split("\\/");
//			} else if (persion.contains("")) {
//				persions = persion.split("");
//			} else {
//				persions = new String[] { persion };
//			}
//
//			if (phone.contains("")) {
//				phones = phone.split("");
//			} else if (phone.contains("\\/")) {
//				phones = phone.split("\\/");
//			} else if (phone.contains("")) {
//				phones = phone.split("");
//			} else {
//				phones = new String[] { phone };
//			}
//
//			if (persions != null && phones != null) {
//				int persionCount = persions.length;
//				int phonesCount = phones.length;
//				if (persionCount == phonesCount) {
//					for (int i = 0; i < persionCount; i++) {
//						persionPhoneSb.append(persions[i]).append("/").append(phones[i]).append("  ");
//
//					}
//				}
//			}
//		}
//
//		return persionPhoneSb.toString();
//	}
//
//	/**
//	 * --ƼƻEXCEL
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeMaigelaControlPlanToExcel(TMomControlPlanBean controlPlanBean, InputStream input,
//			String outputFilePath, String type) throws IOException {
//
//		FileOutputStream output = new FileOutputStream(new File(outputFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		int startRow = 14;
//		map.clear();
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			// for (int i = 0; i < (simpleBeanList.size()); i++)
//			// insertRow(sheet, 15, 1);// 
//			XSSFRow row0 = sheet.getRow(1);
//			setCellValue(row0, 11, row0.getCell(11).getStringCellValue() + controlPlanBean.getControlPlanNo());
//			XSSFRow row1 = sheet.getRow(3);
//			setCellValue(row1, 0, controlPlanBean.getPartNumber());
//			setCellValue(row1, 6,
//					connectPhoneAndPersion(controlPlanBean.getKeyPersion(), controlPlanBean.getKeyPhone()));
//			setCellValue(row1, 12, controlPlanBean.getCreateDateStr());
//			setCellValue(row1, 14, controlPlanBean.getUpdateDateStr());
//			setCellValue(row1, 15, controlPlanBean.getChangeLev());
//			XSSFRow row2 = sheet.getRow(5);
//			setCellValue(row2, 0, controlPlanBean.getCustromPartNumber());
//			setCellValue(row2, 7, controlPlanBean.getCoreTeam());
//			setCellValue(row2, 12, controlPlanBean.getCustromEngineeringApprovalDateStr());
//
//			XSSFRow row3 = sheet.getRow(7);
//			setCellValue(row3, 0, controlPlanBean.getPartNameDesc());
//			setCellValue(row3, 7, controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row3, 12, controlPlanBean.getCustromQuantyApprovalDateStr());
//			XSSFRow row4 = sheet.getRow(9);
//			setCellValue(row4, 0, controlPlanBean.getSupplier());
//			setCellValue(row4, 3, controlPlanBean.getSupplierCode());
//			setCellValue(row4, 7, controlPlanBean.getOtherApprovalDateStr());
//			setCellValue(row4, 12, controlPlanBean.getOtherApprovalIfDateStr());
//
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
//			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
//				getCombineRow(bean.getHbdyg(), startRow);
//			}
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			if ((i + startRow) > sheet.getLastRowNum()) {
//				row = sheet.createRow(i + startRow);
//				isCreat = true;
//			} else {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}
//			// ȡַλ
//			String[] columnNames = null;
//			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
//			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
//				try {
//					if (bean.getSpecial().indexOf("|") >= 0) {
//						columnNames = bean.getSpecial().split("\\|");
//					} else {
//						columnNames = new String[] { bean.getSpecial() };
//					}
//					if (columnNames != null && columnNames.length > 0) {
//						for (int i1 = 0; i1 < columnNames.length; i1++) {
//							if (columnNames[i1].indexOf("-") >= 0) {
//								String[] columnName = columnNames[i1].split("-");
//								// ͨƻȡ
//								int cellindex = -1;
//								if (columnName[0].indexOf(",") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
//								} else if (columnName[0].indexOf("/") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
//								} else {
//									cellindex = getOneNamedCellIndex(wb, columnName[0]);
//								}
//								if (cellindex > -1) {
//									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
//								}
//							}
//						}
//					}
//				} catch (Exception e) {
//					// TODO: handle exception
//					e.printStackTrace();
//				}
//			}
//			for (int cols = 0; cols <= 15; cols++) {
//				XSSFCell cell = null;
//				if (isCreat) {
//					cell = row.createCell(cols);
//				} else {
//					cell = row.getCell(cols);
//				}
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//
//				switch (cols) {
//
//				case 0:
//					if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[1]);
//					} else if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getPartProcessNumber());
//					}
////					cell.setCellValue(bean.getPartProcessNumber());
//					break;
//				case 1:
//					if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[1]);
//					} else if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcessName());
//					}
////					cell.setCellValue(bean.getProcessName());
//					break;
//				case 2:
//					if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[1]);
//					} else if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getMachineDevice());
//					}
////					cell.setCellValue(bean.getMachineDevice());
//					break;
//				case 3:
//					if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[1]);
//					} else if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSmjy(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSmjy());
//					}
////					cell.setCellValue(bean.getMachineDevice());
//					break;
//				case 4:
//					if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[1]);
//					} else if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getBubbledPrintNo(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getBubbledPrintNo());
//					}
////					cell.setCellValue(bean.getBubbledPrintNo());
//					break;
//				case 5:
//					if (bean.getSize() != null && bean.getSize().indexOf("\n") >= 0
//							&& bean.getSize().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSize().split("\n")[1]);
//					} else if (bean.getSize() != null && bean.getSize().indexOf("\n") >= 0
//							&& bean.getSize().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSize().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSize(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSize());
//					}
////					cell.setCellValue(bean.getSize());
//					break;
//				case 6:
//					if (bean.getNo() != null && bean.getNo().indexOf("\n") >= 0 && bean.getNo().split("\n").length == 2
//							&& type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getNo().split("\n")[1]);
//					} else if (bean.getNo() != null && bean.getNo().indexOf("\n") >= 0
//							&& bean.getNo().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getNo().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getNo(), indexMap.get(cols), indexMap.get(cols) + 1, 10,
//								"Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getNo());
//					}
////					cell.setCellValue(bean.getNo());
//					break;
//
//				case 7:
//					if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProduct().split("\n")[1]);
//					} else if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProduct().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProduct());
//					}
////					cell.setCellValue(bean.getProduct());
//					break;
//				case 8:
//					if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcess().split("\n")[1]);
//					} else if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcess().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcess());
//					}
////					cell.setCellValue(bean.getProcess());
//					break;
//				case 9:
//					if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[1]);
//					} else if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSpecialClass());
//					}
////					cell.setCellValue(bean.getSpecialClass());
//					break;
//				case 10:
//					if (bean.getConceal().equals("1")) {
//						String processName = bean.getProcessName();// .split("\n")[1];
//						String productId = bean.getMeopId().split("_")[0];
//						StringBuffer value = new StringBuffer();
//						System.out.println(value.length());
//						if (type.indexOf("CHINESE") != -1) {
//							String name = processName.split("\n")[0];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(3, name.length() - 1);
//							}
//							value.append("" + name + "ҵָ/" + productId);
//							// cell.setCellValue(""+processName+"ҵָ/"+productId);
//						}
//						if (type.indexOf("ENGLISH") != -1) {
//							String name = processName.split("\n")[1];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(8, name.length() - 1);
//							}
//							if (value.length() != 0)
//								value.append("\n");
//							value.append("In " + name + " OP INS/" + productId);
//
//						}
//						cell.setCellValue(value.toString());
//					} else {
//						if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("ENGLISH")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[1]);
//						} else if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("CHINESE")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[0]);
//						} else if (indexMap.get(cols) != null) {
//							cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
//									indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
//						} else {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance());
//						}
//					}
////					if (bean.getUpProductProcessSpecificationTolerance() == null) {
////						cell.setCellValue("");
////					} else if (!bean
////							.getUpProductProcessSpecificationTolerance().trim()
////							.isEmpty()
////							&& !bean.getDownProductProcessSpecificationTolerance()
////									.trim().isEmpty())
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance()
////								+ " "
////								+ bean.getUpProductProcessSpecificationTolerance()
////								+ "/"
////								+ bean.getDownProductProcessSpecificationTolerance());
////					else {
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance());
////					}
//					break;
//				case 11:
//					if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[1]);
//					} else if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("CHINESE")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
//					}
//					break;
//				case 12:
//					if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[1]);
//					} else if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleSize());
//					}
//					break;
//				case 13:
//					if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[1]);
//					} else if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleFreq());
//					}
//					break;
//
//				case 14:
//					if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[1]);
//					} else if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getControlMethod());
//					}
//					break;
//
//				case 15:
//					if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[1]);
//					} else if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getReactionPlan());
//					}
//					break;
//
//				default:
//					break;
//
//				}
//			}
//		}
//		if (map != null && map.size() != 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				List<Integer> columnIndex = new ArrayList<Integer>();
//				for (int i = 0; i < entry.getValue().length; i++) {
//					if (entry.getValue()[i] == 3 || (entry.getValue()[i] >= 18 && entry.getValue()[i] <= 20)
//							|| entry.getValue()[i] == 14 || entry.getValue()[i] == 16) {
//						continue;
//					} else if (entry.getValue()[i] >= 4 && entry.getValue()[i] <= 13) {
//						columnIndex.add(entry.getValue()[i] - 1);
//					} else if (entry.getValue()[i] == 15) {
//						columnIndex.add(entry.getValue()[i] - 2);
//					} else if (entry.getValue()[i] == 17) {
//						columnIndex.add(entry.getValue()[i] - 3);
//					} else {
//						columnIndex.add(entry.getValue()[i]);
//					}
//				}
//				int[] column = new int[columnIndex.size()];
//				for (int i = 0; i < columnIndex.size(); i++) {
//					column[i] = columnIndex.get(i);
//				}
//				if (column.length > 0) {
//					combine(sheet, entry.getKey(), column);
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * Ӣıͷ--ƼƻEXCEL
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeBogehuanaControlPlanToExcel2(TMomControlPlanBean controlPlanBean, InputStream input,
//			String outputFilePath) throws IOException {
//
//		FileOutputStream output = new FileOutputStream(new File(outputFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		int startRow = 13;
//		map.clear();
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			// for (int i = 0; i < (simpleBeanList.size()); i++)
//			// insertRow(sheet, 14, 1);// 
//			XSSFRow row1 = sheet.getRow(3);
//			setCellValue(row1, 0, row1.getCell(0).getStringCellValue() + controlPlanBean.getControlPlanNo());
//			setCellValue(row1, 5,
//					connectPhoneAndPersion(controlPlanBean.getKeyPersion(), controlPlanBean.getKeyPhone()));
//			setCellValue(row1, 9, controlPlanBean.getCreateDateStr());
//			setCellValue(row1, 12, controlPlanBean.getUpdateDateStr());
//			XSSFRow row2 = sheet.getRow(5);
//			setCellValue(row2, 0, controlPlanBean.getPartNumber());
//
//			setCellValue(row2, 5, controlPlanBean.getCoreTeam());
//			setCellValue(row2, 9, controlPlanBean.getCustromEngineeringApprovalDateStr());
//
//			XSSFRow row3 = sheet.getRow(7);
//			setCellValue(row3, 0, controlPlanBean.getPartNameDesc());
//			setCellValue(row3, 5, controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row3, 9, controlPlanBean.getCustromQuantyApprovalDateStr());
//
//			XSSFRow row4 = sheet.getRow(9);
//			setCellValue(row4, 0, controlPlanBean.getSupplier());
//			setCellValue(row4, 3, controlPlanBean.getSupplierCode());
//			setCellValue(row4, 5, controlPlanBean.getOtherApprovalDateStr());
//			setCellValue(row4, 9, controlPlanBean.getOtherApprovalIfDateStr());
//
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
//			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
//				getCombineRow(bean.getHbdyg(), startRow);
//			}
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			System.out.println("row = " + (i + startRow));
//			if ((i + startRow) > sheet.getLastRowNum()) {
//				row = sheet.createRow(i + startRow);
//				isCreat = true;
//			} else {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}
//			// ȡַλ
//			String[] columnNames = null;
//			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
//			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
//				try {
//					if (bean.getSpecial().indexOf("|") >= 0) {
//						columnNames = bean.getSpecial().split("\\|");
//					} else {
//						columnNames = new String[] { bean.getSpecial() };
//					}
//					if (columnNames != null && columnNames.length > 0) {
//						for (int i1 = 0; i1 < columnNames.length; i1++) {
//							if (columnNames[i1].indexOf("-") >= 0) {
//								String[] columnName = columnNames[i1].split("-");
//								// ͨƻȡ
//								int cellindex = -1;
//								if (columnName[0].indexOf(",") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
//								} else if (columnName[0].indexOf("/") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
//								} else {
//									cellindex = getOneNamedCellIndex(wb, columnName[0]);
//								}
//								if (cellindex > -1) {
//									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
//								}
//							}
//						}
//					}
//				} catch (Exception e) {
//					// TODO: handle exception
//					e.printStackTrace();
//				}
//			}
//			for (int cols = 0; cols < 13; cols++) {
//				XSSFCell cell = null;
//				if (isCreat) {
//					cell = row.createCell(cols);
//				} else {
//					cell = row.getCell(cols);
//				}
//				if (cell == null)
//					cell = row.getCell(cols);
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//
//				switch (cols) {
//
//				case 0:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getPartProcessNumber());
//					}
//					break;
//				case 1:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcessName());
//					}
//					break;
//				case 2:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getMachineDevice());
//					}
//					break;
//				case 3:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getNo(), indexMap.get(cols), indexMap.get(cols) + 1, 10,
//								"Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getNo());
//					}
//					break;
//				case 4:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProduct());
//					}
//					break;
//				case 5:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcess());
//					}
//					break;
//				case 6:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSpecialClass());
//					}
//					break;
//				case 7:
//					if (bean.getConceal().equals("1")) {
//						String processName = bean.getProcessName();
//						if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//							processName = bean.getProcessName().substring(3,
//									bean.getProcessName().toString().length() - 1);
//						}
//						cell.setCellValue("" + processName + "ҵָ");
//					} else {
//						if (indexMap.get(cols) != null) {
//							cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
//									indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
//						} else {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance());
//						}
//					}
////					if (bean.getUpProductProcessSpecificationTolerance() == null) {
////						sheet.addMergedRegion(new CellRangeAddress(
////								i + startRow, i + startRow + 1, 7, 8));
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance());
////					} else if (!bean
////							.getUpProductProcessSpecificationTolerance().trim()
////							.isEmpty()
////							&& !bean.getDownProductProcessSpecificationTolerance()
////									.trim().isEmpty()) {
////
////						sheet.addMergedRegion(new CellRangeAddress(
////								i + startRow, i + startRow + 1, 7, 7));
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance());
////						row.getCell(8)
////								.setCellValue(
////										bean.getUpProductProcessSpecificationTolerance());
////						XSSFRow rowNext = sheet.getRow(i + 1 + startRow);
////						rowNext.getCell(8)
////								.setCellValue(
////										bean.getDownProductProcessSpecificationTolerance());
////					} else {
////						sheet.addMergedRegion(new CellRangeAddress(
////								i + startRow, i + startRow + 1, 7, 8));
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance());
////					}
//					break;
//				case 8:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
//					}
//					break;
//				case 9:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleSize());
//					}
//					break;
//				case 10:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleFreq());
//					}
//					break;
//
//				case 11:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getControlMethod());
//					}
//					break;
//
//				case 12:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getReactionPlan());
//					}
//					break;
//
//				default:
//					break;
//
//				}
//			}
//		}
//		if (map != null && map.size() != 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				List<Integer> columnIndex = new ArrayList<Integer>();
//				for (int i = 0; i < entry.getValue().length; i++) {
//					if (entry.getValue()[i] == 3 || entry.getValue()[i] == 5 || entry.getValue()[i] == 6
//							|| (entry.getValue()[i] >= 18 && entry.getValue()[i] <= 20) || entry.getValue()[i] == 14
//							|| entry.getValue()[i] == 16) {
//						continue;
//					} else if (entry.getValue()[i] == 4) {
//						columnIndex.add(entry.getValue()[i] - 1);
//					} else if (entry.getValue()[i] >= 7 && entry.getValue()[i] <= 13) {
//						columnIndex.add(entry.getValue()[i] - 3);
//					} else if (entry.getValue()[i] == 15) {
//						columnIndex.add(entry.getValue()[i] - 4);
//					} else if (entry.getValue()[i] == 17) {
//						columnIndex.add(entry.getValue()[i] - 5);
//					} else {
//						columnIndex.add(entry.getValue()[i]);
//					}
//				}
//				int[] column = new int[columnIndex.size()];
//				for (int i = 0; i < columnIndex.size(); i++) {
//					column[i] = columnIndex.get(i);
//				}
//				if (column.length > 0) {
//					combine(sheet, entry.getKey(), column);
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}

	/**
	 * --ƼƻEXCEL
	 * 
	 * @param controlPlanBean ƼƻϢ
	 * @param input           ģļ
	 * @param outputFilePath  Ҫȫ·
	 * @throws IOException
	 */
//	public static int writeBogehuanaControlPlanToExcel(TMomControlPlanBean controlPlanBean, InputStream input,
//			String outputFilePath, String type) throws IOException {
//
//		FileOutputStream output = new FileOutputStream(new File(outputFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		int startRow = 13;
//		map.clear();
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			// for (int i = 0; i < (simpleBeanList.size()); i++)
//			// insertRow(sheet, 14, 1);// 
//			XSSFRow row1 = sheet.getRow(3);
//			setCellValue(row1, 0, row1.getCell(0).getStringCellValue() + controlPlanBean.getControlPlanNo());
//			setCellValue(row1, 6,
//					connectPhoneAndPersion(controlPlanBean.getKeyPersion(), controlPlanBean.getKeyPhone()));
//			setCellValue(row1, 10, controlPlanBean.getCreateDateStr());
//			setCellValue(row1, 12, controlPlanBean.getUpdateDateStr());
//			XSSFRow row2 = sheet.getRow(5);
//			setCellValue(row2, 0, controlPlanBean.getCustromPartNumber());
//
//			setCellValue(row2, 6, controlPlanBean.getCoreTeam());
//			setCellValue(row2, 10, controlPlanBean.getCustromEngineeringApprovalDateStr());
//
//			XSSFRow row3 = sheet.getRow(7);
//			setCellValue(row3, 0, controlPlanBean.getPartNameDesc());
//			setCellValue(row3, 6, controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row3, 10, controlPlanBean.getCustromQuantyApprovalDateStr());
//
//			XSSFRow row4 = sheet.getRow(9);
//			setCellValue(row4, 0, controlPlanBean.getSupplier());
//			setCellValue(row4, 4, controlPlanBean.getSupplierCode());
//			setCellValue(row4, 6, controlPlanBean.getOtherApprovalDateStr());
//			setCellValue(row4, 10, controlPlanBean.getOtherApprovalIfDateStr());
//
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
//			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
//				getCombineRow(bean.getHbdyg(), startRow);
//			}
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			System.out.println("row = " + (i + startRow));
//			if ((i + startRow) > sheet.getLastRowNum()) {
//				row = sheet.createRow(i + startRow);
//				isCreat = true;
//			} else {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}
//			// ȡַλ
//			String[] columnNames = null;
//			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
//			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
//				try {
//					if (bean.getSpecial().indexOf("|") >= 0) {
//						columnNames = bean.getSpecial().split("\\|");
//					} else {
//						columnNames = new String[] { bean.getSpecial() };
//					}
//					if (columnNames != null && columnNames.length > 0) {
//						for (int i1 = 0; i1 < columnNames.length; i1++) {
//							if (columnNames[i1].indexOf("-") >= 0) {
//								String[] columnName = columnNames[i1].split("-");
//								// ͨƻȡ
//								int cellindex = -1;
//								if (columnName[0].indexOf(",") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
//								} else if (columnName[0].indexOf("/") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
//								} else {
//									cellindex = getOneNamedCellIndex(wb, columnName[0]);
//								}
//								if (cellindex > -1) {
//									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
//								}
//							}
//						}
//					}
//				} catch (Exception e) {
//					// TODO: handle exception
//					e.printStackTrace();
//				}
//			}
//			for (int cols = 0; cols <= 13; cols++) {
//				XSSFCell cell = null;
//				if (isCreat) {
//					cell = row.createCell(cols);
//				} else {
//					cell = row.getCell(cols);
//				}
//				if (cell == null)
//					cell = row.getCell(cols);
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//
//				switch (cols) {
//
//				case 0:
//					if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[1]);
//					} else if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getPartProcessNumber());
//					}
//					break;
//				case 1:
//					if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[1]);
//					} else if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcessName());
//					}
//					break;
//				case 2:
//					if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[1]);
//					} else if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getMachineDevice());
//					}
//					break;
//				case 3:
//					if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[1]);
//					} else if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSmjy(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSmjy());
//					}
//					break;
//				case 4:
//					if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[1]);
//					} else if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getBubbledPrintNo(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getBubbledPrintNo());
//					}
//					break;
//				case 5:
//					if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProduct().split("\n")[1]);
//					} else if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProduct().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProduct());
//					}
//					break;
//				case 6:
//					if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcess().split("\n")[1]);
//					} else if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcess().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcess());
//					}
//					break;
//				case 7:
//					if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[1]);
//					} else if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSpecialClass());
//					}
//					break;
//				case 8:
//					if (bean.getConceal().equals("1")) {
//						String processName = bean.getProcessName();// .split("\n")[1];
//						String productId = bean.getMeopId().split("_")[0];
//						StringBuffer value = new StringBuffer();
//						System.out.println(value.length());
//						if (type.indexOf("CHINESE") != -1) {
//							String name = processName.split("\n")[0];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(3, name.length() - 1);
//							}
//							value.append("" + name + "ҵָ/" + productId);
//							// cell.setCellValue(""+processName+"ҵָ/"+productId);
//						}
//						if (type.indexOf("ENGLISH") != -1) {
//							String name = processName.split("\n")[1];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(8, name.length() - 1);
//							}
//							if (value.length() != 0)
//								value.append("\n");
//							value.append("In " + name + " OP INS/" + productId);
//
//						}
//						cell.setCellValue(value.toString());
//					} else {
//						if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("ENGLISH")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[1]);
//						} else if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("CHINESE")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[0]);
//						} else if (indexMap.get(cols) != null) {
//							cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
//									indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
//						} else {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance());
//						}
//					}
//					break;
//				case 9:
//					if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[1]);
//					} else if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("CHINESE")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
//					}
//					break;
//				case 10:
//					if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[1]);
//					} else if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleSize());
//					}
//					break;
//				case 11:
//					if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[1]);
//					} else if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleFreq());
//					}
//					break;
//
//				case 12:
//					if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[1]);
//					} else if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getControlMethod());
//					}
//					break;
//
//				case 13:
//					if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[1]);
//					} else if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getReactionPlan());
//					}
//					break;
//
//				default:
//					break;
//
//				}
//			}
//		}
//		if (map != null && map.size() != 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				List<Integer> columnIndex = new ArrayList<Integer>();
//				for (int i = 0; i < entry.getValue().length; i++) {
//					if (entry.getValue()[i] == 6 || entry.getValue()[i] == 7
//							|| (entry.getValue()[i] >= 17 && entry.getValue()[i] <= 20) || entry.getValue()[i] == 15) {
//						continue;
//					} else if (entry.getValue()[i] == 4) {
//						columnIndex.add(entry.getValue()[i] - 1);
//					} else if (entry.getValue()[i] >= 8 && entry.getValue()[i] <= 14) {
//						columnIndex.add(entry.getValue()[i] - 2);
//					} else if (entry.getValue()[i] == 16) {
//						columnIndex.add(entry.getValue()[i] - 3);
//					} else if (entry.getValue()[i] == 18) {
//						columnIndex.add(entry.getValue()[i] - 4);
//					} else {
//						columnIndex.add(entry.getValue()[i]);
//					}
//				}
//				int[] column = new int[columnIndex.size()];
//				for (int i = 0; i < columnIndex.size(); i++) {
//					column[i] = columnIndex.get(i);
//				}
//				if (column.length > 0) {
//					combine(sheet, entry.getKey(), column);
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * Ӣıͷ--ƼƻEXCEL
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeNBTMControlPlanToExcel(TMomControlPlanBean controlPlanBean, InputStream input,
//			String outputFilePath, String type) throws IOException {
//
//		FileOutputStream output = new FileOutputStream(new File(outputFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		int startRow = 13;
//		map.clear();
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			// for (int i = 0; i < (simpleBeanList.size()); i++)
//			// insertRow(sheet, 14, 1);// 
//			XSSFRow row1 = sheet.getRow(3);
//			setCellValue(row1, 0, row1.getCell(0).getStringCellValue() + controlPlanBean.getControlPlanNo());
//			setCellValue(row1, 5,
//					connectPhoneAndPersion(controlPlanBean.getKeyPersion(), controlPlanBean.getKeyPhone()));
//			setCellValue(row1, 10, controlPlanBean.getCreateDateStr());
//			setCellValue(row1, 12, controlPlanBean.getUpdateDateStr());
//			XSSFRow row2 = sheet.getRow(5);
//			setCellValue(row2, 0, controlPlanBean.getPartNumber());
//
//			setCellValue(row2, 6, controlPlanBean.getCoreTeam());
//			setCellValue(row2, 10, controlPlanBean.getCustromEngineeringApprovalDateStr());
//
//			XSSFRow row3 = sheet.getRow(7);
//			setCellValue(row3, 0, controlPlanBean.getPartNameDesc());
//			setCellValue(row3, 6, controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row3, 10, controlPlanBean.getCustromQuantyApprovalDateStr());
//
//			XSSFRow row4 = sheet.getRow(9);
//			setCellValue(row4, 0, controlPlanBean.getSupplier());
//			setCellValue(row4, 3, controlPlanBean.getSupplierCode());
//			setCellValue(row4, 6, controlPlanBean.getOtherApprovalDateStr());
//			setCellValue(row4, 10, controlPlanBean.getOtherApprovalIfDateStr());
//
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
//			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
//				getCombineRow(bean.getHbdyg(), startRow);
//			}
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			System.out.println("row = " + (i + startRow));
//			if ((i + startRow) > sheet.getLastRowNum()) {
//				row = sheet.createRow(i + startRow);
//				isCreat = true;
//			} else {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}
//			// ȡַλ
//			String[] columnNames = null;
//			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
//			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
//				try {
//					if (bean.getSpecial().indexOf("|") >= 0) {
//						columnNames = bean.getSpecial().split("\\|");
//					} else {
//						columnNames = new String[] { bean.getSpecial() };
//					}
//					if (columnNames != null && columnNames.length > 0) {
//						for (int i1 = 0; i1 < columnNames.length; i1++) {
//							if (columnNames[i1].indexOf("-") >= 0) {
//								String[] columnName = columnNames[i1].split("-");
//								// ͨƻȡ
//								int cellindex = -1;
//								if (columnName[0].indexOf(",") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
//								} else if (columnName[0].indexOf("/") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
//								} else {
//									cellindex = getOneNamedCellIndex(wb, columnName[0]);
//								}
//								if (cellindex > -1) {
//									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
//								}
//							}
//						}
//					}
//				} catch (Exception e) {
//					// TODO: handle exception
//					e.printStackTrace();
//				}
//			}
//			for (int cols = 0; cols <= 13; cols++) {
//				XSSFCell cell = null;
//				if (isCreat) {
//					cell = row.createCell(cols);
//				} else {
//					cell = row.getCell(cols);
//				}
//				if (cell == null)
//					cell = row.getCell(cols);
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//
//				switch (cols) {
//
//				case 0:
//					// ͨ type.equals("ENGLISH") жӢʾ
//					if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[1]);// Ӣʾ
//					} else if (bean.getPartProcessNumber() != null && bean.getPartProcessNumber().indexOf("\n") >= 0
//							&& bean.getPartProcessNumber().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getPartProcessNumber().split("\n")[0]); // ʾ
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getPartProcessNumber()); // ӢĶʾ
//					}
//					break;
//				case 1:
//					if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[1]);
//					} else if (bean.getProcessName() != null && bean.getProcessName().indexOf("\n") >= 0
//							&& bean.getProcessName().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcessName().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcessName());
//					}
//					break;
//				case 2:
//					if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[1]);
//					} else if (bean.getMachineDevice() != null && bean.getMachineDevice().indexOf("\n") >= 0
//							&& bean.getMachineDevice().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getMachineDevice().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getMachineDevice());
//					}
//					break;
//				case 3:
//					if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[1]);
//					} else if (bean.getSmjy() != null && bean.getSmjy().indexOf("\n") >= 0
//							&& bean.getSmjy().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSmjy().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSmjy(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSmjy());
//					}
//					break;
//				case 4:
//					if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[1]);
//					} else if (bean.getBubbledPrintNo() != null && bean.getBubbledPrintNo().indexOf("\n") >= 0
//							&& bean.getBubbledPrintNo().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getBubbledPrintNo().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getBubbledPrintNo(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getBubbledPrintNo());
//					}
//					break;
//				case 5:
//					if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProduct().split("\n")[1]);
//					} else if (bean.getProduct() != null && bean.getProduct().indexOf("\n") >= 0
//							&& bean.getProduct().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProduct().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProduct());
//					}
//					break;
//				case 6:
//					if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getProcess().split("\n")[1]);
//					} else if (bean.getProcess() != null && bean.getProcess().indexOf("\n") >= 0
//							&& bean.getProcess().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getProcess().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcess());
//					}
//					break;
//				case 7:
//					if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[1]);
//					} else if (bean.getSpecialClass() != null && bean.getSpecialClass().indexOf("\n") >= 0
//							&& bean.getSpecialClass().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSpecialClass().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSpecialClass());
//					}
//					break;
//				case 8:
//					if (bean.getConceal().equals("1")) {
//						String processName = bean.getProcessName();// .split("\n")[1];
//						String productId = bean.getMeopId().split("_")[0];
//						StringBuffer value = new StringBuffer();
//						System.out.println(value.length());
//						if (type.indexOf("CHINESE") != -1) {
//							String name = processName.split("\n")[0];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(3, name.length() - 1);
//							}
//							value.append("" + name + "ҵָ/" + productId);
//							// cell.setCellValue(""+processName+"ҵָ/"+productId);
//						}
//						if (type.indexOf("ENGLISH") != -1) {
//							String name = processName.split("\n")[1];
//							if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//								name = name.substring(8, name.length() - 1);
//							}
//							if (value.length() != 0)
//								value.append("\n");
//							value.append("In " + name + " OP INS/" + productId);
//
//						}
//						cell.setCellValue(value.toString());
//					} else {
//						if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("ENGLISH")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[1]);
//						} else if (bean.getProductProcessSpecificationTolerance() != null
//								&& bean.getProductProcessSpecificationTolerance().indexOf("\n") >= 0
//								&& bean.getProductProcessSpecificationTolerance().split("\n").length == 2
//								&& type.equals("CHINESE")) {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance().split("\n")[0]);
//						} else if (indexMap.get(cols) != null) {
//							cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
//									indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
//						} else {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance());
//						}
//					}
//					break;
//				case 9:
//					if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[1]);
//					} else if (bean.getEvaluationMeasurementTechnique() != null
//							&& bean.getEvaluationMeasurementTechnique().indexOf("\n") >= 0
//							&& bean.getEvaluationMeasurementTechnique().split("\n").length == 2
//							&& type.equals("CHINESE")) {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
//					}
//					break;
//				case 10:
//					if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[1]);
//					} else if (bean.getSampleSize() != null && bean.getSampleSize().indexOf("\n") >= 0
//							&& bean.getSampleSize().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleSize().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleSize());
//					}
//					break;
//				case 11:
//					if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[1]);
//					} else if (bean.getSampleFreq() != null && bean.getSampleFreq().indexOf("\n") >= 0
//							&& bean.getSampleFreq().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getSampleFreq().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleFreq());
//					}
//					break;
//
//				case 12:
//					if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[1]);
//					} else if (bean.getControlMethod() != null && bean.getControlMethod().indexOf("\n") >= 0
//							&& bean.getControlMethod().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getControlMethod().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getControlMethod());
//					}
//					break;
//
//				case 13:
//					if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("ENGLISH")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[1]);
//					} else if (bean.getReactionPlan() != null && bean.getReactionPlan().indexOf("\n") >= 0
//							&& bean.getReactionPlan().split("\n").length == 2 && type.equals("CHINESE")) {
//						cell.setCellValue(bean.getReactionPlan().split("\n")[0]);
//					} else if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getReactionPlan());
//					}
//					break;
//
//				default:
//					break;
//
//				}
//			}
//		}
//		if (map != null && map.size() != 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				List<Integer> columnIndex = new ArrayList<Integer>();
//				for (int i = 0; i < entry.getValue().length; i++) {
//					if (entry.getValue()[i] == 3 || entry.getValue()[i] == 5 || entry.getValue()[i] == 6
//							|| (entry.getValue()[i] >= 18 && entry.getValue()[i] <= 20) || entry.getValue()[i] == 14
//							|| entry.getValue()[i] == 16) {
//						continue;
//					} else if (entry.getValue()[i] == 4) {
//						columnIndex.add(entry.getValue()[i] - 1);
//					} else if (entry.getValue()[i] >= 7 && entry.getValue()[i] <= 13) {
//						columnIndex.add(entry.getValue()[i] - 3);
//					} else if (entry.getValue()[i] == 15) {
//						columnIndex.add(entry.getValue()[i] - 4);
//					} else if (entry.getValue()[i] == 17) {
//						columnIndex.add(entry.getValue()[i] - 5);
//					} else {
//						columnIndex.add(entry.getValue()[i]);
//					}
//				}
//				int[] column = new int[columnIndex.size()];
//				for (int i = 0; i < columnIndex.size(); i++) {
//					column[i] = columnIndex.get(i);
//				}
//				if (column.length > 0) {
//					combine(sheet, entry.getKey(), column);
//				}
//			}
//		}
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * ƼƻEXCEL
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeControlPlanToExcel(TMomControlPlanBean controlPlanBean, File file) throws IOException {
//		file.setWritable(true);
//		InputStream is = new FileInputStream(file);
//		XSSFWorkbook wb = new XSSFWorkbook(is);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		map.clear();
//		int startRow = 13;
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			for (int i = 0; i < (simpleBeanList.size()); i++)
//				insertRow(sheet, 13, 1);// 
//			XSSFRow row1 = sheet.getRow(3);
//			setCellValue(row1, 4, controlPlanBean.getControlPlanNo());
//			setCellValue(row1, 8, controlPlanBean.getKeyPersion());
//			setCellValue(row1, 10, controlPlanBean.getKeyPhone());
//			setCellValue(row1, 12, controlPlanBean.getCreateDateStr());
//			setCellValue(row1, 15, controlPlanBean.getUpdateDateStr());
//			XSSFRow row2 = sheet.getRow(5);
//			setCellValue(row2, 0, controlPlanBean.getSorName());
//			setCellValue(row2, 4, controlPlanBean.getPartNumber());
//			setCellValue(row2, 8, controlPlanBean.getCoreTeam());
//			setCellValue(row2, 12, controlPlanBean.getCustromEngineeringApprovalDateStr());
//			XSSFRow row3 = sheet.getRow(7);
//			setCellValue(row3, 0, controlPlanBean.getCustromPartNumber());
//			setCellValue(row3, 4, controlPlanBean.getPartNameDesc());
//			setCellValue(row3, 8, controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row3, 12, controlPlanBean.getCustromQuantyApprovalDateStr());
//			XSSFRow row4 = sheet.getRow(9);
//			setCellValue(row4, 0, controlPlanBean.getSupplier());
//			setCellValue(row4, 4, controlPlanBean.getSupplierCode());
//			setCellValue(row4, 6, controlPlanBean.getChangeLev());
//			setCellValue(row4, 8, controlPlanBean.getMode());
//			setCellValue(row4, 10, controlPlanBean.getCustromApprovalDateStr());
//			setCellValue(row4, 12, controlPlanBean.getOtherApprovalDateStr());
//			setCellValue(row4, 15, controlPlanBean.getOtherApprovalIfDateStr());
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
//			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
//				getCombineRow(bean.getHbdyg(), startRow);
//			}
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			if ((i + startRow) > sheet.getLastRowNum()) {
//				row = sheet.createRow(i + startRow);
//				isCreat = true;
//			} else {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}
//			// ȡַλ+++++++++++++++++
//			String[] columnNames = null;
//			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
//			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
//				try {
//					if (bean.getSpecial().indexOf("|") >= 0) {
//						columnNames = bean.getSpecial().split("\\|");
//					} else {
//						columnNames = new String[] { bean.getSpecial() };
//					}
//					if (columnNames != null && columnNames.length > 0) {
//						for (int i1 = 0; i1 < columnNames.length; i1++) {
//							if (columnNames[i1].indexOf("-") >= 0) {
//								String[] columnName = columnNames[i1].split("-");
//								// ͨƻȡ
//								int cellindex = -1;
//								if (columnName[0].indexOf(",") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
//								} else if (columnName[0].indexOf("/") >= 0) {
//									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
//								} else {
//									cellindex = getOneNamedCellIndex(wb, columnName[0]);
//								}
//								if (cellindex > -1) {
//									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
//								}
//							}
//						}
//					}
//				} catch (Exception e) {
//					// TODO: handle exception
//					e.printStackTrace();
//				}
//			}
//			for (int cols = 0; cols < 18; cols++) {
//				XSSFCell cell = null;
//				if (isCreat) {
//					cell = row.createCell(cols);
//				} else {
//					cell = row.getCell(cols);
//				}
//				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
//
//				switch (cols) {
//
//				case 0:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getPartProcessNumber());
//					}
//					break;
//				case 1:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcessName());
//					}
//					break;
//				case 2:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getMachineDevice());
//					}
//					break;
//				case 3:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSmjy(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSmjy());
//					}
//					break;
//				case 4:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getBubbledPrintNo(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getBubbledPrintNo());
//					}
//					break;
//				case 5:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSize(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSize());
//					}
//					break;
//				case 6:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getNo(), indexMap.get(cols), indexMap.get(cols) + 1, 10,
//								"Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getNo());
//					}
//					break;
//				case 7:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProduct());
//					}
//					break;
//				case 8:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getProcess());
//					}
//					break;
//				case 9:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSpecialClass());
//					}
//					break;
//				case 10:
//					if (bean.getConceal().equals("1")) {
//						String processName = bean.getProcessName();
//						if (bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0) {
//							processName = bean.getProcessName().substring(3,
//									bean.getProcessName().toString().length() - 1);
//						}
//						cell.setCellValue("" + processName + "ҵָ");
//					} else {
//						if (indexMap.get(cols) != null) {
//							cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
//									indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
//						} else {
//							cell.setCellValue(bean.getProductProcessSpecificationTolerance());
//						}
//					}
////ע
////					if (bean.getUpProductProcessSpecificationTolerance() == null) {
////						cell.setCellValue("");
////					} else if (!bean
////							.getUpProductProcessSpecificationTolerance().trim()
////							.isEmpty()
////							&& !bean.getDownProductProcessSpecificationTolerance()
////									.trim().isEmpty())
////						cell.setCellValue(bean
////								.getProductProcessSpecificationTolerance()
////								+ " "
////								+ bean.getUpProductProcessSpecificationTolerance()
////								+ "/"
////								+ bean.getDownProductProcessSpecificationTolerance());
////					else {
////						
////					}
////ע
//					break;
//				case 11:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
//					}
//					break;
//				case 12:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleSize());
//					}
//					break;
//				case 13:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getSampleFreq());
//					}
//					break;
//				case 14:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getResp(), indexMap.get(cols), indexMap.get(cols) + 1,
//								10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getResp());
//					}
//					break;
//				case 15:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getControlMethod());
//					}
//					break;
//				case 16:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getOperationCriteria(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getOperationCriteria());
//					}
//					break;
//				case 17:
//					if (indexMap.get(cols) != null) {
//						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
//								indexMap.get(cols) + 1, 10, "Y14.5M"));
//					} else {
//						cell.setCellValue(bean.getReactionPlan());
//					}
//					break;
//
//				default:
//					break;
//
//				}
//			}
//		}
//		if (map != null && map.size() != 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				List<Integer> columnIndex = new ArrayList<Integer>();
//				for (int i = 0; i < entry.getValue().length; i++) {
//					if ((entry.getValue()[i] >= 18 && entry.getValue()[i] <= 20)) {
//						continue;
//					} else {
//						columnIndex.add(entry.getValue()[i]);
//					}
//				}
//				int[] column = new int[columnIndex.size()];
//				for (int i = 0; i < columnIndex.size(); i++) {
//					column[i] = columnIndex.get(i);
//				}
//				if (column.length > 0) {
//					combine(sheet, entry.getKey(), column);
//				}
//			}
//		}
//		//+++++++++++++++++++
//		FileOutputStream output = new FileOutputStream(file);
//		wb.write(output);
//		output.close();
//		is.close();
//		// file.setReadOnly();
//		System.out.println("-------WRITE EXCEL OVER-------");
//		return 0;
//	}
//
//	/**
//	 * ƼƻEXCEL
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeControlPlanToExcel(TMomControlPlanBean controlPlanBean, File file, String outFilePath)
//			throws IOException {
//		InputStream input = new FileInputStream(file);
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		map.clear();
//		int startRow = 9;
//		List<TMomControlPlanSimpleBean> simpleBeanList = null;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			simpleBeanList = controlPlanBean.getSimpleBeanList();
//
//			for (int i = 0; i < (simpleBeanList.size()); i++) {
//				//+++
//				if (simpleBeanList.get(i).getHbdyg() != null && !simpleBeanList.get(i).getHbdyg().equals("")) {
//					String sombine = simpleBeanList.get(i).getHbdyg().toString();
//					int rowDif = 0;
//					String[] sombines;
//					if (sombine.indexOf("-") >= 0) {
//						sombines = sombine.split("-");
//					} else {
//						sombines = new String[] { sombine };
//					}
//					for (int j = 0; j < sombines.length; j++) {
//						if (sombines[j].indexOf("/") >= 0) {
//							int[] row;
//							int[] cloumn;
//							String[] cells = sombines[j].split("/");
//							if (cells[0].indexOf(",") >= 0) {
//								String[] rows = cells[0].split(",");
//								row = new int[rows.length];
//								for (int k = 0; k < rows.length; k++) {
//									row[k] = Integer.parseInt(rows[k]) + rowDif;
//								}
//							} else {
//								row = new int[] { Integer.parseInt(cells[0]) + rowDif };
//							}
//							if (cells[1].indexOf(",") >= 0) {
//								String[] cloumns = cells[1].split(",");
//								cloumn = new int[cloumns.length];
//								for (int k = 0; k < cloumns.length; k++) {
//									cloumn[k] = Integer.parseInt(cloumns[k]);
//								}
//							} else {
//								cloumn = new int[] { Integer.parseInt(cells[1]) };
//							}
//							map.put(row, cloumn);
//						}
//					}
//				}
//				//+++
//				// insertRow(sheet, 13, 1);// 
//			}
//			XSSFRow row3 = sheet.getRow(2);
//			//setCellValue(row3, 0,"Ƽƻ:"+ controlPlanBean.getControlType()+"\nƼƻ:"+controlPlanBean.getControlPlanNo());
//			
//			setCellValue(row3,5,"Ҫϵ/绰:"+controlPlanBean.getKeyPhone());
//			setCellValue(row3,10,"ڣƣ:"+controlPlanBean.getCreateDateStr());
//			setCellValue(row3,13,"ڣ޶:"+controlPlanBean.getUpdateDateStr());
//			XSSFRow row4 = sheet.getRow(3);
//			setCellValue(row4,0,"/¸ĳ̶ȣ"+controlPlanBean.getPartNumber());
//			setCellValue(row4,5,"С:"+controlPlanBean.getCoreTeam());
//			setCellValue(row4,10,"˿͹׼/(Ҫ):"+controlPlanBean.getCustromEngineeringApprovalDateStr());
//			XSSFRow row5 = sheet.getRow(4);
//			setCellValue(row5,0,"/:"+controlPlanBean.getPartNameDesc());
//			setCellValue(row5,5,"/׼/ڣ"+controlPlanBean.getSupplierApprovalDateStr());
//			setCellValue(row5,10,"˿׼/(Ҫ):"+controlPlanBean.getCustromQuantyApprovalDateStr());
//			XSSFRow row6 = sheet.getRow(5);
//			setCellValue(row6,0,"/:"+controlPlanBean.getSupplier());
//			setCellValue(row6,3,":"+controlPlanBean.getSupplierCode());
//			setCellValue(row6,5,"׼/(Ҫ):"+controlPlanBean.getOtherApprovalDateStr());
//			setCellValue(row6,10,"׼/(Ҫ):"+controlPlanBean.getOtherApprovalIfDateStr());
//			
//		} else {
//			return -1;
//		}
//		if (simpleBeanList == null) {
//			return -1;
//		}
//		for (int i = 0; i < simpleBeanList.size(); i++) {
//			
//			XSSFRow row = null;
//			Boolean isCreat = false;
//			if(i<22) {
//				row = sheet.getRow(i + startRow);
//				isCreat = false;
//			}else{
//			row = sheet.createRow(i+ startRow);
//			isCreat = true;
//			}
//			if (isCreat) {
//				XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//				for (int j = 0; j < 15; j++) {
//					XSSFCell oldCell = oldRow.getCell(j);
//					XSSFCell newCell = row.createCell(j);
//					newCell.setCellStyle(oldCell.getCellStyle());
//					newCell.setCellType(oldCell.getCellType());
//				}
//				combine(sheet, new int[] { i + startRow }, new int[] { 4, 5 });
//				combine(sheet, new int[] { i + startRow }, new int[] { 9, 10 });
//			}
//			XSSFCell cell0 = row.getCell(0);
//			cell0.setCellValue(simpleBeanList.get(i).getPartProcessNumber());
//			XSSFCell cell1 = row.getCell(1);
//			cell1.setCellValue(simpleBeanList.get(i).getProcessName());
//			XSSFCell cell2 = row.getCell(2);
//			cell2.setCellValue(simpleBeanList.get(i).getMachineDevice());
//			XSSFCell cell3 = row.getCell(3);
//			cell3.setCellValue(simpleBeanList.get(i).getNo());
//			XSSFCell cell4 = row.getCell(4);
//			cell4.setCellValue(simpleBeanList.get(i).getProduct());
//			XSSFCell cell6 = row.getCell(6);
//			cell6.setCellValue(simpleBeanList.get(i).getProcess());
////			XSSFCell cell7 = row.getCell(7);
////			cell7.setCellValue(simpleBeanList.get(i).getSpecialClass());
//			
//			//+++ַݿRB3_SPETABLEѯӦַ
//			XSSFCell cell7 = row.getCell(7);
//			ResultSet rs = null;
//			SqlUtilT.getTCConnection();
//			String selectSQL = String.format("SELECT SPE FROM RB3_SPETABLE WHERE ORI='%s'",simpleBeanList.get(i).getSpecialClass());
//			System.out.print(selectSQL);
//			try {
//				String ss=simpleBeanList.get(i).getSpecialClass();
//				rs = SqlUtilT.read(selectSQL);
//				while (rs.next()) {
//					ss=rs.getString("SPE");
//				}
//				cell7.setCellValue(ss);
//			} catch (SQLException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//			//+++
//			
//			XSSFCell cell8 = row.getCell(8);
//			cell8.setCellValue(simpleBeanList.get(i).getProductProcessSpecificationTolerance());
//			XSSFCell cell9 = row.getCell(9);
//			cell9.setCellValue(simpleBeanList.get(i).getEvaluationMeasurementTechnique());
//			XSSFCell cell11 = row.getCell(11);
//			cell11.setCellValue(simpleBeanList.get(i).getSampleSize());
//			XSSFCell cell12 = row.getCell(12);
//			cell12.setCellValue(simpleBeanList.get(i).getSampleFreq());
//			XSSFCell cell13 = row.getCell(13);
//			cell13.setCellValue(simpleBeanList.get(i).getControlMethod());
//			XSSFCell cell14 = row.getCell(14);
//			cell14.setCellValue(simpleBeanList.get(i).getReactionPlan());
//		}
////			TMomControlPlanSimpleBean bean = simpleBeanList.get(i);
////			if (bean.getHbdyg() != null && !bean.getHbdyg().equals("")) {
////				getCombineRow(bean.getHbdyg(), startRow);
////			}
////			XSSFRow row = null;
////			Boolean isCreat = false;
////			if ((i + startRow) > sheet.getLastRowNum()) {
////				row = sheet.createRow(i + startRow);
////				isCreat = true;
////			} else {
////				row = sheet.getRow(i + startRow);
////				isCreat = false;
////			}
////			
////			// ȡַλ++++++
////			String[] columnNames = null;
////			Map<Integer, Integer> indexMap = new HashMap<Integer, Integer>();
////			if (bean.getSpecial() != null && !bean.getSpecial().equals("")) {
////				try {
////					if (bean.getSpecial().indexOf("|") >= 0) {
////						columnNames = bean.getSpecial().split("\\|");
////					} else {
////						columnNames = new String[] { bean.getSpecial() };
////					}
////					if (columnNames != null && columnNames.length > 0) {
////						for (int i1 = 0; i1 < columnNames.length; i1++) {
////							if (columnNames[i1].indexOf("-") >= 0) {
////								String[] columnName = columnNames[i1].split("-");
////								// ͨƻȡ
////								int cellindex = -1;
////								if (columnName[0].indexOf(",") >= 0) {
////									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll(",", ""));
////								} else if (columnName[0].indexOf("/") >= 0) {
////									cellindex = getOneNamedCellIndex(wb, columnName[0].replaceAll("/", ""));
////								} else {
////									cellindex = getOneNamedCellIndex(wb, columnName[0]);
////								}
////								if (cellindex > -1) {
////									indexMap.put(cellindex, Integer.parseInt(columnName[1]));
////								}
////							}
////						}
////					}
////				} catch (Exception e) {
////					// TODO: handle exception
////					e.printStackTrace();
////				}
////			}
////			for (int cols = 0; cols < 18; cols++) {
////				XSSFCell cell = null;
////				if (isCreat) {
////					cell = row.createCell(cols);
////				} else {
////					cell = row.getCell(cols);
////				}
////				cell.setCellType(XSSFCell.CELL_TYPE_STRING);// ıʽ
////
////				switch (cols) {
////
////				case 0:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getPartProcessNumber(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getPartProcessNumber());
////					}
////					break;
////				case 1:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getProcessName(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getProcessName());
////					}
////					break;
////				case 2:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getMachineDevice(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getMachineDevice());
////					}
////					break;
////				case 3:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getSmjy(), indexMap.get(cols), indexMap.get(cols) + 1,
////								10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getSmjy());
////					}
////					break;
////				case 4:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getBubbledPrintNo(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getBubbledPrintNo());
////					}
////					break;
////				case 5:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getSize(), indexMap.get(cols), indexMap.get(cols) + 1,
////								10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getSize());
////					}
////					break;
////				case 6:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getNo(), indexMap.get(cols), indexMap.get(cols) + 1, 10,
////								"Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getNo());
////					}
////					break;
////				case 7:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getProduct(), indexMap.get(cols), indexMap.get(cols) + 1,
////								10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getProduct());
////					}
////					break;
////				case 8:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getProcess(), indexMap.get(cols), indexMap.get(cols) + 1,
////								10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getProcess());
////					}
////					break;
////				case 9:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getSpecialClass(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getSpecialClass());
////					}
////					break;
////				case 10:
//////					if(bean.getConceal().equals("1"))
//////					{
//////						String processName = bean.getProcessName();
//////						if(bean.getProcessName() != null && bean.getProcessName().indexOf("飨") >= 0)
//////						{
//////							processName = bean.getProcessName().substring(3, bean.getProcessName().toString().length()-1);
//////						}
//////						cell.setCellValue(""+processName+"ҵָ");
//////					}
//////					else
//////					{
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getProductProcessSpecificationTolerance(),
////								indexMap.get(cols), indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getProductProcessSpecificationTolerance());
////					}
//////ע
//////					}
//////					if (bean.getUpProductProcessSpecificationTolerance() == null) {
//////						cell.setCellValue("");
//////					} else if (!bean
//////							.getUpProductProcessSpecificationTolerance().trim()
//////							.isEmpty()
//////							&& !bean.getDownProductProcessSpecificationTolerance()
//////									.trim().isEmpty())
//////						cell.setCellValue(bean
//////								.getProductProcessSpecificationTolerance()
//////								+ " "
//////								+ bean.getUpProductProcessSpecificationTolerance()
//////								+ "/"
//////								+ bean.getDownProductProcessSpecificationTolerance());
//////					else {
//////						
//////					}
//////ע
////					break;
////				case 11:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getEvaluationMeasurementTechnique(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getEvaluationMeasurementTechnique());
////					}
////					break;
////				case 12:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getSampleSize(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getSampleSize());
////					}
////					break;
////				case 13:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getSampleFreq(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getSampleFreq());
////					}
////					break;
////				case 14:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getResp(), indexMap.get(cols), indexMap.get(cols) + 1,
////								10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getResp());
////					}
////					break;
////				case 15:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getControlMethod(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getControlMethod());
////					}
////					break;
////				case 16:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getOperationCriteria(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getOperationCriteria());
////					}
////					break;
////				case 17:
////					if (indexMap.get(cols) != null) {
////						cell.setCellValue(setCellFont(wb, bean.getReactionPlan(), indexMap.get(cols),
////								indexMap.get(cols) + 1, 10, "Y14.5M"));
////					} else {
////						cell.setCellValue(bean.getReactionPlan());
////					}
////					break;
////
////				default:
////					break;
////
////				}
////			}
////		}
////		if (map != null && map.size() != 0) {
////			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
////			while (it.hasNext()) {
////				Map.Entry<int[], int[]> entry = it.next();
////				List<Integer> columnIndex = new ArrayList<Integer>();
////				for (int i = 0; i < entry.getValue().length; i++) {
////					if ((entry.getValue()[i] >= 18 && entry.getValue()[i] <= 20)) {
////						continue;
////					} else {
////						columnIndex.add(entry.getValue()[i]);
////					}
////				}
////				int[] column = new int[columnIndex.size()];
////				for (int i = 0; i < columnIndex.size(); i++) {
////					column[i] = columnIndex.get(i);
////				}
////				if (column.length > 0) {
////					combine(sheet, entry.getKey(), column);
////				}
////			}
////		}
//		//+++
//		// ϲԪ
//		if (map != null && map.size() > 0) {
//			Iterator<Map.Entry<int[], int[]>> it = map.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<int[], int[]> entry = it.next();
//				int[] row = new int[entry.getKey().length];
//				int[] column = new int[entry.getValue().length];
//				for (int k = 0; k < entry.getKey().length; k++) {
//					//row[k] = entry.getKey()[k] + 17;
//					row[k] = entry.getKey()[k]+9 ;
//				}
//				for (int k = 0; k < entry.getValue().length; k++) {
//					if(entry.getValue()[k]<=5) {
//						column[k] = entry.getValue()[k] -1;
//					}else if(entry.getValue()[k]>9) {
//						column[k] = entry.getValue()[k] +1;
//					}else {
//						column[k] = entry.getValue()[k];
//					}
//				}
//				if(column.length==1&&column[0]==4){
//					for(int s=0;s<row.length;s++) {
//						removeMergedRegion(sheet,row[s],column[0]);
//					}
//					ExcelUtil.combine_XSSF(sheet, row, new int[]{column[0],5});
//				}else if(column.length==1&&column[0]==9) {
//					for(int s=0;s<row.length;s++) {
//						removeMergedRegion(sheet,row[s],column[0]);
//					}
//					ExcelUtil.combine_XSSF(sheet, row, new int[]{column[0],10});
//				}else {
//					ExcelUtil.combine_XSSF(sheet, row, column);
//				}
//				
//			}
//		}
//		//+++
//////++++++++++
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}

	//+++ƳϲĵԪ
	 public static void removeMergedRegion(XSSFSheet sheet,int row ,int column)  
     {  
	      int sheetMergeCount = sheet.getNumMergedRegions();//ȡеĵԪ 
	      int index = 0;//ڱҪƳǸԪ
	      for (int i = 0; i < sheetMergeCount; i++) { 
	       CellRangeAddress ca = sheet.getMergedRegion(i); //ȡiԪ
	       int firstColumn = ca.getFirstColumn();  
	       int lastColumn = ca.getLastColumn();  
	       int firstRow = ca.getFirstRow();  
	       int lastRow = ca.getLastRow();  
	       if(row >= firstRow && row <= lastRow)  
	       {  
	        if(column >= firstColumn && column <= lastColumn)  
	        {  
	           index = i;
	        }  
	       }  
	      }
	      sheet.removeMergedRegion(index);//ƳϲԪ
     }  
//+++
	
	/**
	 * ıݼ
	 * 
	 * @param tccomponentDataset
	 * @param quote
	 * @param type
	 * @param path
	 * @throws TCException
	 */
	public static void changeDataSet(TCComponentDataset tccomponentDataset, String quote, String type, String path)
			throws TCException {
		String myPath[] = { path };
		String myQuote[] = { quote };// "excel"
		String myType[] = { type };// "MSExcelX"
		String myPlain[] = { "Plain" };

		// ɾݼ
		deleDateSetRef(tccomponentDataset);
		// ݼ滻
		tccomponentDataset.setFiles(myPath, myType, myPlain, myQuote);

	}

	/**
	 * ɾݼ
	 * 
	 * @param dataset
	 * @throws TCException
	 */
	private static void deleDateSetRef(TCComponentDataset dataset) throws TCException {

		TCComponentTcFile[] tcFiles = dataset.getTcFiles();
		for (int i = 0; i < tcFiles.length; i++) {
			// õݼ
			String str_temp = getNamedRefType(dataset, tcFiles[i]);
			// ɾ
			dataset.removeNamedReference(str_temp);
		}

	}

	/**
	 * õݼ
	 * 
	 * @param datasetComponent
	 * @param tccomponent
	 * @return
	 * @throws TCException
	 */
	private static String getNamedRefType(TCComponentDataset datasetComponent, TCComponentTcFile tccomponent)
			throws TCException {
		String s;
		s = "";
		TCProperty tcproperty;
		TCProperty tcproperty1;
		TCComponent atccomponent[];
		String as[];
		int i;
		int j;
		int k;
		try {
			tcproperty = datasetComponent.getTCProperty("ref_list");
			tcproperty1 = datasetComponent.getTCProperty("ref_names");
			if (tcproperty == null || tcproperty1 == null)
				return s;
		} catch (TCException tcexception) {
			return s;
		}
		atccomponent = tcproperty.getReferenceValueArray();
		as = tcproperty1.getStringValueArray();
		if (atccomponent == null || as == null)
			return s;
		i = atccomponent.length;
		if (i != as.length)
			return s;
		j = -1;
		k = 0;
		do {
			if (k >= i)
				break;
			if (tccomponent == atccomponent[k]) {
				j = k;
				break;
			}
			k++;
		} while (true);
		if (j != -1)
			s = as[j];
		return s;
	}

	/**
	 * ļ
	 * 
	 * @param comps
	 * @return
	 * @throws TCException
	 * @throws IOException
	 */
//	public static String downLoadFile(TCComponentDataset dateSet, String compType) throws TCException, IOException {
//		String value = "";
//		String tempPath = System.getenv("TEMP");
//		// MessageBox.post(" tempPath = "+tempPath,"INFO",MessageBox.INFORMATION);
//		if (tempPath == null) {
//			tempPath = "";
//		} else if (!tempPath.endsWith("\\")) {
//			tempPath = tempPath + "\\";
//		}
//		SimpleDateFormat sdf = new SimpleDateFormat("yyyymmdd");
//		TCComponentTcFile[] tcFiles = dateSet.getTcFiles();
//		File file = null;
//		if (tcFiles != null) {
//			file = tcFiles[0].getFmsFile();
//			String fileName = file.getName();
//			String fileDix = fileName.substring(fileName.lastIndexOf("."), fileName.length());
//			fileName = tempPath + sdf.format(new Date()) + fileDix;
//			File dirFile = new File(fileName);
//			FileUtility.copyFile(file, dirFile);
////			if (compType.equals("MSExcelX")) {
////				this.excelDataset = (TCComponentDataset) comp;
////			}
//			return fileName;
//		}
//		return value;
//	}
//
//	public static void setFlowChart(Map<String, String> valueMap, File file) {
//		// TODO Auto-generated method stub
//		file.setWritable(true);
//		try {
//			InputStream is = new FileInputStream(file);
//			XSSFWorkbook wb = new XSSFWorkbook(is);// (
//			XSSFSheet sheet = wb.getSheetAt(0);
//
//			Iterator<Map.Entry<String, String>> it = valueMap.entrySet().iterator();
//			while (it.hasNext()) {
//				Map.Entry<String, String> entry = it.next();
//				setNamedCellValue(wb, entry.getKey(), entry.getValue());
//			}
//			FileOutputStream output = new FileOutputStream(file);
//			wb.write(output);
//			output.close();
//			is.close();
//		} catch (Exception e) {
//			// TODO: handle exception
//			e.printStackTrace();
//		}
//		// file.setReadOnly();
//		System.out.println("-------WRITE EXCEL OVER-------");
//	}
//
//	public static Workbook getWorkbok(File file) throws IOException {
//		Workbook wb = null;
//		FileInputStream in = new FileInputStream(file);
//		System.out.println(file.getName());
//
//		if (file.getName().endsWith(EXCEL_XLS)) { // Excel&nbsp;2003
//			wb = new HSSFWorkbook(in);
//		} else if (file.getName().endsWith(EXCEL_XLSX)) { // Excel 2007/2010
//			System.out.println("OK");
//			wb = new XSSFWorkbook(in);
//		}
//		return wb;
//	}

	/**
	 * ȡEXCEL
	 * 
	 * @param File excel_file
	 * @return List<List<String>> صϢ
	 * @throws IOException
	 * @throws FileNotFoundException
	 */
//	public static List<String> readExcelByEntrustment(File excel_file, String type)
//			throws FileNotFoundException, IOException {
//		if (excel_file == null || !excel_file.exists()) {
//			return null;
//		}
//		// صееϢ
//		List<String> lines_msg = new ArrayList<String>();
//		XSSFWorkbook workBook = new XSSFWorkbook(new FileInputStream(excel_file));
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(workBook);
//		XSSFSheet sheet = workBook.getSheetAt(0);
//		XSSFRow title_row = sheet.getRow(0);
//
//		// õеĿ
//		int col_count = title_row.getPhysicalNumberOfCells();
//		// õеĿ
//		int row_count = sheet.getLastRowNum();
//		boolean isSelectType = false;// жǷҵָ
//		for (int j = 0; j < row_count + 1; j++) {
//			// صеϢ
//			XSSFRow row = sheet.getRow(j);
//			if (row == null) {
//				isSelectType = false;
//				continue;
//			}
//			// System.out.println(getStringCellValue(evaluator, row.getCell((short) 0)));
//			if (getStringCellValue(evaluator, row.getCell((short) 0)) == null
//					|| getStringCellValue(evaluator, row.getCell((short) 0)).isEmpty()) {
//				isSelectType = false;
//			} else if (isSelectType || type.compareTo(getStringCellValue(evaluator, row.getCell((short) 0))) == 0) {
//				isSelectType = true;
//				if (row.getCell((short) 2) != null) {
//					String value = getStringCellValue(evaluator, row.getCell((short) 1));
//					lines_msg.add(value);
//				}
//			} else {
//				continue;
//			}
//
//		}
//		// insertRow(sheet,4,1);
//		return lines_msg;
//	}
//	
//	/**
//	 * ȡEXCEL
//	 * 
//	 * @param File excel_file
//	 * @return List<List<String>> صϢ
//	 * @throws IOException
//	 * @throws FileNotFoundException
//	 */
//	public static DefaultMutableTreeNode readExcelNodeByEntrustment(File excel_file, String type)
//			throws FileNotFoundException, IOException {
//		DefaultMutableTreeNode node = new DefaultMutableTreeNode("Ӧ");
//		if (excel_file == null || !excel_file.exists()) {
//			return node;
//		}
//		// صееϢ
//		//List<String> lines_msg = new ArrayList<String>();
//		XSSFWorkbook workBook = new XSSFWorkbook(new FileInputStream(excel_file));
//		XSSFFormulaEvaluator evaluator = new XSSFFormulaEvaluator(workBook);
//		XSSFSheet sheet = workBook.getSheetAt(0);
//		XSSFRow title_row = sheet.getRow(0);
//
//		// õеĿ
//		int col_count = title_row.getPhysicalNumberOfCells();
//		// õеĿ
//		int row_count = sheet.getLastRowNum();
//		boolean isSelectType = false;// жǷҵָ
//		String no1 = "";
//		String no2 = "";
//		DefaultMutableTreeNode no1Node = null;
//		DefaultMutableTreeNode no2Node = null;
//		for (int j = 0; j < row_count + 1; j++) {
//			
//			// صеϢ
//			XSSFRow row = sheet.getRow(j);
//			String sss=getStringCellValue(evaluator, row.getCell((short) 0));
//			if (row == null) {
//				isSelectType = false;
//				continue;
//			}
//			// System.out.println(getStringCellValue(evaluator, row.getCell((short) 0)));
//			if (getStringCellValue(evaluator, row.getCell((short) 0)) == null
//					|| getStringCellValue(evaluator, row.getCell((short) 0)).isEmpty()) {
//				isSelectType = false;
//			} else if (isSelectType || type.compareTo(sss) == 0) {
//				isSelectType = true;
//				if (row.getCell((short) 3) != null) {
//					String value1 = getStringCellValue(evaluator, row.getCell((short) 1));
//					String value2 = getStringCellValue(evaluator, row.getCell((short) 2));
//					//String value = getStringCellValue(evaluator, row.getCell((short) 3));
//					String value4 = getStringCellValue(evaluator, row.getCell((short) 3));
//					if(!value1.isEmpty() && value1.compareTo(no1) != 0)
//					{
//						no1Node = new DefaultMutableTreeNode(value1);
//						node.add(no1Node);
//						no2Node = new DefaultMutableTreeNode(value2);
//						no1Node.add(no2Node);
//					}
//					else if(!value2.isEmpty() && value2.compareTo(no2) != 0) {
//						no2Node = new DefaultMutableTreeNode(value2);
//						no1Node.add(no2Node);
//					}
//					
//					no2Node.add(new DefaultMutableTreeNode(value4));
//					
//					//lines_msg.add(value);
//				}
//			} else {
//				continue;
//			}
//
//		}
//		// insertRow(sheet,4,1);
//		return node;
//	}
//	
//	/**
//	 * ƼƻEXCEL
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeEntrustmentFormToExcel(EntrustmentFormBean controlPlanBean, File file, String outFilePath)
//			throws IOException {
//		InputStream input = new FileInputStream(file);
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		map.clear();
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			XSSFRow row = sheet.getRow(4);
//			setCellValue(row, 2, controlPlanBean.getP1());
//			setCellValue(row, 7, controlPlanBean.getItemId());
//			XSSFRow row1 = sheet.getRow(5);
//			setCellValue(row1, 2, controlPlanBean.getP3());
//			setCellValue(row1, 7, controlPlanBean.getP4());
//			XSSFRow row2 = sheet.getRow(6);
//			setCellValue(row2, 2, controlPlanBean.getP5());
//			setCellValue(row2, 7, controlPlanBean.getP6());
//			XSSFRow row3 = sheet.getRow(7);
//			setCellValue(row3, 2, controlPlanBean.getP7());
//			setCellValue(row3, 7, controlPlanBean.getP8());
//			XSSFRow row4 = sheet.getRow(8);
//			setCellValue(row4, 2, controlPlanBean.getP9());
//			setCellValue(row4, 7, controlPlanBean.getP10());
//			XSSFRow row5 = sheet.getRow(10);
//			setCellValue(row5, 2, controlPlanBean.getP11());
//			XSSFRow row6 = sheet.getRow(11);
//			setCellValue(row6, 2, controlPlanBean.getP12());
//			setCellValue(row6, 7, controlPlanBean.getP15());
//			XSSFRow row7 = sheet.getRow(12);
//			setCellValue(row7, 1, controlPlanBean.getP13());
//			setCellValue(row7, 4, controlPlanBean.getP14());
//			setCellValue(row7, 7, controlPlanBean.getP16());
//			XSSFRow row8 = sheet.getRow(14);
//			setCellValue(row8, 2, controlPlanBean.getP17());
//			setCellValue(row8, 7, controlPlanBean.getP18());
//			XSSFRow row9 = sheet.getRow(15);
//			setCellValue(row9, 2, controlPlanBean.getP19());
//			setCellValue(row9, 7, controlPlanBean.getP20());
//			XSSFRow row10 = sheet.getRow(16);
//			setCellValue(row10, 2, controlPlanBean.getP21());
//			setCellValue(row10, 7, controlPlanBean.getP22());
//			XSSFRow row11 = sheet.getRow(17);
//			setCellValue(row11, 2, controlPlanBean.getP23());
//			setCellValue(row11, 7, controlPlanBean.getP24());
//			XSSFRow row12 = sheet.getRow(18);
//			setCellValue(row12, 2, controlPlanBean.getP25());
//			XSSFRow row13 = sheet.getRow(20);
//			setCellValue(row13, 2, controlPlanBean.getP26());
//			setCellValue(row13, 7, controlPlanBean.getP27());
//			XSSFRow row14 = sheet.getRow(21);
//			setCellValue(row14, 1, controlPlanBean.getP28());
//			setCellValue(row14, 4, controlPlanBean.getP29());
//			setCellValue(row14, 7, controlPlanBean.getP30());
//			XSSFRow row15 = sheet.getRow(22);
//			setCellValue(row15, 2, controlPlanBean.getP31());
//			setCellValue(row15, 7, controlPlanBean.getP32());
//			XSSFRow row16 = sheet.getRow(24);
//			setCellValue(row16, 0, controlPlanBean.getP33());
//			XSSFRow row17 = sheet.getRow(26);
//			setCellValue(row17, 0, controlPlanBean.getP66());
//		} else {
//			return -1;
//		}
//		
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//	
//	/**
//	 * ҵտ
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeJobProcessFormVerticalToExcel(JobProcessFormBean controlPlanBean, File file,
//			String outFilePath,TCComponentTcFile picFile,String outFilePathp) throws IOException {
//		//ͼ
//		if(outFilePathp!=null) { 
//			//ExcelUtil.InsertPicture(file,6,10,outFilePath,outFilePathp);
//			//6е15еиߣ5.67cm
//			//10е17еп9.52cm
//			ExcelUtil.InsertTitlePicture(file,outFilePath,outFilePathp,new int[] {7,8,9,10,11,12,13,14,15,16},
//					new int[] {10,11,12,13,14,15,16,17},true,3.1,9.52,7,10);//ǲλ
//		}
//				
//		File file1=new File(outFilePath);
//		InputStream input = new FileInputStream(file1);
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		
//		
//		wb.removeSheetAt(wb.getActiveSheetIndex());//ˮӡ
//		map.clear();
//		int startRow = 6;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			XSSFRow titleRow = sheet.getRow(0);
//			setCellValue(titleRow, 3, controlPlanBean.getGsmc());
//			titleRow = sheet.getRow(1);
//			setCellValue(titleRow, 9, controlPlanBean.getLjdh());
//			titleRow = sheet.getRow(2);
//			setCellValue(titleRow, 9, controlPlanBean.getSbmc());
//			titleRow = sheet.getRow(3);
//			setCellValue(titleRow, 9, controlPlanBean.getSbxh());
//			//setCellValue(titleRow, 13, " ¹"+controlPlanBean.getXdgx());
//			
//			List<List<String>> toolingDetailData = controlPlanBean.getToolingDetailData();
//			List<List<String>> machiningParameterData = controlPlanBean.getMachiningParameterData();
//			List<List<String>> controlRequirementData = controlPlanBean.getControlRequirementData();
//			for (int i = 0; i < toolingDetailData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == toolingDetailData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 9) {//i0ʼi=10һ
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 0; j < 16; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 5, 6 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 7, 8 });
//				}
//
//				List<String> toolingDetailList = toolingDetailData.get(i);
//				// XSSFRow row = sheet.getRow(i + startRow);
//				XSSFCell cell1 = row.getCell(2);
//				cell1.setCellValue(toolingDetailList.get(1));
//				XSSFCell cell2 = row.getCell(3);
//				cell2.setCellValue(toolingDetailList.get(2));
//				XSSFCell cell3 = row.getCell(5);
//				cell3.setCellValue(toolingDetailList.get(3));
//				XSSFCell cell4 = row.getCell(7);
//				cell4.setCellValue(toolingDetailList.get(4));
//			}
//			startRow = 19;
//			if (toolingDetailData.size() > 11) {
//				// ֺϲԪ
//				unMerge(sheet, "A4");
//				// ϲԪ
//				int[] rows = new int[2 + toolingDetailData.size()];
//				rows[0] = 3;
//				rows[1] = 4;
//				for (int i = 0; i < toolingDetailData.size(); i++) {
//					rows[i + 2] = i + 5;
//				}
//
//				combine(sheet, rows, new int[] { 0, 1 });
//				startRow = 19 + toolingDetailData.size() - 11;
//			}
//
//			int rows = 10;
//			if (machiningParameterData.size() > 20) {
//				rows = (int) Math.ceil(machiningParameterData.size() / 2);
//				for (int i = 9; i < rows - 1; i++) {
//					XSSFRow row = null;
//					Boolean isCreat = false;
//					if (i == toolingDetailData.size() - 1) {
//						row = sheet.getRow(i + startRow);
//						isCreat = false;
//					} else if (i > 8) {
//						row = createRow(sheet, i + startRow);
//						isCreat = true;
//					} else {
//						row = sheet.getRow(i + startRow);
//						isCreat = false;
//					}
//					// XSSFRow row = sheet.getRow(i + startRow);
//					if (isCreat) {
//						XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//						for (int j = 0; j < 16; j++) {
//							XSSFCell oldCell = oldRow.getCell(j);
//							XSSFCell newCell = row.createCell(j);
//							newCell.setCellStyle(oldCell.getCellStyle());
//							newCell.setCellType(oldCell.getCellType());
//						}
//						// ϲԪ
//						combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 6, 7, 8 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 10, 11 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 13, 14, 15,16 });
//					}
//				}
//			}
//
//			if (machiningParameterData.size() > 10) {
//
//				for (int i = 0; i < rows; i++) {
//					List<String> machiningParameterList = machiningParameterData.get(i);
//					XSSFRow row = sheet.getRow(i + startRow);
//					XSSFCell cell1 = row.getCell(2);
//					cell1.setCellValue(machiningParameterList.get(1));
//					XSSFCell cell2 = row.getCell(3);
//					cell2.setCellValue(machiningParameterList.get(2));
//					XSSFCell cell3 = row.getCell(5);
//					cell3.setCellValue(machiningParameterList.get(3));
//					XSSFCell cell4 = row.getCell(6);
//					cell4.setCellValue(machiningParameterList.get(4));
//				}
//				for (int i = rows; i < machiningParameterData.size(); i++) {
//					List<String> machiningParameterList = machiningParameterData.get(i);
//					XSSFRow row = sheet.getRow(i - rows + startRow);
//					XSSFCell cell1 = row.getCell(9);
//					cell1.setCellValue(machiningParameterList.get(1));
//					XSSFCell cell2 = row.getCell(10);
//					cell2.setCellValue(machiningParameterList.get(2));
//					XSSFCell cell3 = row.getCell(12);
//					cell3.setCellValue(machiningParameterList.get(3));
//					XSSFCell cell4 = row.getCell(13);
//					cell4.setCellValue(machiningParameterList.get(4));
//				}
//			} else {
//				for (int i = 0; i < machiningParameterData.size(); i++) {
//					List<String> machiningParameterList = machiningParameterData.get(i);
//					XSSFRow row = sheet.getRow(i + startRow);
//					XSSFCell cell1 = row.getCell(2);
//					cell1.setCellValue(machiningParameterList.get(1));
//					XSSFCell cell2 = row.getCell(3);
//					cell2.setCellValue(machiningParameterList.get(2));
//					XSSFCell cell3 = row.getCell(5);
//					cell3.setCellValue(machiningParameterList.get(3));
//					XSSFCell cell4 = row.getCell(6);
//					cell4.setCellValue(machiningParameterList.get(4));
//				}
//			}
//			if (rows > 10) {
//				// ֺϲԪ
//				unMerge(sheet, "A" + startRow);
//				// ϲԪ
//				int[] rowInders = new int[1 + rows];
//				rowInders[0] = startRow - 1;
//				for (int i = 0; i < rows; i++) {
//					rowInders[i + 1] = i + startRow;
//				}
//
//				combine(sheet, rowInders, new int[] { 0, 1 });
//			}
//			if (toolingDetailData.size() > 11) {
//				startRow = 33 + toolingDetailData.size() - 11;
//			} else {
//				startRow = 33;
//			}
//			if (rows > 10) {
//				startRow = startRow + rows - 10;
//			}
//			for (int i = 0; i < controlRequirementData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == controlRequirementData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 7) {
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 0; j < 17; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 6, 7 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 10, 11 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 13, 14, 15 });
//				}
//
//				List<String> controlRequirementList = controlRequirementData.get(i);
//				// XSSFRow row = sheet.getRow(i + startRow);
//				XSSFCell cell1 = row.getCell(2);
//				cell1.setCellValue(controlRequirementList.get(1));
//				XSSFCell cell2 = row.getCell(3);
//				cell2.setCellValue(controlRequirementList.get(2));
//				XSSFCell cell3 = row.getCell(5);
//				cell3.setCellValue(controlRequirementList.get(3));
//				XSSFCell cell4 = row.getCell(6);
//				cell4.setCellValue(controlRequirementList.get(4));
//				XSSFCell cell5 = row.getCell(8);
//				cell5.setCellValue(controlRequirementList.get(5));
//				XSSFCell cell6 = row.getCell(9);
//				cell6.setCellValue(controlRequirementList.get(6));
//				XSSFCell cell7 = row.getCell(10);
//				cell7.setCellValue(controlRequirementList.get(7));
//				XSSFCell cell8 = row.getCell(12);
//				cell8.setCellValue(controlRequirementList.get(8));
//				XSSFCell cell9 = row.getCell(13);
//				cell9.setCellValue(controlRequirementList.get(9));
//				XSSFCell cel20 = row.getCell(16);
//				cel20.setCellValue(controlRequirementList.get(10));
//			}
//
//			if (controlRequirementData.size() > 9) {
//				// ֺϲԪ
//				unMerge(sheet, "A" + (startRow - 2));
//				// ϲԪ
//				int[] rowInders = new int[3 + controlRequirementData.size()];
//				rowInders[0] = startRow - 3;
//				rowInders[1] = startRow - 2;
//				rowInders[2] = startRow - 1;
//				for (int i = 0; i < controlRequirementData.size(); i++) {
//					rowInders[i + 3] = i + startRow;
//				}
//
//				combine(sheet, rowInders, new int[] { 0, 1 });
//			}
//
//		} else {
//			return -1;
//		}
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		wb.write(output);
//		output.close();
//		input.close();
//		
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * ҵտ
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeJobProcessFormAcrossToExcel(JobProcessFormBean controlPlanBean, File file,
//			String outFilePath,TCComponentTcFile picFile,String outFilePathp) throws IOException{
//		//ͼƬ
//		//ͼ
//		if(outFilePathp!=null) { 
//			//17е28еиߣ3.96cm
//			//18е24еп8.9cm
//			int i=0;
//			if(controlPlanBean.getToolingDetailData().size()>9) {
//				i=controlPlanBean.getToolingDetailData().size()-9;
//			}
//			if(controlPlanBean.getMachiningParameterData().size()-9>i) {
//				i=controlPlanBean.getMachiningParameterData().size()-9;
//			}
//			ExcelUtil.InsertTitlePicture(file,outFilePath,outFilePathp,new int[] {17,18,19,20,21,22,23,24,25,26,27,28},
//					new int[] {18,19,20,21,22,23,24},true,3.96,8.9,17+i,18);
//		}
//		
//		File file1=new File(outFilePath);
//		InputStream input = new FileInputStream(file1);
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		wb.removeSheetAt(wb.getActiveSheetIndex());
//		map.clear();
//		int startRow = 5;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			XSSFRow titleRow = sheet.getRow(0);
//			setCellValue(titleRow, 2, controlPlanBean.getGsmc());
//			setCellValue(titleRow, 17, controlPlanBean.getSbmc());
//			titleRow = sheet.getRow(1);
//			setCellValue(titleRow, 13, controlPlanBean.getLjdh());
//			setCellValue(titleRow, 17, controlPlanBean.getSbxh());
//			titleRow = sheet.getRow(2);
//			setCellValue(titleRow, 13, controlPlanBean.getBgx());
//			
//			
//			List<List<String>> toolingDetailData = controlPlanBean.getToolingDetailData();
//			List<List<String>> machiningParameterData = controlPlanBean.getMachiningParameterData();
//			List<List<String>> controlRequirementData = controlPlanBean.getControlRequirementData();
//			for (int i = 0; i < toolingDetailData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == toolingDetailData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 7) {
//					row = createRow(sheet, i + startRow);
//
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 0; j < 24; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 5, 6 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 7, 8, 9, 10 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 16, 17 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 19, 20 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 22, 23 });
//				}
//
//				List<String> toolingDetailList = toolingDetailData.get(i);
//				XSSFCell cell1 = row.getCell(2);
//				cell1.setCellValue(toolingDetailList.get(1));
//				XSSFCell cell2 = row.getCell(3);
//				cell2.setCellValue(toolingDetailList.get(2));
//				XSSFCell cell3 = row.getCell(5);
//				cell3.setCellValue(toolingDetailList.get(3));
//				XSSFCell cell4 = row.getCell(7);
//				cell4.setCellValue(toolingDetailList.get(4));
//			}
//			startRow = 4;
////			if (toolingDetailData.size() > 11) {
////				// ֺϲԪ
////				unMerge(sheet, "A4");
////				// ϲԪ
////				int[] rows = new int[2 + toolingDetailData.size()];
////				rows[0] = 3;
////				rows[1] = 4;
////				for (int i = 0; i < toolingDetailData.size(); i++) {
////					rows[i + 2] = i + 5;
////				}
////
////				combine(sheet, rows, new int[] { 0, 1 });
////				startRow = 18 + toolingDetailData.size() - 10;
////			}
//			int rows = 10;
//			if (toolingDetailData.size() > 9) {
//				rows = toolingDetailData.size() + 1;
//			}
//			if (machiningParameterData.size() > 2 * rows) {
//				rows = (int) Math.ceil(machiningParameterData.size() / 2);
//				for (int i = 10; i < rows - 1; i++) {
//					XSSFRow row = null;
//					Boolean isCreat = false;
//					if (i == toolingDetailData.size() - 1) {
//						row = sheet.getRow(i + startRow);
//						isCreat = false;
//					} else if (i > 8) {
//						row = createRow(sheet, i + startRow);
//						isCreat = true;
//					} else {
//						row = sheet.getRow(i + startRow);
//						isCreat = false;
//					}
//					// XSSFRow row = sheet.getRow(i + startRow);
//					if (isCreat) {
//						XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//						for (int j = 0; j < 24; j++) {
//							XSSFCell oldCell = oldRow.getCell(j);
//							XSSFCell newCell = row.createCell(j);
//							newCell.setCellStyle(oldCell.getCellStyle());
//							newCell.setCellType(oldCell.getCellType());
//						}
//						// ϲԪ
//						combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 5, 6 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 7, 8, 9, 10 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 16, 17 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 19, 20 });
//						combine(sheet, new int[] { i + startRow }, new int[] { 22, 23 });
//					}
//				}
//			}
//
//			if (machiningParameterData.size() > rows) {
//
//				for (int i = 0; i < rows; i++) {
//					List<String> machiningParameterList = machiningParameterData.get(i);
//					XSSFRow row = sheet.getRow(i + startRow);
//					XSSFCell cell1 = row.getCell(13);
//					cell1.setCellValue(machiningParameterList.get(1));
//					XSSFCell cell2 = row.getCell(14);
//					cell2.setCellValue(machiningParameterList.get(2));
//					XSSFCell cell3 = row.getCell(15);
//					cell3.setCellValue(machiningParameterList.get(3));
//					XSSFCell cell4 = row.getCell(16);
//					cell4.setCellValue(machiningParameterList.get(4));
//				}
//				for (int i = rows; i < machiningParameterData.size(); i++) {
//					List<String> machiningParameterList = machiningParameterData.get(i);
//					XSSFRow row = sheet.getRow(i - rows + startRow);
//					XSSFCell cell1 = row.getCell(17);
//					cell1.setCellValue(machiningParameterList.get(1));
//					XSSFCell cell2 = row.getCell(18);
//					cell2.setCellValue(machiningParameterList.get(2));
//					XSSFCell cell3 = row.getCell(20);
//					cell3.setCellValue(machiningParameterList.get(3));
//					XSSFCell cell4 = row.getCell(21);
//					cell4.setCellValue(machiningParameterList.get(4));
//				}
//			} else {
//				for (int i = 0; i < machiningParameterData.size(); i++) {
//					List<String> machiningParameterList = machiningParameterData.get(i);
//					XSSFRow row = sheet.getRow(i + startRow);
//					XSSFCell cell1 = row.getCell(13);
//					cell1.setCellValue(machiningParameterList.get(1));
//					XSSFCell cell2 = row.getCell(14);
//					cell2.setCellValue(machiningParameterList.get(2));
//					XSSFCell cell3 = row.getCell(15);
//					cell3.setCellValue(machiningParameterList.get(3));
//					XSSFCell cell4 = row.getCell(16);
//					cell4.setCellValue(machiningParameterList.get(4));
//				}
//			}
//			// startRow = 18;
//			// ϲԪ
//			if (rows > 10) {
//				// ֺϲԪ
//				unMerge(sheet, "A4");
//				// ֺϲԪ
//				unMerge(sheet, "L1");
//				// ֺϲԪ
//				unMerge(sheet, "M4");
//				// ϲԪ
//				int[] rowIndexs = new int[2 + rows - 1];
//				rowIndexs[0] = 3;
//				rowIndexs[1] = 4;
//				for (int i = 0; i < rows - 1; i++) {
//					rowIndexs[i + 2] = i + 5;
//				}
//				// ϲԪ
//				int[] rowIndexs2 = new int[startRow + rows];
////				rowIndexs2[0] = 3;
////				rowIndexs2[1] = 4;
//				for (int i = 0; i < startRow + rows; i++) {
//					rowIndexs2[i] = i;
//				}
//				// ϲԪ
//				int[] rowIndexs3 = new int[1 + rows];
//				rowIndexs3[0] = 3;
//				for (int i = 0; i < rows; i++) {
//					rowIndexs3[i + 1] = i + 4;
//				}
//
//				combine(sheet, rowIndexs, new int[] { 0, 1 });
//				combine(sheet, rowIndexs2, new int[] { 11 });
//				combine(sheet, rowIndexs3, new int[] { 12 });
//				startRow = 18 + rows - 10;
//			}
//			else
//			{
//				startRow = 18;
//			}
//			for (int i = 0; i < controlRequirementData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == controlRequirementData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 9) {
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 0; j < 24; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 6, 7 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 10, 11 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 13, 14});
//					combine(sheet, new int[] { i + startRow }, new int[] { 15, 16});
//				}
//
//				List<String> controlRequirementList = controlRequirementData.get(i);
//				XSSFCell cell1 = row.getCell(2);
//				cell1.setCellValue(controlRequirementList.get(1));
//				XSSFCell cell2 = row.getCell(3);
//				cell2.setCellValue(controlRequirementList.get(2));
//				XSSFCell cell3 = row.getCell(5);
//				cell3.setCellValue(controlRequirementList.get(3));
//				XSSFCell cell4 = row.getCell(6);
//				cell4.setCellValue(controlRequirementList.get(4));
//				XSSFCell cell5 = row.getCell(8);
//				cell5.setCellValue(controlRequirementList.get(5));
//				XSSFCell cell6 = row.getCell(9);
//				cell6.setCellValue(controlRequirementList.get(6));
//				XSSFCell cell7 = row.getCell(10);
//				cell7.setCellValue(controlRequirementList.get(7));
//				XSSFCell cell8 = row.getCell(12);
//				cell8.setCellValue(controlRequirementList.get(8));
//				XSSFCell cell9 = row.getCell(13);
//				cell9.setCellValue(controlRequirementList.get(9));
//				XSSFCell cell10 = row.getCell(15);
//				cell10.setCellValue(controlRequirementList.get(10));
//			}
//			
//			//++++++
//			// ϲԪ
//			if (controlRequirementData.size() > 11) {
//				// ֺϲԪ
//				unMerge(sheet, "A" + (startRow - 2));
//				// ϲԪ
//				int[] rowIndexs = new int[3 + controlRequirementData.size()];
//				rowIndexs[0] = startRow - 3;
//				rowIndexs[1] = startRow - 2;
//				rowIndexs[1] = startRow - 1;
//				for (int i = 0; i < controlRequirementData.size(); i++) {
//					rowIndexs[i + 3] = i + startRow;
//				}
//
//				combine(sheet, rowIndexs, new int[] { 0, 1 });
//			}
//			
//		} else {
//			return -1;
//		}
////		//ͼ
////		if(outFilePathp!=null) {
////			insertPicture(wb, sheet, new ImageIcon(outFilePathp), "ʾͼ",7,8);
////			new File(outFilePathp).delete();
////	}
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		wb.write(output);
//		output.close();
//		input.close();
//		
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * װ乤տ
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeAssembleProcessFormToExcel(JobProcessFormBean controlPlanBean, File file, String outFilePath
//			,TCComponentTcFile picFile,String outFilePathp)
//			throws IOException {
//		//ͼ
//		if(outFilePathp!=null) { 
//			//5е16еиߣ0.49*12=5.88cm
//			//1е8еп14.56cm
//			ExcelUtil.InsertTitlePicture(file,outFilePath,outFilePathp,new int[] {6,7,8,9,10,11,12,13,14,15,16,17},
//					new int[] {1,2,3,4,5,6,7,8},true,5.88,14.56,6,1);
//		}
//		File file1=new File(outFilePath);
//		InputStream input = new FileInputStream(file1);
//		
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		wb.removeSheetAt(wb.getActiveSheetIndex());
//		map.clear();
//		int startRow = 7;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			XSSFRow titleRow = sheet.getRow(0);
//			setCellValue(titleRow, 3, controlPlanBean.getGsmc());
//			titleRow = sheet.getRow(1);
//			setCellValue(titleRow, 9, controlPlanBean.getLjdh());
//			titleRow = sheet.getRow(2);
//			setCellValue(titleRow, 9, controlPlanBean.getSbmc());
//			titleRow = sheet.getRow(3);
//			setCellValue(titleRow, 9, controlPlanBean.getSbxh());
//			//setCellValue(titleRow, 13, " ¹"+controlPlanBean.getXdgx());
//			
//			List<List<String>> toolingDetailData = controlPlanBean.getToolingDetailData();
//			List<List<String>> machiningParameterData = controlPlanBean.getMachiningParameterData();
//			List<List<String>> controlRequirementData = controlPlanBean.getControlRequirementData();
//			for (int i = 0; i < toolingDetailData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == toolingDetailData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 8) {
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 8; j < 17; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 9, 10 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 11, 12 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 13, 14, 15 });
//				}
//
//				List<String> toolingDetailList = toolingDetailData.get(i);
////				XSSFRow row = sheet.getRow(i + startRow);
//				XSSFCell cell1 = row.getCell(8);
//				cell1.setCellValue(toolingDetailList.get(1));
//				XSSFCell cell2 = row.getCell(9);
//				cell2.setCellValue(toolingDetailList.get(2));
//				XSSFCell cell3 = row.getCell(11);
//				cell3.setCellValue(toolingDetailList.get(3));
//				XSSFCell cell4 = row.getCell(13);
//				cell4.setCellValue(toolingDetailList.get(4));
//				XSSFCell cell5 = row.getCell(16);
//				cell5.setCellValue(toolingDetailList.get(5));
//			}
//			startRow = 19;
//			if (toolingDetailData.size() > 10) {
//				// ֺϲԪ
//				unMerge(sheet, "A5");
//				// ϲԪ
//				int[] rows = new int[2 + toolingDetailData.size()];
//				rows[0] = 4;
//				rows[1] = 5;
//				for (int i = 0; i < toolingDetailData.size(); i++) {
//					rows[i + 2] = i + 6;
//				}
//
//				combine(sheet, rows, new int[] { 0, 1, 2, 3, 4, 5, 6, 7 });
//				startRow = 19 + toolingDetailData.size() - 10;
//			}
//			for (int i = 0; i < machiningParameterData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == machiningParameterData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 8) {
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 0; j < 17; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 0, 1 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 2, 3, 4, 5, 6, 7 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 8, 9, 10 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 11, 12, 13 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 14, 15, 16 });
//				}
//
//				List<String> machiningParameterList = machiningParameterData.get(i);
//				XSSFCell cell1 = row.getCell(0);
//				cell1.setCellValue(machiningParameterList.get(1));
//				XSSFCell cell2 = row.getCell(2);
//				cell2.setCellValue(machiningParameterList.get(2));
//				XSSFCell cell3 = row.getCell(8);
//				cell3.setCellValue(machiningParameterList.get(3));
//				XSSFCell cell4 = row.getCell(11);
//				cell4.setCellValue(machiningParameterList.get(4));
//				XSSFCell cell5 = row.getCell(14);
//				cell5.setCellValue(machiningParameterList.get(5));
//			}
//			startRow = 33;
//			if (toolingDetailData.size() > 10) {
//				startRow = 33 + toolingDetailData.size() - 10;
//			}
//			if (machiningParameterData.size() > 10) {
//				startRow = startRow + machiningParameterData.size() - 10;
//			}
//			for (int i = 0; i < controlRequirementData.size(); i++) {
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == controlRequirementData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if (i > 7) {
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 2; j < 17; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 6, 7 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 10, 11 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 13, 14, 15, 16 });
//				}
//
//				List<String> controlRequirementList = controlRequirementData.get(i);
//				XSSFCell cell1 = row.getCell(2);
//				cell1.setCellValue(controlRequirementList.get(1));
//				XSSFCell cell2 = row.getCell(3);
//				cell2.setCellValue(controlRequirementList.get(2));
//				XSSFCell cell3 = row.getCell(5);
//				cell3.setCellValue(controlRequirementList.get(3));
//				XSSFCell cell4 = row.getCell(6);
//				cell4.setCellValue(controlRequirementList.get(4));
//				XSSFCell cell5 = row.getCell(8);
//				cell5.setCellValue(controlRequirementList.get(5));
//				XSSFCell cell6 = row.getCell(9);
//				cell6.setCellValue(controlRequirementList.get(6));
//				XSSFCell cell7 = row.getCell(10);
//				cell7.setCellValue(controlRequirementList.get(7));
//				XSSFCell cell8 = row.getCell(12);
//				cell8.setCellValue(controlRequirementList.get(8));
//				XSSFCell cell9 = row.getCell(13);
//				cell9.setCellValue(controlRequirementList.get(9));
//			}
//
//			if (controlRequirementData.size() > 9) {
//				// ֺϲԪ
//				unMerge(sheet, "A" + startRow);
//				// ϲԪ
//				int[] rows = new int[3 + controlRequirementData.size()];
//				rows[0] = startRow - 3;
//				rows[1] = startRow - 2;
//				rows[2] = startRow - 1;
//				for (int i = 0; i < controlRequirementData.size(); i++) {
//					rows[i + 3] = i + startRow;
//				}
//
//				combine(sheet, rows, new int[] { 0, 1 });
//			}
//
//		} else {
//			return -1;
//		}
//		
////		//ͼ
////		if(outFilePathp!=null) {
////			insertPicture(wb, sheet, new ImageIcon(outFilePathp), "ʾͼ",8,8);
////			new File(outFilePathp).delete();
////	}
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * ׼
//	 * 
//	 * @param controlPlanBean ƼƻϢ
//	 * @param input           ģļ
//	 * @param outputFilePath  Ҫȫ·
//	 * @throws IOException
//	 */
//	public static int writeOperationReferenceBookToExcel(JobProcessFormBean controlPlanBean, File file,
//			String outFilePath,TCComponentTcFile picFile,String outFilePathp) throws IOException {
//		//ͼ
//		if(outFilePathp!=null) { 
//			//5е11еиߣ6.3cm
//			//7е14еп15.31cm
//			ExcelUtil.InsertTitlePicture(file,outFilePath,outFilePathp,new int[] {5,6,7,8,9,10,11},
//					new int[] {7,8,9,10,11,12,13,14},true,6.3,15.31,5,7);
//		}
//		File file1=new File(outFilePath);
//		InputStream input = new FileInputStream(file1);
//		
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		wb.removeSheetAt(wb.getActiveSheetIndex());
//		map.clear();
//		int startRow = 14;
//		if (controlPlanBean != null) {
//			// ӵϢexcel
//			XSSFRow titleRow = sheet.getRow(0);
//			setCellValue(titleRow, 3, controlPlanBean.getGsmc());
//			titleRow = sheet.getRow(1);
//			setCellValue(titleRow, 10, controlPlanBean.getSbxh());
//			titleRow = sheet.getRow(2);
//			setCellValue(titleRow, 10, controlPlanBean.getLjdh());
//
//			List<List<String>> controlRequirementData = controlPlanBean.getControlRequirementData();
//			for (int i = 0; i < controlRequirementData.size(); i++) {
//				List<String> controlRequirementList = controlRequirementData.get(i);
//
//				XSSFRow row = null;
//				Boolean isCreat = false;
//				if (i == controlRequirementData.size() - 1) {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				} else if ((i + startRow) > sheet.getLastRowNum() - 2) {
//					row = createRow(sheet, i + startRow);
//					isCreat = true;
//				} else {
//					row = sheet.getRow(i + startRow);
//					isCreat = false;
//				}
//				// XSSFRow row = sheet.getRow(i + startRow);
//				if (isCreat) {
//					XSSFRow oldRow = sheet.getRow(i + startRow - 1);
//					for (int j = 0; j < 14; j++) {
//						XSSFCell oldCell = oldRow.getCell(j);
//						XSSFCell newCell = row.createCell(j);
//						newCell.setCellStyle(oldCell.getCellStyle());
//						newCell.setCellType(oldCell.getCellType());
//					}
//					// ϲԪ
//					combine(sheet, new int[] { i + startRow }, new int[] { 0, 1 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 3, 4 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 6, 7 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 8, 9 });
//					combine(sheet, new int[] { i + startRow }, new int[] { 12, 13 });
//				}
//
//				XSSFCell cell1 = row.getCell(0);
//				cell1.setCellValue(controlRequirementList.get(1));
//				XSSFCell cell2 = row.getCell(2);
//				cell2.setCellValue(controlRequirementList.get(2));
//				XSSFCell cell3 = row.getCell(3);
//				cell3.setCellValue(controlRequirementList.get(3));
//				XSSFCell cell4 = row.getCell(5);
//				cell4.setCellValue(controlRequirementList.get(4));
//				XSSFCell cell5 = row.getCell(6);
//				cell5.setCellValue(controlRequirementList.get(5));
//				XSSFCell cell6 = row.getCell(8);
//				cell6.setCellValue(controlRequirementList.get(6));
//				XSSFCell cell7 = row.getCell(10);
//				cell7.setCellValue(controlRequirementList.get(7));
//				XSSFCell cell8 = row.getCell(11);
//				cell8.setCellValue(controlRequirementList.get(8));
//				XSSFCell cell9 = row.getCell(12);
//				cell9.setCellValue(controlRequirementList.get(9));
//			}
//
//		} else {
//			return -1;
//		}
//
////		//ͼ
////		if(outFilePathp!=null) {
////			insertPicture(wb, sheet, new ImageIcon(outFilePathp), "ʾͼ",8,7);
////			new File(outFilePathp).delete();
////	}
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		wb.write(output);
//		output.close();
//		input.close();
//		System.out.println("-------WRITE EXCEL OVER-------");
//
//		return 0;
//	}
//
//	/**
//	 * ҵҪ½һPOIrow
//	 * 
//	 * @param sheet
//	 * @param rowIndex
//	 * @return
//	 */
//	private static XSSFRow createRow(XSSFSheet sheet, Integer rowIndex) {
//		XSSFRow row = null;
//		if (sheet.getRow(rowIndex) != null) {
//			int lastRowNo = sheet.getLastRowNum();
//			sheet.shiftRows(rowIndex, lastRowNo, 1);
//		}
//		row = sheet.createRow(rowIndex);
//		return row;
//	}
//
//	private static void unMerge(XSSFSheet sheet, String cellName) {
//		// ӵC1ʼֵԪ
//		CellReference ref = new CellReference(cellName);
//		// sheetееĺϲ
//		for (int i = sheet.getNumMergedRegions() - 1; i >= 0; i--) {
//			String value = "";
//			CellRangeAddress region = sheet.getMergedRegion(i);
//			Row firstRow = sheet.getRow(region.getFirstRow());
//			Cell firstCellOfFirstRow = firstRow.getCell(region.getFirstColumn());
//			// һԪַ
//			if (firstCellOfFirstRow.getCellType() == Cell.CELL_TYPE_STRING) {
//				value = firstCellOfFirstRow.getStringCellValue();
//			}
//			// жϵC1ŽвֵԪ
//			if (region.getFirstRow() == ref.getRow() && region.getFirstColumn() == ref.getCol()) {
//				sheet.removeMergedRegion(i);
//			}
//			// õһеֵΪֺÿһеֵ
//			for (Row row : sheet) {
//				for (Cell cell : row) {
//					if (region.isInRange(cell.getRowIndex(), cell.getColumnIndex())) {
//						cell.setCellType(Cell.CELL_TYPE_STRING);
//						cell.setCellValue(value);
//					}
//				}
//			}
//		}
//	}
//	
///**
// * װ
// * @throws IOException 
// * 
// * 
// */
//	public static int writePackagingSchemeToExcel(List<String> mainValueData,List<List<String>> TableDatas
//			,File file,String outFilePath) throws IOException {
//		InputStream input = new FileInputStream(file);
//		FileOutputStream output = new FileOutputStream(new File(outFilePath)); //
//		XSSFWorkbook wb = new XSSFWorkbook(input);// (
//		XSSFSheet sheet = wb.getSheetAt(0);
//		map.clear();
//		if(mainValueData!=null||TableDatas!=null){
//			//
//			XSSFRow titleRow = sheet.getRow(2);
//			setCellValue(titleRow, 2, mainValueData.get(0));
//			titleRow = sheet.getRow(3);
//			setCellValue(titleRow, 2, mainValueData.get(1));
//			titleRow = sheet.getRow(4);
//			setCellValue(titleRow, 2, mainValueData.get(2));
//			titleRow = sheet.getRow(5);
//			setCellValue(titleRow, 2, mainValueData.get(3));
//			titleRow = sheet.getRow(6);
//			setCellValue(titleRow, 2, mainValueData.get(4));
//			titleRow = sheet.getRow(7);
//			setCellValue(titleRow, 2, mainValueData.get(5));
//			titleRow = sheet.getRow(8);
//			setCellValue(titleRow, 2, mainValueData.get(6));
//			titleRow = sheet.getRow(9);
//			setCellValue(titleRow, 2, mainValueData.get(7));
//			titleRow = sheet.getRow(24);
//			setCellValue(titleRow, 2, mainValueData.get(8));
//			titleRow = sheet.getRow(25);
//			setCellValue(titleRow, 2, mainValueData.get(9));
//			
//			//ӡ
//			for(int i=0;i<TableDatas.size();i++) {
//				List<String> lineList=TableDatas.get(i);
//				titleRow=sheet.getRow(12+i);
//				setCellValue(titleRow, 2, lineList.get(2));
//				setCellValue(titleRow, 3, lineList.get(3));
//				setCellValue(titleRow, 4, lineList.get(4));
//			}
//		}
//		
//		wb.write(output);
//		output.close();
//		input.close();
//		return 0;
//	}
	
}
