package com.connor.zf.plm001;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

import com.connor.zf.plm001.TMom005CreateOPByModuleOperation;
//import com.connor.renben.process.plm.tmom005.TMom005CreateOPByModuleOperation;
//import com.connor.renben.process.plm.tmom006.TMom006CreateProcessByProcessOperation;
//import com.connor.renben.process.plm.tmom007.TMom007ResourcesAssignedOperation;
import com.teamcenter.rac.aif.AbstractAIFUIApplication;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.classification.common.G4MInClassDialog;
import com.teamcenter.rac.classification.common.table.G4MTable;
import com.teamcenter.rac.classification.common.table.G4MTableModel;
import com.teamcenter.rac.classification.common.tree.G4MTree;
import com.teamcenter.rac.commands.paste.PasteCommand;
import com.teamcenter.rac.kernel.TCClassificationService;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.kernel.ics.ICSHierarchyNodeDescriptor;
import com.teamcenter.rac.util.ButtonLayout;
import com.teamcenter.rac.util.HorizontalLayout;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.Registry;
import com.teamcenter.rac.util.SplitPane;
import com.teamcenter.rac.util.Utilities;
import com.teamcenter.rac.util.VerticalLayout;

//import org.apache.log4j.Logger;

public class DDInClassDialog extends G4MInClassDialog {
	private Registry m_reg;
	private TCSession m_session;
	protected InterfaceAIFComponent targets;
	private ArrayList<TCComponent> listComps;
	private TCClassificationService m_ics;
	private JButton addButton;
	private JButton removeButton;
	private ArrayList<TCComponent> objectsToBePasted = new ArrayList();
	private ArrayList<String> childrenList = new ArrayList();
	private DefaultListModel selectedDictionaryListModel;
	private JList selectedDictionaryList;
	private TCPreferenceService m_filterPrefService;
	private String[] m_filterValues;
	private static final long serialVersionUID = 1L;
	private String commandId;

	// private static final Logger logger =
	// Logger.getLogger(DDInClassDialog.class);

	public DDInClassDialog(
			AbstractAIFUIApplication paramAbstractAIFUIApplication,
			InterfaceAIFComponent paramTCComponentBOMLine, int paramInt) {
		super(paramAbstractAIFUIApplication, paramInt);
		this.m_reg = Registry.getRegistry(DDInClassDialog.class);
		this.targets = paramTCComponentBOMLine;
		this.m_session = ((TCSession) paramAbstractAIFUIApplication
				.getSession());
		this.m_ics = this.m_session.getClassificationService();
		buildInitialization();
	}

	public DDInClassDialog(
			AbstractAIFUIApplication paramAbstractAIFUIApplication,
			InterfaceAIFComponent paramTCComponentBOMLine, int paramInt,
			String commandId) {
		super(paramAbstractAIFUIApplication, paramInt);
		this.m_reg = Registry.getRegistry(DDInClassDialog.class);
		this.targets = paramTCComponentBOMLine;
		this.m_session = ((TCSession) paramAbstractAIFUIApplication
				.getSession());
		this.m_ics = this.m_session.getClassificationService();
		this.commandId = commandId;
		buildInitialization();
	}

	public DDInClassDialog(
			AbstractAIFUIApplication paramAbstractAIFUIApplication,
			int paramInt, boolean paramBoolean) {
		super(paramAbstractAIFUIApplication, paramInt, paramBoolean);
	}

	public DDInClassDialog(
			AbstractAIFUIApplication paramAbstractAIFUIApplication, int paramInt) {
		super(paramAbstractAIFUIApplication, paramInt);
	}

	public DDInClassDialog(
			AbstractAIFUIApplication paramAbstractAIFUIApplication) {
		super(paramAbstractAIFUIApplication);
	}

	private void buildInitialization() {
		setTitle(this.m_reg.getString("DDInClassDialog.TITLE"));
		super.setTitleText(this.m_reg.getString("DDInClassDialog.TITLE"));
		JPanel localJPanel1 = new JPanel(new BorderLayout());
		JPanel localJPanel2 = tableListPanel();
		SplitPane localSplitPane = new SplitPane(1);
		localSplitPane.setTopComponent(localJPanel2);
		localSplitPane.setDividerLocation(0.95D);
		JPanel localJPanel3 = createButtonPanel();
		localJPanel1.add("Center", localSplitPane);
		localJPanel1.add("South", localJPanel3);
		setContentPane(localJPanel1);
	}

	protected void initializeDialogBasedOnCookie() {
		setPersistentDisplayCookieFileName(G4MInClassDialog.COOKIE_FILENAME);
		setPersistentDisplay(true);
		setLocation(100, 100);
		pack();
		setSize(700, 400);
		readDisplayParameters();
	}

	private JPanel tableListPanel() {
		JPanel localJPanel1 = new JPanel(new HorizontalLayout(10, 10, 10, 10,
				10));
		JPanel localJPanel2 = treeTablePanel();
		JPanel localJPanel3 = buildAddandRemoveButtonPanel();
		JPanel localJPanel4 = new JPanel(new BorderLayout());
		localJPanel4.add(localJPanel2, "Center");
		localJPanel1.add("unbound.bind", localJPanel4);
		localJPanel1.add("right.bind.center.center", localJPanel3);
		JPanel localJPanel5 = buildSelectedDictionaryPanel(this.m_session,
				this.m_reg);
		SplitPane localSplitPane = new SplitPane(0);
		localSplitPane.setLeftComponent(localJPanel1);
		localSplitPane.setRightComponent(new JScrollPane(localJPanel5));
		localSplitPane.setDividerLocation(0.85D);
		JPanel localJPanel6 = new JPanel(new BorderLayout());
		localJPanel6.add(localSplitPane, "Center");
		return localJPanel6;
	}

	protected JPanel buildAddandRemoveButtonPanel() {
		JPanel localJPanel = new JPanel();
		localJPanel.setLayout(new ButtonLayout(2));
		this.addButton = new JButton(
				this.m_reg.getImageIcon("quickAddButton.ICON"));
		this.listComps = new ArrayList();
		this.addButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent paramAnonymousActionEvent) {
				DDInClassDialog.this.addSelectedNodeAction();
			}
		});
		this.listComps.clear();
		localJPanel.add(this.addButton);
		this.removeButton = new JButton(this.m_reg.getImageIcon("minus.ICON"));
		this.removeButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent paramAnonymousActionEvent) {
				DDInClassDialog.this.removeSelectedNodeAction();
			}
		});
		localJPanel.add(this.removeButton);
		return localJPanel;
	}

	protected JPanel createButtonPanel() {
		JPanel localJPanel = new JPanel();
		JButton localJButton = new JButton(this.m_reg.getString("cancel.NAME"));
		this.m_okButton = new JButton(this.m_reg.getString("oK.NAME"));
		this.m_okButton.addActionListener(this);
		if (this.selectedDictionaryListModel.getSize() > 0) {
			this.m_okButton.setEnabled(true);
		}
		localJButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent paramAnonymousActionEvent) {
				DDInClassDialog.this.closeDialogs();
			}
		});
		localJPanel.add(this.m_okButton);
		localJPanel.add(localJButton);
		return localJPanel;
	}

	private JPanel treeTablePanel() {
		setLayout(new BorderLayout());
		JTabbedPane localJTabbedPane = createMainTabbedPane();
		this.m_filterPrefService = this.m_session.getPreferenceService();
		this.m_filterValues = this.m_filterPrefService
				.getStringValues("ICS_FilterBy_Library_types");
		if (this.m_filterValues == null) {
			this.m_filterValues = new String[0];
		}
		String[] arrayOfString = getAssoicateToProjectClassID();
		if ((arrayOfString != null) && (arrayOfString.length > 0)) {
			this.m_tree = new G4MTree(this.m_context, true,
					this.m_filterValues, "Library");
			this.m_tree.addG4MTreeListener(this);
			this.m_tree.setReducedClassList(arrayOfString);
			this.m_tree.refresh("ICM", true, false);
		} else {
			this.m_tree = new G4MTree(this.m_context, true,
					this.m_filterValues, "Library");
			this.m_tree.addG4MTreeListener(this);
		}
		SplitPane localSplitPane = new SplitPane(0);
		localSplitPane.setDividerSize(2);
		localSplitPane.setDividerLocation(0.4D);
		localSplitPane.setLeftComponent(this.m_tree);
		localSplitPane.getLeftComponent().validate();
		localSplitPane.setRightComponent(localJTabbedPane);
		localSplitPane.getRightComponent().validate();
		JPanel localJPanel = new JPanel(new BorderLayout());
		localJPanel.add(localSplitPane, "Center");
		return localJPanel;
	}

	private String[] getAssoicateToProjectClassID() {
		String[] arrayOfString1 = null;
		ArrayList localArrayList1 = new ArrayList();
		TCComponent[] arrayOfTCComponent1 = null;
		try {
			TCComponentItem localTCComponentItem = ((TCComponentItemRevision) this.targets)
					.getItem();
			arrayOfTCComponent1 = localTCComponentItem
					.getReferenceListProperty("project_list");
			TCClassificationService localTCClassificationService = this.m_session
					.getClassificationService();
			int i;
			if ((arrayOfTCComponent1 != null)
					&& (arrayOfTCComponent1.length > 0)) {
				for (i = 0; i < arrayOfTCComponent1.length; i++) {
					TCComponent[] arrayOfTCComponent2 = arrayOfTCComponent1[i]
							.getRelatedComponents("Fnd0LibraryForProject");
					if (arrayOfTCComponent2.length > 0) {
						for (int j = 0; j < arrayOfTCComponent2.length; j++) {
							ICSHierarchyNodeDescriptor localICSHierarchyNodeDescriptor = localTCClassificationService
									.describeNode(arrayOfTCComponent2[j]
											.getProperty("cid"), 0);
							ICSHierarchyNodeDescriptor[] arrayOfICSHierarchyNodeDescriptor = this.m_context
									.getChildren(
											localICSHierarchyNodeDescriptor
													.getId(),
											localICSHierarchyNodeDescriptor
													.getClassChildrenCount());
							String[] arrayOfString2 = this.m_context
									.getParents(arrayOfTCComponent2[j]
											.getProperty("cid"));
							if (arrayOfString2.length > 0) {
								for (int k = 0; k < arrayOfString2.length; k++) {
									localArrayList1.add(arrayOfString2[k]);
								}
								if (arrayOfICSHierarchyNodeDescriptor != null) {
									ArrayList localArrayList2 = new ArrayList();
									localArrayList2 = getAssociateChildrensClassID(localICSHierarchyNodeDescriptor);
									for (int m = 0; m < localArrayList2.size(); m++) {
										localArrayList1.add(localArrayList2
												.get(m));
									}
								}
								localArrayList1.add(arrayOfTCComponent2[j]
										.getProperty("cid"));
							}
						}
					}
				}
			}
			if (localArrayList1 != null) {
				arrayOfString1 = new String[localArrayList1.size()];
				for (i = 0; i < localArrayList1.size(); i++) {
					arrayOfString1[i] = ((String) localArrayList1.get(i));
				}
			}
		} catch (Exception localException) {
		}
		return arrayOfString1;
	}

	private ArrayList getAssociateChildrensClassID(
			ICSHierarchyNodeDescriptor paramICSHierarchyNodeDescriptor) {
		ICSHierarchyNodeDescriptor[] arrayOfICSHierarchyNodeDescriptor = this.m_context
				.getChildren(paramICSHierarchyNodeDescriptor.getId(),
						paramICSHierarchyNodeDescriptor.getClassChildrenCount());
		if (arrayOfICSHierarchyNodeDescriptor != null) {
			for (int i = 0; i < arrayOfICSHierarchyNodeDescriptor.length; i++) {
				getAssociateChildrensClassID(arrayOfICSHierarchyNodeDescriptor[i]);
				this.childrenList.add(arrayOfICSHierarchyNodeDescriptor[i]
						.getId());
			}
		}
		return this.childrenList;
	}

	private void performOKAction() {
		this.selectedDictionaryListModel = ((DefaultListModel) this.selectedDictionaryList
				.getModel());
		if (this.selectedDictionaryListModel.getSize() > 0) {
			Object[] arrayOfObject = this.selectedDictionaryListModel.toArray();
			int i = arrayOfObject.length;
			for (int j = 0; j < i; j++) {
				TCComponent localTCComponent = (TCComponent) this.selectedDictionaryListModel
						.get(j);
				this.objectsToBePasted.add(localTCComponent);
			}
		}
		try {
			if (this.objectsToBePasted.size() > 0) {
				callPasteObjects(this.objectsToBePasted);
			}
			this.listComps.clear();
			disposeDialog();
		} catch (Exception localException) {
			// logger.error(localException.getClass().getName(),
			// localException);
		}
	}

	private void callPasteObjects(ArrayList paramArrayList) throws Exception {
		InterfaceAIFComponent[] arrayOfInterfaceAIFComponent = { this.targets };
		TCComponent[] arrayOfTCComponent = null;
		PasteCommand localPasteCommand = null;
		arrayOfTCComponent = new TCComponent[paramArrayList.size()];
		arrayOfTCComponent = (TCComponent[]) paramArrayList
				.toArray(arrayOfTCComponent);
		localPasteCommand = new PasteCommand(arrayOfTCComponent,
				arrayOfInterfaceAIFComponent, Boolean.TRUE);
		localPasteCommand.setFailBackFlag(true);
		localPasteCommand.executeModal();
	}

	public void actionPerformed(ActionEvent paramActionEvent) {
		if (paramActionEvent.getSource() == this.m_clearButton.getButton()) {
			this.m_OIDtextField.setText("");
			this.m_compTextField.setText("");
		} else if (paramActionEvent.getSource() == this.m_okButton) {
			// String s = this.m_OIDtextField.getText();
			// String s1 = this.m_compTextField.getText();
			// MessageBox.post("ȷť", "", 1);
			// performOKAction();
			System.out.println("ǰcommandIdΪ" + commandId);
			this.selectedDictionaryListModel = ((DefaultListModel) this.selectedDictionaryList
					.getModel());
			if (this.selectedDictionaryListModel.getSize() > 0) {
				Object[] arrayOfObject = this.selectedDictionaryListModel.toArray();
				TMom005CreateOPByModuleOperation createOPOperation = new TMom005CreateOPByModuleOperation(
						this.m_session, this.targets,
						arrayOfObject);
						this.m_session.queueOperation(createOPOperation);
			}	
			
//			TMom005CreateOPByModuleOperation createOPOperation = new TMom005CreateOPByModuleOperation(
//			this.m_session, this.targets,
//			this.m_compTextField.getText());
//			this.m_session.queueOperation(createOPOperation);
			switch (commandId) {
			case "com.connor.renben.process.plm.commands.CreateOPByModule":
//				TMom005CreateOPByModuleOperation createOPOperation = new TMom005CreateOPByModuleOperation(
//						this.m_session, this.targets,
//						this.m_compTextField.getText());
//				this.m_session.queueOperation(createOPOperation);
				break;
			case "com.connor.renben.process.plm.commands.CreateProcessByModule":
//				TMom006CreateProcessByProcessOperation createProcessOperation = new TMom006CreateProcessByProcessOperation(
//						targets, this.m_compTextField.getText(), this.m_session);
//				this.m_session.queueOperation(createProcessOperation);
				break;
			case "com.connor.renben.process.plm.commands.ResourcesAssigned":
//				TMom007ResourcesAssignedOperation resourcesAssignedOperation = new TMom007ResourcesAssignedOperation(
//						targets, this.m_compTextField.getText(), this.m_session);
//				this.m_session.queueOperation(resourcesAssignedOperation);
				break;

			default:
				break;
			}
		} else if (paramActionEvent.getSource() == this.m_searchButton) {
			performAttributeSearch();
		} else {
			performObjectIDSearch();
		}
	}

	private void addSelectedNodeAction() {
		int i = 1;
		ArrayList localArrayList = new ArrayList();
		DefaultListModel localDefaultListModel = (DefaultListModel) this.selectedDictionaryList
				.getModel();
		int j = this.m_tabbedPane.getSelectedIndex();
		TCComponent localTCComponent = null;
		Object localObject1;
		Object localObject2;
		Object localObject3;
		if (j == 1) {
			localObject1 = this.m_context.getICSApplicationObject()
					.getClassifiedObjectUid();
			try {
				localTCComponent = this.m_ics
						.getTCComponent((String) localObject1);
				if (!this.listComps.contains(localTCComponent)) {
					localDefaultListModel.addElement(localTCComponent);
					this.listComps.add(localTCComponent);
					this.selectedDictionaryList.setModel(localDefaultListModel);
				} else {
					localArrayList.add(localTCComponent);
					i = 0;
				}
			} catch (TCException localTCException1) {
				// logger.error(localTCException1.getClass().getName(),
				// localTCException1);
			}
		} else if (j == 2) {
			localObject1 = this.m_tablePane.getG4MTable();
			if (localObject1 != null) {
				G4MTableModel localG4MTableModel = ((G4MTable) localObject1)
						.getG4MTableModel();
				localObject2 = null;
				localObject3 = ((G4MTable) localObject1).getSelectedRows();
				if (((int[]) localObject3).length == 0) {
					return;
				}
				for (int m = 0; m < ((int[]) localObject3).length; m++) {
					String str2 = localG4MTableModel.getValueAt(
							((int[]) localObject3)[m],
							localG4MTableModel.getWSOColumnNo()).toString();
					if ((str2 != null) && (str2.length() > 0)) {
						try {
							localObject2 = this.m_ics.getTCComponent(str2);
							if (!this.listComps.contains(localObject2)) {
								localDefaultListModel.addElement(localObject2);
								this.listComps.add((TCComponent) localObject2);
								this.selectedDictionaryList
										.setModel(localDefaultListModel);
							} else {
								localArrayList.add(localObject2);
								i = 0;
							}
						} catch (TCException localTCException2) {
							// logger.error(localTCException2.getClass().getName(),
							// localTCException2);
						}
					} else {
						MessageBox
								.post(Utilities.getCurrentFrame(),
										this.m_reg
												.getString("invalidSelectedObject.MESSAGE"),
										this.m_reg
												.getString("absOccIllegalSelection.TITLE"),
										1);
					}
					if (this.m_tree != null) {
						this.m_tree.getTree().getSelectionModel()
								.clearSelection();
					}
				}
			}
		}
		if (i == 0) {
			localObject1 = new StringBuffer();
			if (localArrayList.size() > 0) {
				for (int k = 0; k < localArrayList.size(); k++) {
					if (((StringBuffer) localObject1).length() > 0) {
						((StringBuffer) localObject1).append(",");
					}
					((StringBuffer) localObject1).append(localArrayList.get(k));
				}
			}
			if (((StringBuffer) localObject1).length() > 0) {
				Registry localRegistry = Registry.getRegistry(this);
				localObject2 = localRegistry
						.getString("duplicateAdded.MESSAGE");
				localObject3 = ((String) localObject2).substring(0,
						((String) localObject2).indexOf("%1"));
				String str1 = ((String) localObject2)
						.substring(((String) localObject2).indexOf("%1") + 2);
				MessageBox.post(
						Utilities.getCurrentFrame(),
						localObject3 + "["
								+ ((StringBuffer) localObject1).toString()
								+ "]" + str1,
						localRegistry.getString("duplicateAdded.TITLE"), 1);
			}
		}
	}

	private void removeSelectedNodeAction() {
		List localList = this.selectedDictionaryList.getSelectedValuesList();
		if ((localList != null) && (localList.size() > 0)) {
			for (int i = 0; i < localList.size(); i++) {
				this.selectedDictionaryListModel
						.removeElement(localList.get(i));
				this.listComps.remove(localList.get(i));
			}
		}
		if (this.selectedDictionaryList.getSelectedValue() != null) {
			this.selectedDictionaryListModel
					.removeElement(this.selectedDictionaryList
							.getSelectedValue());
			this.listComps.remove(this.selectedDictionaryList
					.getSelectedValue());
		}
	}

	protected JPanel buildSelectedDictionaryPanel(TCSession paramTCSession,
			Registry paramRegistry) {
		this.selectedDictionaryListModel = new DefaultListModel();
		this.selectedDictionaryList = new JList(
				this.selectedDictionaryListModel);
		this.selectedDictionaryList.setSelectionMode(2);
		JScrollPane localJScrollPane = new JScrollPane(
				this.selectedDictionaryList, 20, 30);
		JPanel localJPanel1 = new JPanel(new VerticalLayout(3, 3, 3, 3, 3));
		localJPanel1.add("unbound", localJScrollPane);
		JPanel localJPanel2 = new JPanel(new BorderLayout());
		localJPanel2.add(localJPanel1, "Center");
		JPanel localJPanel3 = new JPanel(new HorizontalLayout(3, 3, 3, 3, 3));
		localJPanel3.add("unbound.bind", localJPanel2);
		return localJPanel3;
	}

	public ArrayList<TCComponent> getObjectsToBePasted() {
		if ((this.objectsToBePasted == null)
				|| (this.objectsToBePasted.size() == 0)) {
			this.selectedDictionaryListModel = ((DefaultListModel) this.selectedDictionaryList
					.getModel());
			if (this.selectedDictionaryListModel.getSize() > 0) {
				Object[] arrayOfObject = this.selectedDictionaryListModel
						.toArray();
				int i = arrayOfObject.length;
				for (int j = 0; j < i; j++) {
					TCComponent localTCComponent = (TCComponent) this.selectedDictionaryListModel
							.get(j);
					this.objectsToBePasted.add(localTCComponent);
				}
			}
		}
		return this.objectsToBePasted;
	}
}
